////////////////////////////////////////////////////////////////////////////////
// Do not modify!
// Generated by embed
////////////////////////////////////////////////////////////////////////////////

package generate

var embedded = map[string]string{
	cpp_tmpl_file:  cpp_tmpl,
	go_tmpl_file:   go_tmpl,
	java_tmpl_file: java_tmpl,
}

const cpp_tmpl_file = `cpp.tmpl`
const cpp_tmpl = `// Copyright (C) 2014 The Android Open Source Project
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

{{define "Cpp.Constructor"}}»»{{FixupName .Name}}({{range $index, $field := .Fields}}{{if $index}}, {{end}}{{CppStorage $field.Type}} {{$field.Name}}{{end}}) {{range $index, $field := .Fields}}{{if $index}},{{else}}:{{end}}
»»»m{{.Name}}({{.Name}}){{end}} {}{{end}}

{{define "Cpp.ID"}}»»virtual const gapic::Id& Id() const {
»»»static gapic::Id ID{ { {{range .ID}}{{printf "0x%2.2x" .}}, {{end}} } };
»»»return ID;
»»}{{end}}

{{define "Cpp.Encoder"}}»»virtual void Encode(Encoder* e) const {
{{range .Fields}}»»»{{Encode (print "this->m" .Name) .Type}}
{{end}}»»}{{end}}

{{define "Cpp.EncodePrimitive"}}e->{{.Type.Method}}({{.Name}});{{end}}
{{define "Cpp.EncodeStruct"}}e->Value(&{{.Name}});{{end}}
{{define "Cpp.EncodePointer"}}e->object({{.Name}});{{end}}
{{define "Cpp.EncodeInterface"}}e->object({{.Name}});{{end}}

{{define "Cpp.EncodeSlice"}}e->Int32({{.Name}}.size());
»»»for (int i = 0; i < {{.Name}}.size(); i++) {
»»»»{{Encode (print .Name "[i]") .Type.ValueType}}
»»»}{{end}}

{{define "Cpp.EncodeArray"}}
»»»for (int i = 0; i < {{.Type.Length}}; i++) {
»»»»{{Encode (print .Name "[i]") .Type.ValueType}}
»»»}{{end}}

{{define "Cpp.EncodeStream"}}{{end}}

{{define "Cpp.EncodeMap"}}{{end}}

{{define "Cpp.File"}}{{$.Copyright}}

namespace gapic {

class Encodable;
class Encoder;

namespace coder {
namespace {{.Package}} {
{{range .Structs}}»class {{FixupName .Name}}: public Encodable {
»public:
{{template "Cpp.Constructor" .}}
{{template "Cpp.ID" .}}
{{template "Cpp.Encoder" .}}

{{range .Fields}}»»{{CppStorage .Type}} m{{.Name}};
{{end}}»};

{{end}}

} // namespace {{.Package}}
} // namespace coder
} // namespace gapic
{{end}}
`
const go_tmpl_file = `go.tmpl`
const go_tmpl = `{{/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */}}

{{define "Go.ID"}} {{.IDName}} = binary.ID{ {{range .ID}}{{printf "0x%2.2x" .}}, {{end}} } {{end}}

{{define "Go.Init"}} registry.Add((*{{.Name}})(nil).Class()){{end}}

{{define "Go.Class"}} type binaryClass{{.Name}} struct{}
func (*{{.Name}}) Class() binary.Class {
	return (*binaryClass{{.Name}})(nil)
}
func doEncode{{.Name}}(e binary.Encoder, o *{{.Name}}) error {
	{{range .Fields}}{{Encode (print "o." .Name) .Type}}
{{end}} return nil
}
func doDecode{{.Name}}(d binary.Decoder, o *{{.Name}}) error {
	{{range .Fields}}{{Decode (print "o." .Name) .Type}}
{{end}} return nil
}
func doSkip{{.Name}}(d binary.Decoder) error {
	{{range .Fields}}{{Skip (print "_." .Name) .Type}}
{{end}} return nil
}
func (*binaryClass{{.Name}}) ID() binary.ID { return {{.IDName}} }
func (*binaryClass{{.Name}}) New() binary.Object { return &{{.Name}}{} }
func (*binaryClass{{.Name}}) Encode(e binary.Encoder, obj binary.Object) error {return doEncode{{.Name}}(e, obj.(*{{.Name}})) }
func (*binaryClass{{.Name}}) Decode(d binary.Decoder) (binary.Object, error) {obj := &{{.Name}}{}; return obj, doDecode{{.Name}}(d, obj) }
func (*binaryClass{{.Name}}) DecodeTo(d binary.Decoder, obj binary.Object) error {return doDecode{{.Name}}(d, obj.(*{{.Name}})) }
func (*binaryClass{{.Name}}) Skip(d binary.Decoder) error {return doSkip{{.Name}}(d) }
func (*binaryClass{{.Name}}) Schema() *{{SchemaPrefix}}Class { return schema{{.Name}} }
var schema{{.Name}} = &{{SchemaPrefix}}Class{
	TypeID: {{.IDName}},
	Name: "{{.Name}}",
	Fields: []{{SchemaPrefix}}Field{
		{{range .Fields}}{ Declared:"{{.Name}}", Type:{{Schema .Type}} },
	{{end}} },
}
{{end}}

{{define "Go.EncodePrimitive"}}{{/*
*/}}{{if eq .Type.Native .Type.Name}}{{/*
*/}}if err := e.{{.Type.Method}}({{.Name}}); err != nil { return err } {{/*
*/}}{{else}}{{/*
*/}}if err := e.{{.Type.Method}}({{.Type.Native}}({{.Name}})); err != nil { return err } {{/*
*/}}{{end}}{{end}}

{{define "Go.EncodeStruct"}} if err := e.Value(&{{.Name}}); err != nil { return err } {{end}}

{{define "Go.EncodePointer"}} if {{.Name}} != nil {
			if err := e.Object({{.Name}}); err != nil {
				return err
			}
		} else if err := e.Object(nil); err != nil {
			return err
		} {{end}}

{{define "Go.EncodeInterface"}} if {{.Name}} != nil {
			if err := e.Object({{.Name}}); err != nil {
				return err
			}
		} else if err := e.Object(nil); err != nil {
			return err
		} {{end}}

{{define "Go.EncodeSlice"}} if err := e.Uint32(uint32(len({{.Name}}))); err != nil {
			return err
		}
		{{$vt := print .Type.ValueType}}{{if or (eq $vt "uint8") (eq $vt "byte")}} if err := e.Data({{.Name}}); err != nil { return err} {{else}}{{/*
		*/}} for i := range {{.Name}} {
			{{Encode (print .Name "[i]") .Type.ValueType}}
		}{{end}} {{end}}

{{define "Go.EncodeArray"}} for i := range {{.Name}} {
			{{Encode (print .Name "[i]") .Type.ValueType}}
		}{{end}}

{{define "Go.EncodeStream"}}for _, o := range {{.Name}} {
			if err := e.Object(o); err != nil {
				return err
			}
		}
		if err := e.Object((*objects.Terminator)(nil)); err != nil {
			return err
		}{{end}}

{{define "Go.EncodeMap"}} if err := e.Uint32(uint32(len({{.Name}}))); err != nil {
			return err
		}
		for k, v := range {{.Name}} {
			{{Encode "k" .Type.KeyType}}
			{{Encode "v" .Type.ValueType}}
		} {{end}}

{{define "Go.DecodePrimitive"}} if obj, err := d.{{.Type.Method}}(); err != nil {
			return err
		} else {
			{{.Name}} = {{.Type.Name}}(obj)
		} {{end}}

{{define "Go.DecodeStruct"}} if err := d.Value(&{{.Name}}); err != nil { return err } {{end}}

{{define "Go.DecodePointer"}} if obj, err := d.Object(); err != nil {
			return err
		} else if obj != nil {
			{{.Name}} = obj.({{.Type}})
		} else {
			{{.Name}} = nil
		} {{end}}

{{define "Go.DecodeInterface"}} if obj, err := d.Object(); err != nil {
			return err
		} else if obj != nil {
			{{.Name}} = obj.({{.Type.Name}})
		} else {
			{{.Name}} = nil
		} {{end}}

{{define "Go.DecodeSlice"}} if count, err := d.Uint32(); err != nil {
			return err
		} else {
			{{.Name}} = make({{.Type}}, count)
			{{$vt := print .Type.ValueType}}{{if or (eq $vt "uint8") (eq $vt "byte")}} if err := d.Data({{.Name}}); err != nil { return err} {{else}}{{/*
			*/}} for i := range {{.Name}} {
				{{Decode (print .Name "[i]") .Type.ValueType}}
			}{{end}}
		} {{end}}

{{define "Go.DecodeArray"}} for i := range {{.Name}} {
				{{Decode (print .Name "[i]") .Type.ValueType}}
			}{{end}}

{{define "Go.DecodeStream"}}for {
			if obj, err := d.Object(); err != nil {
				return err
			} else if _, end := obj.(*objects.Terminator); end {
				break
			} else {
				{{.Name}} = append({{.Name}}, obj.({{.Type.ValueType}}))
			}
		} {{end}}

{{define "Go.DecodeMap"}} if count, err := d.Uint32(); err != nil {
			return err
		} else {
			{{.Name}} = make({{.Type}}, count)
			m := {{.Name}}
			for i := uint32(0); i < count; i++ {
				var k {{.Type.KeyType}}
				var v {{.Type.ValueType}}
				{{Decode "k" .Type.KeyType}}
				{{Decode "v" .Type.ValueType}}
				m[k] = v
			}
		} {{end}}

{{define "Go.SkipPrimitive"}}{{if .Type.Method.Skippable}}if err := d.Skip{{.Type.Method}}(); err != nil {
	return err
} {{else}}if _,err := d.{{.Type.Method}}(); err != nil {
		return err
} {{end}} {{end}}
{{define "Go.SkipStruct"}} if err := d.SkipValue((*{{.Type.Name}})(nil)); err != nil { return err } {{end}}
{{define "Go.SkipPointer"}} if _, err := d.SkipObject(); err != nil { return err } {{end}}
{{define "Go.SkipInterface"}} if _, err := d.SkipObject(); err != nil { return err } {{end}}

{{define "Go.SkipSlice"}} if count, err := d.Uint32(); err != nil {
			return err
		} else {
			{{$vt := print .Type.ValueType}}{{if or (eq $vt "uint8") (eq $vt "byte")}} if err := d.Skip(count); err != nil { return err} {{else}}{{/*
			*/}} for i := uint32(0); i < count; i++ {
				{{Skip (print .Name "[i]") .Type.ValueType}}
			}{{end}}
		} {{end}}

{{define "Go.SkipArray"}}for i := uint32(0); i < {{.Type.Length}}; i++ {
			{{Skip (print .Name "[i]") .Type.ValueType}}
		}{{end}}


{{define "Go.SkipStream"}}for {
			if id, err := d.SkipObject(); err != nil {
				return err
			} else if id == objects.TerminatorID {
				break
			}
		} {{end}}

{{define "Go.SkipMap"}} if count, err := d.Uint32(); err != nil {
			return err
		} else {
			for i := uint32(0); i < count; i++ {
				{{Skip "k" .Type.KeyType}}
				{{Skip "v" .Type.ValueType}}
			}
		} {{end}}

{{define "Go.SchemaPrimitive"}}&{{SchemaPrefix}}Primitive{ Name: "{{.Name}}", Method: {{SchemaPrefix}}{{.Method}} }{{end}}
{{define "Go.SchemaStruct"}}&{{SchemaPrefix}}Struct{Name: "{{.Name}}"}{{end}}
{{define "Go.SchemaPointer"}}&{{SchemaPrefix}}Pointer{ Type: {{Schema .Type}} }{{end}}
{{define "Go.SchemaInterface"}}&{{SchemaPrefix}}Interface{ Name: "{{.Name}}"}{{end}}
{{define "Go.SchemaSlice"}}&{{SchemaPrefix}}Slice{Alias: "{{.Alias}}", ValueType: {{Schema .ValueType}} }{{end}}
{{define "Go.SchemaArray"}}&{{SchemaPrefix}}Array{Alias: "{{.Alias}}", ValueType: {{Schema .ValueType}}, Size: {{.Size}} }{{end}}
{{define "Go.SchemaStream"}}&{{SchemaPrefix}}Stream{Alias: "{{.Alias}}", ValueType: {{Schema .ValueType}} }{{end}}
{{define "Go.SchemaMap"}}&{{SchemaPrefix}}Map{Alias: "{{.Alias}}", KeyType: {{Schema .KeyType}}, ValueType: {{Schema .ValueType}} }{{end}}

{{define "Go.Constants"}}{{if Directive (print .Type ".String") true}}{{$name := print .Type}}{{$c := Counter "Go.Constants"}}
const _{{$name}}_name = "{{range .Values}}{{.Name}}{{end}}"
var _{{$name}}_map = map[{{.Type}}]string{ {{$c.Set 0}}{{range .Values}}
	{{.Value}}: _{{$name}}_name[{{$c}}:{{$c.AddLen .Name}}{{$c}}],{{end}}
}

func (v {{$name}}) String() string {
	if s, ok := _{{$name}}_map[v]; ok {
		return s
	}
	return fmt.Sprintf("{{$name}}(%d)", v)
}

func (v *{{$name}}) Parse(s string) error {
	for k, t := range _{{$name}}_map {
		if s == t {
			*v = k
			return nil
		}
	}
	return fmt.Errorf("%s not in {{$name}}", s)
}
{{end}}{{end}}

{{define "Go.File"}}
{{$.Copyright}}

package {{.Package}}

import (
	"reflect"
	"android.googlesource.com/platform/tools/gpu/binary/registry"
	{{range $imp, $v := .Imports}}"{{$imp}}"
{{end}})

{{if len .Structs}}func init() {
	{{range .Structs}}{{template "Go.Init" .}}
	{{end}} }

var (
{{range .Structs}} {{template "Go.ID" .}}
{{end}} ){{end}}

{{range .Structs}} {{template "Go.Class" .}}
{{end}}

{{range .Constants}}{{template "Go.Constants" .}}
{{end}}
{{end}}
`
const java_tmpl_file = `java.tmpl`
const java_tmpl = `{{/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */}}

{{define "Java.Enum"}}{{.Name}}Enum{{end}}
{{define "Java.ID"}}{{JavaID .Name}}ID{{end}}
{{define "Java.IDBytes"}}{{JavaID .Name}}IDBytes{{end}}

{{define "Java.Encoder"}}
»public static void encode(Encoder e, {{JavaClass .Name}} o) throws IOException {
{{range .Fields}}»»{{Encode (print "o." (JavaFieldName .Name)) .Type}}
{{end}}»}{{end}}

{{define "Java.EncodePrimitive"}}e.{{Lower .Type.Method}}({{.Name}});{{end}}
{{define "Java.EncodeStruct"}}{{.Name}}.encode(e);{{end}}
{{define "Java.EncodePointer"}}e.object({{.Name}});{{end}}
{{define "Java.EncodeInterface"}}e.object({{.Name}});{{end}}

{{define "Java.EncodeSlice"}}e.int32({{.Name}}.length);
»»for (int i = 0; i < {{.Name}}.length; i++) {
»»»{{Encode (print .Name "[i]") .Type.ValueType}}
»»}{{end}}

{{define "Java.EncodeArray"}}
»»for (int i = 0; i < {{.Type.Length}}; i++) {
»»»{{Encode (print .Name "[i]") .Type.ValueType}}
»»}{{end}}

{{define "Java.EncodeStream"}}TODO: Java stream handling{{end}}

{{define "Java.EncodeMap"}}TODO: Java map handling{{end}}

{{define "Java.Decoder"}}
»public static void decode(Decoder d, {{JavaClass .Name}} o) throws IOException {
{{range .Fields}}»»{{Decode (print "o." (JavaFieldName .Name)) .Type}}
{{end}}»}{{end}}

{{define "Java.DecodePrimitive"}}{{.Name}} = d.{{Lower .Type.Method}}();{{end}}
{{define "Java.DecodeStruct"}}{{.Name}} = new {{.Type.Name}}(d);{{end}}
{{define "Java.DecodePointer"}}{{.Name}} = ({{JavaStorage .Type}})d.object();{{end}}
{{define "Java.DecodeInterface"}}{{.Name}} = ({{JavaStorage .Type}})d.object();{{end}}

{{define "Java.DecodeSlice"}}{{.Name}} = new {{JavaStorage .Type.ValueType}}[d.int32()];
»»for (int i = 0; i < {{.Name}}.length; i++) {
»»»{{Decode (print .Name "[i]") .Type.ValueType}}
»»}{{end}}

{{define "Java.DecodeArray"}}{{.Name}} = new {{JavaStorage .Type.ValueType}}[{{.Type.Length}}];
»»for (int i = 0; i < {{.Type.Length}}; i++) {
»»»{{Decode (print .Name "[i]") .Type.ValueType}}
»»}{{end}}

{{define "Java.DecodeMap"}}TODO: Java map handling{{end}}
{{define "Java.DecodeStream"}}TODO: Java stream handling{{end}}

{{define "Java.File"}}{{$.Copyright}}package {{.Package}};

import com.android.tools.rpclib.binary.BinaryObject;
import com.android.tools.rpclib.binary.BinaryObjectCreator;
import com.android.tools.rpclib.binary.Decoder;
import com.android.tools.rpclib.binary.Encoder;
import com.android.tools.rpclib.binary.ObjectTypeID;
import java.io.IOException;

class ObjectFactory {
»public enum Entries implements BinaryObjectCreator {{"{"}}{{range .Structs}}
»»{{template "Java.Enum" .}} {
»»»@Override public BinaryObject create() {
»»»»return new {{JavaClass .Name}}();
»»»}
»»},{{end}}
»}
{{range .Structs}}
»public static byte[] {{template "Java.IDBytes" .}} = { {{range .ID}}{{ToS8 .}}, {{end}}{{"}"}};{{end}}
{{range .Structs}}
»public static ObjectTypeID {{template "Java.ID" .}} = new ObjectTypeID({{template "Java.IDBytes" .}});{{end}}

»static {{"{"}}{{range .Structs}}
»»ObjectTypeID.register({{template "Java.ID" .}}, Entries.{{template "Java.Enum" .}});{{end}}
»}{{range .Structs}}
{{template "Java.Encoder" .}}
{{template "Java.Decoder" .}}{{end}}
}
{{end}}
`
