////////////////////////////////////////////////////////////////////////////////
// Do not modify!
// Generated by codergen -cpp=coder
////////////////////////////////////////////////////////////////////////////////



namespace gapic {

class Encodable;
class Encoder;

namespace coder {
namespace atom {
    class Range: public Encodable {
    public:
        Range(ID Start, ID End) :
            mStart(Start),
            mEnd(End) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6f, 0xbb, 0x0f, 0x69, 0x4c, 0x19, 0xdb, 0x86, 0x34, 0x4f, 0x63, 0xc3, 0x04, 0xaf, 0x06, 0x89, 0xda, 0x0f, 0xb3, 0x0a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mStart);
            e->Uint64(this->mEnd);
        }

        ID mStart;
        ID mEnd;
    };

    class Group: public Encodable {
    public:
        Group(char* Name, Range Range, Group* SubGroups) :
            mName(Name),
            mRange(Range),
            mSubGroups(SubGroups) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x1d, 0x80, 0xcc, 0xfa, 0xe5, 0xba, 0x0e, 0x88, 0x3f, 0x11, 0x3b, 0xd5, 0x07, 0x16, 0x56, 0x13, 0xf5, 0x43, 0x42, 0xeb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->String(this->mName);
            e->Value(&this->mRange);
            e->Int32(this->mSubGroups.size());
            for (int i = 0; i < this->mSubGroups.size(); i++) {
                e->Value(&this->mSubGroups[i]);
            }
        }

        char* mName;
        Range mRange;
        Group* mSubGroups;
    };

    class Observation: public Encodable {
    public:
        Observation(memory::Range Range, binary::ID ID) :
            mRange(Range),
            mID(ID) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf4, 0xbd, 0xbf, 0xe0, 0x82, 0x78, 0xa4, 0xbd, 0x55, 0xac, 0xeb, 0x1e, 0x0b, 0xde, 0xe5, 0x27, 0x1a, 0xd8, 0x84, 0x0f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mRange);
            e->ID(this->mID);
        }

        memory::Range mRange;
        binary::ID mID;
    };

    class Observations: public Encodable {
    public:
        Observations(Observation* Reads, Observation* Writes) :
            mReads(Reads),
            mWrites(Writes) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x61, 0xdf, 0xaa, 0x12, 0x4f, 0x53, 0x1a, 0x54, 0x92, 0x4e, 0x90, 0xc4, 0x05, 0x7c, 0xf4, 0x5f, 0x00, 0xcb, 0x62, 0xe9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Int32(this->mReads.size());
            for (int i = 0; i < this->mReads.size(); i++) {
                e->Value(&this->mReads[i]);
            }
            e->Int32(this->mWrites.size());
            for (int i = 0; i < this->mWrites.size(); i++) {
                e->Value(&this->mWrites[i]);
            }
        }

        Observation* mReads;
        Observation* mWrites;
    };

    class Resource: public Encodable {
    public:
        Resource(binary::ID ID, byte* Data) :
            mID(ID),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdd, 0xe2, 0x00, 0x18, 0x25, 0x45, 0x71, 0xb9, 0xdb, 0x6f, 0xed, 0x39, 0xdd, 0x8e, 0x71, 0x4b, 0xf6, 0x76, 0x26, 0xce,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->ID(this->mID);
            e->Int32(this->mData.size());
            for (int i = 0; i < this->mData.size(); i++) {
                e->Uint8(this->mData[i]);
            }
        }

        binary::ID mID;
        byte* mData;
    };



} // namespace atom
} // namespace coder
} // namespace gapic
