/*
 * Copyright (C) 2015 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "connection.h"

#include <string>

namespace gapic {

bool Connection::sendString(const std::string& s) {
    uint32_t length = static_cast<uint32_t>(s.size())+1;
    return this->send(s.c_str(), length) == length;
}

bool Connection::readString(std::string* s) {
    char c;
    s->clear();
    while(true) {
        if (this->recv(&c, 1) != 1) { return false; }
        if (c == 0) {
            return true;
        }
        s->push_back(c);
    }
}

}  // namespace gapic
