/*
 * Copyright 2015, The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY apic. DO NOT EDIT.
 */

#include "gles_imports.h"
#include "gles_types.h"
#include "spy.h"

#include <gapic/get_gfx_proc_address.h>
#include <gapic/log.h>
#include <gapic/target.h>  // STDCALL

#include <memory>

#include <string.h>

using namespace gapii;

extern "C" {
EXPORT int STDCALL eglInitialize(void* dpy, int* major, int* minor);
EXPORT void* STDCALL
eglCreateContext(void* display, void* config, void* share_context, int* attrib_list);
EXPORT int STDCALL eglMakeCurrent(void* display, void* draw, void* read, void* context);
EXPORT int STDCALL eglSwapBuffers(void* display, void* surface);
EXPORT int STDCALL eglQuerySurface(void* display, void* surface, int attribute, int* value);
EXPORT void* STDCALL glXCreateContext(void* dpy, void* vis, void* shareList, bool direct);
EXPORT void* STDCALL
glXCreateNewContext(void* display, void* fbconfig, uint32_t type, void* shared, bool direct);
EXPORT void STDCALL glXMakeContextCurrent(void* display, void* draw, void* read, void* ctx);
EXPORT void STDCALL glXSwapBuffers(void* display, void* drawable);
EXPORT void* STDCALL wglCreateContext(void* hdc);
EXPORT void* STDCALL wglCreateContextAttribsARB(void* hdc, void* hShareContext, int* attribList);
EXPORT int STDCALL wglMakeCurrent(void* hdc, void* hglrc);
EXPORT void STDCALL wglSwapBuffers(void* hdc);
EXPORT int STDCALL CGLCreateContext(void* pix, void* share, void** ctx);
EXPORT int STDCALL CGLSetCurrentContext(void* ctx);
EXPORT void STDCALL glEnableClientState(uint32_t type);
EXPORT void STDCALL glDisableClientState(uint32_t type);
EXPORT void STDCALL glGetProgramBinaryOES(uint32_t program, int32_t buffer_size,
                                          int32_t* bytes_written, uint32_t* binary_format,
                                          void* binary);
EXPORT void STDCALL
glProgramBinaryOES(uint32_t program, uint32_t binary_format, void* binary, int32_t binary_size);
EXPORT void STDCALL
glStartTilingQCOM(int32_t x, int32_t y, int32_t width, int32_t height, uint32_t preserveMask);
EXPORT void STDCALL glEndTilingQCOM(uint32_t preserve_mask);
EXPORT void STDCALL
glDiscardFramebufferEXT(uint32_t target, int32_t numAttachments, uint32_t* attachments);
EXPORT void STDCALL glInsertEventMarkerEXT(int32_t length, char* marker);
EXPORT void STDCALL glPushGroupMarkerEXT(int32_t length, char* marker);
EXPORT void STDCALL glPopGroupMarkerEXT();
EXPORT void STDCALL
glTexStorage1DEXT(uint32_t target, int32_t levels, uint32_t format, int32_t width);
EXPORT void STDCALL
glTexStorage2DEXT(uint32_t target, int32_t levels, uint32_t format, int32_t width, int32_t height);
EXPORT void STDCALL glTexStorage3DEXT(uint32_t target, int32_t levels, uint32_t format,
                                      int32_t width, int32_t height, int32_t depth);
EXPORT void STDCALL glTextureStorage1DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width);
EXPORT void STDCALL glTextureStorage2DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width, int32_t height);
EXPORT void STDCALL glTextureStorage3DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width, int32_t height,
                                          int32_t depth);
EXPORT void STDCALL glGenVertexArraysOES(int32_t count, uint32_t* arrays);
EXPORT void STDCALL glBindVertexArrayOES(uint32_t array);
EXPORT void STDCALL glDeleteVertexArraysOES(int32_t count, uint32_t* arrays);
EXPORT bool STDCALL glIsVertexArrayOES(uint32_t array);
EXPORT void STDCALL glEGLImageTargetTexture2DOES(uint32_t target, void* image);
EXPORT void STDCALL glEGLImageTargetRenderbufferStorageOES(uint32_t target, void* image);
EXPORT uint32_t STDCALL glGetGraphicsResetStatusEXT();
EXPORT void STDCALL glBindAttribLocation(uint32_t program, uint32_t location, char* name);
EXPORT void STDCALL glBlendFunc(uint32_t src_factor, uint32_t dst_factor);
EXPORT void STDCALL glBlendFuncSeparate(uint32_t src_factor_rgb, uint32_t dst_factor_rgb,
                                        uint32_t src_factor_alpha, uint32_t dst_factor_alpha);
EXPORT void STDCALL glBlendEquation(uint32_t equation);
EXPORT void STDCALL glBlendEquationSeparate(uint32_t rgb, uint32_t alpha);
EXPORT void STDCALL glBlendColor(float red, float green, float blue, float alpha);
EXPORT void STDCALL glEnableVertexAttribArray(uint32_t location);
EXPORT void STDCALL glDisableVertexAttribArray(uint32_t location);
EXPORT void STDCALL glVertexAttribPointer(uint32_t location, int32_t size, uint32_t type,
                                          bool normalized, int32_t stride, void* data);
EXPORT void STDCALL glGetActiveAttrib(uint32_t program, uint32_t location, int32_t buffer_size,
                                      int32_t* buffer_bytes_written, int32_t* vector_count,
                                      uint32_t* type, char* name);
EXPORT void STDCALL glGetActiveUniform(uint32_t program, int32_t location, int32_t buffer_size,
                                       int32_t* buffer_bytes_written, int32_t* vector_count,
                                       uint32_t* type, char* name);
EXPORT uint32_t STDCALL glGetError();
EXPORT void STDCALL glGetProgramiv(uint32_t program, uint32_t parameter, int32_t* value);
EXPORT void STDCALL glGetShaderiv(uint32_t shader, uint32_t parameter, int32_t* value);
EXPORT int32_t STDCALL glGetUniformLocation(uint32_t program, char* name);
EXPORT uint32_t STDCALL glGetAttribLocation(uint32_t program, char* name);
EXPORT void STDCALL glPixelStorei(uint32_t parameter, int32_t value);
EXPORT void STDCALL glTexParameteri(uint32_t target, uint32_t parameter, int32_t value);
EXPORT void STDCALL glTexParameterf(uint32_t target, uint32_t parameter, float value);
EXPORT void STDCALL glGetTexParameteriv(uint32_t target, uint32_t parameter, int32_t* values);
EXPORT void STDCALL glGetTexParameterfv(uint32_t target, uint32_t parameter, float* values);
EXPORT void STDCALL glUniform1i(int32_t location, int32_t value);
EXPORT void STDCALL glUniform2i(int32_t location, int32_t value0, int32_t value1);
EXPORT void STDCALL glUniform3i(int32_t location, int32_t value0, int32_t value1, int32_t value2);
EXPORT void STDCALL
glUniform4i(int32_t location, int32_t value0, int32_t value1, int32_t value2, int32_t value3);
EXPORT void STDCALL glUniform1iv(int32_t location, int32_t count, int32_t* value);
EXPORT void STDCALL glUniform2iv(int32_t location, int32_t count, int32_t* value);
EXPORT void STDCALL glUniform3iv(int32_t location, int32_t count, int32_t* value);
EXPORT void STDCALL glUniform4iv(int32_t location, int32_t count, int32_t* value);
EXPORT void STDCALL glUniform1f(int32_t location, float value);
EXPORT void STDCALL glUniform2f(int32_t location, float value0, float value1);
EXPORT void STDCALL glUniform3f(int32_t location, float value0, float value1, float value2);
EXPORT void STDCALL
glUniform4f(int32_t location, float value0, float value1, float value2, float value3);
EXPORT void STDCALL glUniform1fv(int32_t location, int32_t count, float* value);
EXPORT void STDCALL glUniform2fv(int32_t location, int32_t count, float* value);
EXPORT void STDCALL glUniform3fv(int32_t location, int32_t count, float* value);
EXPORT void STDCALL glUniform4fv(int32_t location, int32_t count, float* value);
EXPORT void STDCALL
glUniformMatrix2fv(int32_t location, int32_t count, bool transpose, float* values);
EXPORT void STDCALL
glUniformMatrix3fv(int32_t location, int32_t count, bool transpose, float* values);
EXPORT void STDCALL
glUniformMatrix4fv(int32_t location, int32_t count, bool transpose, float* values);
EXPORT void STDCALL glGetUniformfv(uint32_t program, int32_t location, float* values);
EXPORT void STDCALL glGetUniformiv(uint32_t program, int32_t location, int32_t* values);
EXPORT void STDCALL glVertexAttrib1f(uint32_t location, float value0);
EXPORT void STDCALL glVertexAttrib2f(uint32_t location, float value0, float value1);
EXPORT void STDCALL glVertexAttrib3f(uint32_t location, float value0, float value1, float value2);
EXPORT void STDCALL
glVertexAttrib4f(uint32_t location, float value0, float value1, float value2, float value3);
EXPORT void STDCALL glVertexAttrib1fv(uint32_t location, float* value);
EXPORT void STDCALL glVertexAttrib2fv(uint32_t location, float* value);
EXPORT void STDCALL glVertexAttrib3fv(uint32_t location, float* value);
EXPORT void STDCALL glVertexAttrib4fv(uint32_t location, float* value);
EXPORT void STDCALL glGetShaderPrecisionFormat(uint32_t shader_type, uint32_t precision_type,
                                               int32_t* range, int32_t* precision);
EXPORT void STDCALL glDepthMask(bool enabled);
EXPORT void STDCALL glDepthFunc(uint32_t function);
EXPORT void STDCALL glDepthRangef(float near, float far);
EXPORT void STDCALL glColorMask(bool red, bool green, bool blue, bool alpha);
EXPORT void STDCALL glStencilMask(uint32_t mask);
EXPORT void STDCALL glStencilMaskSeparate(uint32_t face, uint32_t mask);
EXPORT void STDCALL
glStencilFuncSeparate(uint32_t face, uint32_t function, int32_t reference_value, int32_t mask);
EXPORT void STDCALL glStencilOpSeparate(uint32_t face, uint32_t stencil_fail,
                                        uint32_t stencil_pass_depth_fail,
                                        uint32_t stencil_pass_depth_pass);
EXPORT void STDCALL glFrontFace(uint32_t orientation);
EXPORT void STDCALL glViewport(int32_t x, int32_t y, int32_t width, int32_t height);
EXPORT void STDCALL glScissor(int32_t x, int32_t y, int32_t width, int32_t height);
EXPORT void STDCALL glActiveTexture(uint32_t unit);
EXPORT void STDCALL glGenTextures(int32_t count, uint32_t* textures);
EXPORT void STDCALL glDeleteTextures(int32_t count, uint32_t* textures);
EXPORT bool STDCALL glIsTexture(uint32_t texture);
EXPORT void STDCALL glBindTexture(uint32_t target, uint32_t texture);
EXPORT void STDCALL glTexImage2D(uint32_t target, int32_t level, uint32_t internal_format,
                                 int32_t width, int32_t height, int32_t border, uint32_t format,
                                 uint32_t type, void* data);
EXPORT void STDCALL glTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                    int32_t yoffset, int32_t width, int32_t height, uint32_t format,
                                    uint32_t type, void* data);
EXPORT void STDCALL glCopyTexImage2D(uint32_t target, int32_t level, uint32_t format, int32_t x,
                                     int32_t y, int32_t width, int32_t height, int32_t border);
EXPORT void STDCALL glCopyTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                        int32_t yoffset, int32_t x, int32_t y, int32_t width,
                                        int32_t height);
EXPORT void STDCALL glCompressedTexImage2D(uint32_t target, int32_t level, uint32_t format,
                                           int32_t width, int32_t height, int32_t border,
                                           int32_t image_size, void* data);
EXPORT void STDCALL glCompressedTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                              int32_t yoffset, int32_t width, int32_t height,
                                              uint32_t format, int32_t image_size, void* data);
EXPORT void STDCALL glGenerateMipmap(uint32_t target);
EXPORT void STDCALL glReadPixels(int32_t x, int32_t y, int32_t width, int32_t height,
                                 uint32_t format, uint32_t type, void* data);
EXPORT void STDCALL glGenFramebuffers(int32_t count, uint32_t* framebuffers);
EXPORT void STDCALL glBindFramebuffer(uint32_t target, uint32_t framebuffer);
EXPORT uint32_t STDCALL glCheckFramebufferStatus(uint32_t target);
EXPORT void STDCALL glDeleteFramebuffers(int32_t count, uint32_t* framebuffers);
EXPORT bool STDCALL glIsFramebuffer(uint32_t framebuffer);
EXPORT void STDCALL glGenRenderbuffers(int32_t count, uint32_t* renderbuffers);
EXPORT void STDCALL glBindRenderbuffer(uint32_t target, uint32_t renderbuffer);
EXPORT void STDCALL
glRenderbufferStorage(uint32_t target, uint32_t format, int32_t width, int32_t height);
EXPORT void STDCALL glDeleteRenderbuffers(int32_t count, uint32_t* renderbuffers);
EXPORT bool STDCALL glIsRenderbuffer(uint32_t renderbuffer);
EXPORT void STDCALL
glGetRenderbufferParameteriv(uint32_t target, uint32_t parameter, int32_t* values);
EXPORT void STDCALL glGenBuffers(int32_t count, uint32_t* buffers);
EXPORT void STDCALL glBindBuffer(uint32_t target, uint32_t buffer);
EXPORT void STDCALL glBufferData(uint32_t target, int32_t size, void* data, uint32_t usage);
EXPORT void STDCALL glBufferSubData(uint32_t target, int32_t offset, int32_t size, void* data);
EXPORT void STDCALL glDeleteBuffers(int32_t count, uint32_t* buffers);
EXPORT bool STDCALL glIsBuffer(uint32_t buffer);
EXPORT void STDCALL glGetBufferParameteriv(uint32_t target, uint32_t parameter, int32_t* value);
EXPORT uint32_t STDCALL glCreateShader(uint32_t type);
EXPORT void STDCALL glDeleteShader(uint32_t shader);
EXPORT void STDCALL glShaderSource(uint32_t shader, int32_t count, char** source, int32_t* length);
EXPORT void STDCALL glShaderBinary(int32_t count, uint32_t* shaders, uint32_t binary_format,
                                   void* binary, int32_t binary_size);
EXPORT void STDCALL glGetShaderInfoLog(uint32_t shader, int32_t buffer_length,
                                       int32_t* string_length_written, char* info);
EXPORT void STDCALL glGetShaderSource(uint32_t shader, int32_t buffer_length,
                                      int32_t* string_length_written, char* source);
EXPORT void STDCALL glReleaseShaderCompiler();
EXPORT void STDCALL glCompileShader(uint32_t shader);
EXPORT bool STDCALL glIsShader(uint32_t shader);
EXPORT uint32_t STDCALL glCreateProgram();
EXPORT void STDCALL glDeleteProgram(uint32_t program);
EXPORT void STDCALL glAttachShader(uint32_t program, uint32_t shader);
EXPORT void STDCALL glDetachShader(uint32_t program, uint32_t shader);
EXPORT void STDCALL glGetAttachedShaders(uint32_t program, int32_t buffer_length,
                                         int32_t* shaders_length_written, uint32_t* shaders);
EXPORT void STDCALL glLinkProgram(uint32_t program);
EXPORT void STDCALL glGetProgramInfoLog(uint32_t program, int32_t buffer_length,
                                        int32_t* string_length_written, char* info);
EXPORT void STDCALL glUseProgram(uint32_t program);
EXPORT bool STDCALL glIsProgram(uint32_t program);
EXPORT void STDCALL glValidateProgram(uint32_t program);
EXPORT void STDCALL glClearColor(float r, float g, float b, float a);
EXPORT void STDCALL glClearDepthf(float depth);
EXPORT void STDCALL glClearStencil(int32_t stencil);
EXPORT void STDCALL glClear(uint32_t mask);
EXPORT void STDCALL glCullFace(uint32_t mode);
EXPORT void STDCALL glPolygonOffset(float scale_factor, float units);
EXPORT void STDCALL glLineWidth(float width);
EXPORT void STDCALL glSampleCoverage(float value, bool invert);
EXPORT void STDCALL glHint(uint32_t target, uint32_t mode);
EXPORT void STDCALL glFramebufferRenderbuffer(uint32_t framebuffer_target,
                                              uint32_t framebuffer_attachment,
                                              uint32_t renderbuffer_target, uint32_t renderbuffer);
EXPORT void STDCALL glFramebufferTexture2D(uint32_t framebuffer_target,
                                           uint32_t framebuffer_attachment, uint32_t texture_target,
                                           uint32_t texture, int32_t level);
EXPORT void STDCALL glGetFramebufferAttachmentParameteriv(uint32_t framebuffer_target,
                                                          uint32_t attachment, uint32_t parameter,
                                                          int32_t* value);
EXPORT void STDCALL
glDrawElements(uint32_t draw_mode, int32_t element_count, uint32_t indices_type, void* indices);
EXPORT void STDCALL glDrawArrays(uint32_t draw_mode, int32_t first_index, int32_t index_count);
EXPORT void STDCALL glFlush();
EXPORT void STDCALL glFinish();
EXPORT void STDCALL glGetBooleanv(uint32_t param, bool* values);
EXPORT void STDCALL glGetFloatv(uint32_t param, float* values);
EXPORT void STDCALL glGetIntegerv(uint32_t param, int32_t* values);
EXPORT char* STDCALL glGetString(uint32_t param);
EXPORT void STDCALL glEnable(uint32_t capability);
EXPORT void STDCALL glDisable(uint32_t capability);
EXPORT bool STDCALL glIsEnabled(uint32_t capability);
EXPORT void* STDCALL
glMapBufferRange(uint32_t target, int32_t offset, int32_t length, uint32_t access);
EXPORT void STDCALL glUnmapBuffer(uint32_t target);
EXPORT void STDCALL glInvalidateFramebuffer(uint32_t target, int32_t count, uint32_t* attachments);
EXPORT void STDCALL glRenderbufferStorageMultisample(uint32_t target, int32_t samples,
                                                     uint32_t format, int32_t width,
                                                     int32_t height);
EXPORT void STDCALL glBlitFramebuffer(int32_t srcX0, int32_t srcY0, int32_t srcX1, int32_t srcY1,
                                      int32_t dstX0, int32_t dstY0, int32_t dstX1, int32_t dstY1,
                                      uint32_t mask, uint32_t filter);
EXPORT void STDCALL glGenQueries(int32_t count, uint32_t* queries);
EXPORT void STDCALL glBeginQuery(uint32_t target, uint32_t query);
EXPORT void STDCALL glEndQuery(uint32_t target);
EXPORT void STDCALL glDeleteQueries(int32_t count, uint32_t* queries);
EXPORT bool STDCALL glIsQuery(uint32_t query);
EXPORT void STDCALL glGetQueryiv(uint32_t target, uint32_t parameter, int32_t* value);
EXPORT void STDCALL glGetQueryObjectuiv(uint32_t query, uint32_t parameter, uint32_t* value);
EXPORT void STDCALL glGenQueriesEXT(int32_t count, uint32_t* queries);
EXPORT void STDCALL glBeginQueryEXT(uint32_t target, uint32_t query);
EXPORT void STDCALL glEndQueryEXT(uint32_t target);
EXPORT void STDCALL glDeleteQueriesEXT(int32_t count, uint32_t* queries);
EXPORT bool STDCALL glIsQueryEXT(uint32_t query);
EXPORT void STDCALL glQueryCounterEXT(uint32_t query, uint32_t target);
EXPORT void STDCALL glGetQueryivEXT(uint32_t target, uint32_t parameter, int32_t* value);
EXPORT void STDCALL glGetQueryObjectivEXT(uint32_t query, uint32_t parameter, int32_t* value);
EXPORT void STDCALL glGetQueryObjectuivEXT(uint32_t query, uint32_t parameter, uint32_t* value);
EXPORT void STDCALL glGetQueryObjecti64vEXT(uint32_t query, uint32_t parameter, int64_t* value);
EXPORT void STDCALL glGetQueryObjectui64vEXT(uint32_t query, uint32_t parameter, uint64_t* value);

EXPORT void* STDCALL eglGetProcAddress(const char* name);
EXPORT void* STDCALL wglGetProcAddress(const char* name);
EXPORT void* STDCALL glXGetProcAddress(const char* name);
EXPORT void* STDCALL glXGetProcAddressARB(const char* name);
}  // extern "C"

namespace {

std::unique_ptr<Spy> gSpy;  // Must be accessed via spy() below, gets destroyed with the library.

// spy lazily constructs and returns the instance to the spy.
Spy* spy() {
    static bool initializedOnce = false;
    if (!initializedOnce) {
        gSpy.reset(new Spy());
        GAPID_INFO("Registering spy symbols...\n");
        gSpy->RegisterSymbol("eglInitialize", reinterpret_cast<void*>(eglInitialize));
        gSpy->RegisterSymbol("eglCreateContext", reinterpret_cast<void*>(eglCreateContext));
        gSpy->RegisterSymbol("eglMakeCurrent", reinterpret_cast<void*>(eglMakeCurrent));
        gSpy->RegisterSymbol("eglSwapBuffers", reinterpret_cast<void*>(eglSwapBuffers));
        gSpy->RegisterSymbol("eglQuerySurface", reinterpret_cast<void*>(eglQuerySurface));
        gSpy->RegisterSymbol("glXCreateContext", reinterpret_cast<void*>(glXCreateContext));
        gSpy->RegisterSymbol("glXCreateNewContext", reinterpret_cast<void*>(glXCreateNewContext));
        gSpy->RegisterSymbol("glXMakeContextCurrent",
                             reinterpret_cast<void*>(glXMakeContextCurrent));
        gSpy->RegisterSymbol("glXSwapBuffers", reinterpret_cast<void*>(glXSwapBuffers));
        gSpy->RegisterSymbol("wglCreateContext", reinterpret_cast<void*>(wglCreateContext));
        gSpy->RegisterSymbol("wglCreateContextAttribsARB",
                             reinterpret_cast<void*>(wglCreateContextAttribsARB));
        gSpy->RegisterSymbol("wglMakeCurrent", reinterpret_cast<void*>(wglMakeCurrent));
        gSpy->RegisterSymbol("wglSwapBuffers", reinterpret_cast<void*>(wglSwapBuffers));
        gSpy->RegisterSymbol("CGLCreateContext", reinterpret_cast<void*>(CGLCreateContext));
        gSpy->RegisterSymbol("CGLSetCurrentContext", reinterpret_cast<void*>(CGLSetCurrentContext));
        gSpy->RegisterSymbol("glEnableClientState", reinterpret_cast<void*>(glEnableClientState));
        gSpy->RegisterSymbol("glDisableClientState", reinterpret_cast<void*>(glDisableClientState));
        gSpy->RegisterSymbol("glGetProgramBinaryOES",
                             reinterpret_cast<void*>(glGetProgramBinaryOES));
        gSpy->RegisterSymbol("glProgramBinaryOES", reinterpret_cast<void*>(glProgramBinaryOES));
        gSpy->RegisterSymbol("glStartTilingQCOM", reinterpret_cast<void*>(glStartTilingQCOM));
        gSpy->RegisterSymbol("glEndTilingQCOM", reinterpret_cast<void*>(glEndTilingQCOM));
        gSpy->RegisterSymbol("glDiscardFramebufferEXT",
                             reinterpret_cast<void*>(glDiscardFramebufferEXT));
        gSpy->RegisterSymbol("glInsertEventMarkerEXT",
                             reinterpret_cast<void*>(glInsertEventMarkerEXT));
        gSpy->RegisterSymbol("glPushGroupMarkerEXT", reinterpret_cast<void*>(glPushGroupMarkerEXT));
        gSpy->RegisterSymbol("glPopGroupMarkerEXT", reinterpret_cast<void*>(glPopGroupMarkerEXT));
        gSpy->RegisterSymbol("glTexStorage1DEXT", reinterpret_cast<void*>(glTexStorage1DEXT));
        gSpy->RegisterSymbol("glTexStorage2DEXT", reinterpret_cast<void*>(glTexStorage2DEXT));
        gSpy->RegisterSymbol("glTexStorage3DEXT", reinterpret_cast<void*>(glTexStorage3DEXT));
        gSpy->RegisterSymbol("glTextureStorage1DEXT",
                             reinterpret_cast<void*>(glTextureStorage1DEXT));
        gSpy->RegisterSymbol("glTextureStorage2DEXT",
                             reinterpret_cast<void*>(glTextureStorage2DEXT));
        gSpy->RegisterSymbol("glTextureStorage3DEXT",
                             reinterpret_cast<void*>(glTextureStorage3DEXT));
        gSpy->RegisterSymbol("glGenVertexArraysOES", reinterpret_cast<void*>(glGenVertexArraysOES));
        gSpy->RegisterSymbol("glBindVertexArrayOES", reinterpret_cast<void*>(glBindVertexArrayOES));
        gSpy->RegisterSymbol("glDeleteVertexArraysOES",
                             reinterpret_cast<void*>(glDeleteVertexArraysOES));
        gSpy->RegisterSymbol("glIsVertexArrayOES", reinterpret_cast<void*>(glIsVertexArrayOES));
        gSpy->RegisterSymbol("glEGLImageTargetTexture2DOES",
                             reinterpret_cast<void*>(glEGLImageTargetTexture2DOES));
        gSpy->RegisterSymbol("glEGLImageTargetRenderbufferStorageOES",
                             reinterpret_cast<void*>(glEGLImageTargetRenderbufferStorageOES));
        gSpy->RegisterSymbol("glGetGraphicsResetStatusEXT",
                             reinterpret_cast<void*>(glGetGraphicsResetStatusEXT));
        gSpy->RegisterSymbol("glBindAttribLocation", reinterpret_cast<void*>(glBindAttribLocation));
        gSpy->RegisterSymbol("glBlendFunc", reinterpret_cast<void*>(glBlendFunc));
        gSpy->RegisterSymbol("glBlendFuncSeparate", reinterpret_cast<void*>(glBlendFuncSeparate));
        gSpy->RegisterSymbol("glBlendEquation", reinterpret_cast<void*>(glBlendEquation));
        gSpy->RegisterSymbol("glBlendEquationSeparate",
                             reinterpret_cast<void*>(glBlendEquationSeparate));
        gSpy->RegisterSymbol("glBlendColor", reinterpret_cast<void*>(glBlendColor));
        gSpy->RegisterSymbol("glEnableVertexAttribArray",
                             reinterpret_cast<void*>(glEnableVertexAttribArray));
        gSpy->RegisterSymbol("glDisableVertexAttribArray",
                             reinterpret_cast<void*>(glDisableVertexAttribArray));
        gSpy->RegisterSymbol("glVertexAttribPointer",
                             reinterpret_cast<void*>(glVertexAttribPointer));
        gSpy->RegisterSymbol("glGetActiveAttrib", reinterpret_cast<void*>(glGetActiveAttrib));
        gSpy->RegisterSymbol("glGetActiveUniform", reinterpret_cast<void*>(glGetActiveUniform));
        gSpy->RegisterSymbol("glGetError", reinterpret_cast<void*>(glGetError));
        gSpy->RegisterSymbol("glGetProgramiv", reinterpret_cast<void*>(glGetProgramiv));
        gSpy->RegisterSymbol("glGetShaderiv", reinterpret_cast<void*>(glGetShaderiv));
        gSpy->RegisterSymbol("glGetUniformLocation", reinterpret_cast<void*>(glGetUniformLocation));
        gSpy->RegisterSymbol("glGetAttribLocation", reinterpret_cast<void*>(glGetAttribLocation));
        gSpy->RegisterSymbol("glPixelStorei", reinterpret_cast<void*>(glPixelStorei));
        gSpy->RegisterSymbol("glTexParameteri", reinterpret_cast<void*>(glTexParameteri));
        gSpy->RegisterSymbol("glTexParameterf", reinterpret_cast<void*>(glTexParameterf));
        gSpy->RegisterSymbol("glGetTexParameteriv", reinterpret_cast<void*>(glGetTexParameteriv));
        gSpy->RegisterSymbol("glGetTexParameterfv", reinterpret_cast<void*>(glGetTexParameterfv));
        gSpy->RegisterSymbol("glUniform1i", reinterpret_cast<void*>(glUniform1i));
        gSpy->RegisterSymbol("glUniform2i", reinterpret_cast<void*>(glUniform2i));
        gSpy->RegisterSymbol("glUniform3i", reinterpret_cast<void*>(glUniform3i));
        gSpy->RegisterSymbol("glUniform4i", reinterpret_cast<void*>(glUniform4i));
        gSpy->RegisterSymbol("glUniform1iv", reinterpret_cast<void*>(glUniform1iv));
        gSpy->RegisterSymbol("glUniform2iv", reinterpret_cast<void*>(glUniform2iv));
        gSpy->RegisterSymbol("glUniform3iv", reinterpret_cast<void*>(glUniform3iv));
        gSpy->RegisterSymbol("glUniform4iv", reinterpret_cast<void*>(glUniform4iv));
        gSpy->RegisterSymbol("glUniform1f", reinterpret_cast<void*>(glUniform1f));
        gSpy->RegisterSymbol("glUniform2f", reinterpret_cast<void*>(glUniform2f));
        gSpy->RegisterSymbol("glUniform3f", reinterpret_cast<void*>(glUniform3f));
        gSpy->RegisterSymbol("glUniform4f", reinterpret_cast<void*>(glUniform4f));
        gSpy->RegisterSymbol("glUniform1fv", reinterpret_cast<void*>(glUniform1fv));
        gSpy->RegisterSymbol("glUniform2fv", reinterpret_cast<void*>(glUniform2fv));
        gSpy->RegisterSymbol("glUniform3fv", reinterpret_cast<void*>(glUniform3fv));
        gSpy->RegisterSymbol("glUniform4fv", reinterpret_cast<void*>(glUniform4fv));
        gSpy->RegisterSymbol("glUniformMatrix2fv", reinterpret_cast<void*>(glUniformMatrix2fv));
        gSpy->RegisterSymbol("glUniformMatrix3fv", reinterpret_cast<void*>(glUniformMatrix3fv));
        gSpy->RegisterSymbol("glUniformMatrix4fv", reinterpret_cast<void*>(glUniformMatrix4fv));
        gSpy->RegisterSymbol("glGetUniformfv", reinterpret_cast<void*>(glGetUniformfv));
        gSpy->RegisterSymbol("glGetUniformiv", reinterpret_cast<void*>(glGetUniformiv));
        gSpy->RegisterSymbol("glVertexAttrib1f", reinterpret_cast<void*>(glVertexAttrib1f));
        gSpy->RegisterSymbol("glVertexAttrib2f", reinterpret_cast<void*>(glVertexAttrib2f));
        gSpy->RegisterSymbol("glVertexAttrib3f", reinterpret_cast<void*>(glVertexAttrib3f));
        gSpy->RegisterSymbol("glVertexAttrib4f", reinterpret_cast<void*>(glVertexAttrib4f));
        gSpy->RegisterSymbol("glVertexAttrib1fv", reinterpret_cast<void*>(glVertexAttrib1fv));
        gSpy->RegisterSymbol("glVertexAttrib2fv", reinterpret_cast<void*>(glVertexAttrib2fv));
        gSpy->RegisterSymbol("glVertexAttrib3fv", reinterpret_cast<void*>(glVertexAttrib3fv));
        gSpy->RegisterSymbol("glVertexAttrib4fv", reinterpret_cast<void*>(glVertexAttrib4fv));
        gSpy->RegisterSymbol("glGetShaderPrecisionFormat",
                             reinterpret_cast<void*>(glGetShaderPrecisionFormat));
        gSpy->RegisterSymbol("glDepthMask", reinterpret_cast<void*>(glDepthMask));
        gSpy->RegisterSymbol("glDepthFunc", reinterpret_cast<void*>(glDepthFunc));
        gSpy->RegisterSymbol("glDepthRangef", reinterpret_cast<void*>(glDepthRangef));
        gSpy->RegisterSymbol("glColorMask", reinterpret_cast<void*>(glColorMask));
        gSpy->RegisterSymbol("glStencilMask", reinterpret_cast<void*>(glStencilMask));
        gSpy->RegisterSymbol("glStencilMaskSeparate",
                             reinterpret_cast<void*>(glStencilMaskSeparate));
        gSpy->RegisterSymbol("glStencilFuncSeparate",
                             reinterpret_cast<void*>(glStencilFuncSeparate));
        gSpy->RegisterSymbol("glStencilOpSeparate", reinterpret_cast<void*>(glStencilOpSeparate));
        gSpy->RegisterSymbol("glFrontFace", reinterpret_cast<void*>(glFrontFace));
        gSpy->RegisterSymbol("glViewport", reinterpret_cast<void*>(glViewport));
        gSpy->RegisterSymbol("glScissor", reinterpret_cast<void*>(glScissor));
        gSpy->RegisterSymbol("glActiveTexture", reinterpret_cast<void*>(glActiveTexture));
        gSpy->RegisterSymbol("glGenTextures", reinterpret_cast<void*>(glGenTextures));
        gSpy->RegisterSymbol("glDeleteTextures", reinterpret_cast<void*>(glDeleteTextures));
        gSpy->RegisterSymbol("glIsTexture", reinterpret_cast<void*>(glIsTexture));
        gSpy->RegisterSymbol("glBindTexture", reinterpret_cast<void*>(glBindTexture));
        gSpy->RegisterSymbol("glTexImage2D", reinterpret_cast<void*>(glTexImage2D));
        gSpy->RegisterSymbol("glTexSubImage2D", reinterpret_cast<void*>(glTexSubImage2D));
        gSpy->RegisterSymbol("glCopyTexImage2D", reinterpret_cast<void*>(glCopyTexImage2D));
        gSpy->RegisterSymbol("glCopyTexSubImage2D", reinterpret_cast<void*>(glCopyTexSubImage2D));
        gSpy->RegisterSymbol("glCompressedTexImage2D",
                             reinterpret_cast<void*>(glCompressedTexImage2D));
        gSpy->RegisterSymbol("glCompressedTexSubImage2D",
                             reinterpret_cast<void*>(glCompressedTexSubImage2D));
        gSpy->RegisterSymbol("glGenerateMipmap", reinterpret_cast<void*>(glGenerateMipmap));
        gSpy->RegisterSymbol("glReadPixels", reinterpret_cast<void*>(glReadPixels));
        gSpy->RegisterSymbol("glGenFramebuffers", reinterpret_cast<void*>(glGenFramebuffers));
        gSpy->RegisterSymbol("glBindFramebuffer", reinterpret_cast<void*>(glBindFramebuffer));
        gSpy->RegisterSymbol("glCheckFramebufferStatus",
                             reinterpret_cast<void*>(glCheckFramebufferStatus));
        gSpy->RegisterSymbol("glDeleteFramebuffers", reinterpret_cast<void*>(glDeleteFramebuffers));
        gSpy->RegisterSymbol("glIsFramebuffer", reinterpret_cast<void*>(glIsFramebuffer));
        gSpy->RegisterSymbol("glGenRenderbuffers", reinterpret_cast<void*>(glGenRenderbuffers));
        gSpy->RegisterSymbol("glBindRenderbuffer", reinterpret_cast<void*>(glBindRenderbuffer));
        gSpy->RegisterSymbol("glRenderbufferStorage",
                             reinterpret_cast<void*>(glRenderbufferStorage));
        gSpy->RegisterSymbol("glDeleteRenderbuffers",
                             reinterpret_cast<void*>(glDeleteRenderbuffers));
        gSpy->RegisterSymbol("glIsRenderbuffer", reinterpret_cast<void*>(glIsRenderbuffer));
        gSpy->RegisterSymbol("glGetRenderbufferParameteriv",
                             reinterpret_cast<void*>(glGetRenderbufferParameteriv));
        gSpy->RegisterSymbol("glGenBuffers", reinterpret_cast<void*>(glGenBuffers));
        gSpy->RegisterSymbol("glBindBuffer", reinterpret_cast<void*>(glBindBuffer));
        gSpy->RegisterSymbol("glBufferData", reinterpret_cast<void*>(glBufferData));
        gSpy->RegisterSymbol("glBufferSubData", reinterpret_cast<void*>(glBufferSubData));
        gSpy->RegisterSymbol("glDeleteBuffers", reinterpret_cast<void*>(glDeleteBuffers));
        gSpy->RegisterSymbol("glIsBuffer", reinterpret_cast<void*>(glIsBuffer));
        gSpy->RegisterSymbol("glGetBufferParameteriv",
                             reinterpret_cast<void*>(glGetBufferParameteriv));
        gSpy->RegisterSymbol("glCreateShader", reinterpret_cast<void*>(glCreateShader));
        gSpy->RegisterSymbol("glDeleteShader", reinterpret_cast<void*>(glDeleteShader));
        gSpy->RegisterSymbol("glShaderSource", reinterpret_cast<void*>(glShaderSource));
        gSpy->RegisterSymbol("glShaderBinary", reinterpret_cast<void*>(glShaderBinary));
        gSpy->RegisterSymbol("glGetShaderInfoLog", reinterpret_cast<void*>(glGetShaderInfoLog));
        gSpy->RegisterSymbol("glGetShaderSource", reinterpret_cast<void*>(glGetShaderSource));
        gSpy->RegisterSymbol("glReleaseShaderCompiler",
                             reinterpret_cast<void*>(glReleaseShaderCompiler));
        gSpy->RegisterSymbol("glCompileShader", reinterpret_cast<void*>(glCompileShader));
        gSpy->RegisterSymbol("glIsShader", reinterpret_cast<void*>(glIsShader));
        gSpy->RegisterSymbol("glCreateProgram", reinterpret_cast<void*>(glCreateProgram));
        gSpy->RegisterSymbol("glDeleteProgram", reinterpret_cast<void*>(glDeleteProgram));
        gSpy->RegisterSymbol("glAttachShader", reinterpret_cast<void*>(glAttachShader));
        gSpy->RegisterSymbol("glDetachShader", reinterpret_cast<void*>(glDetachShader));
        gSpy->RegisterSymbol("glGetAttachedShaders", reinterpret_cast<void*>(glGetAttachedShaders));
        gSpy->RegisterSymbol("glLinkProgram", reinterpret_cast<void*>(glLinkProgram));
        gSpy->RegisterSymbol("glGetProgramInfoLog", reinterpret_cast<void*>(glGetProgramInfoLog));
        gSpy->RegisterSymbol("glUseProgram", reinterpret_cast<void*>(glUseProgram));
        gSpy->RegisterSymbol("glIsProgram", reinterpret_cast<void*>(glIsProgram));
        gSpy->RegisterSymbol("glValidateProgram", reinterpret_cast<void*>(glValidateProgram));
        gSpy->RegisterSymbol("glClearColor", reinterpret_cast<void*>(glClearColor));
        gSpy->RegisterSymbol("glClearDepthf", reinterpret_cast<void*>(glClearDepthf));
        gSpy->RegisterSymbol("glClearStencil", reinterpret_cast<void*>(glClearStencil));
        gSpy->RegisterSymbol("glClear", reinterpret_cast<void*>(glClear));
        gSpy->RegisterSymbol("glCullFace", reinterpret_cast<void*>(glCullFace));
        gSpy->RegisterSymbol("glPolygonOffset", reinterpret_cast<void*>(glPolygonOffset));
        gSpy->RegisterSymbol("glLineWidth", reinterpret_cast<void*>(glLineWidth));
        gSpy->RegisterSymbol("glSampleCoverage", reinterpret_cast<void*>(glSampleCoverage));
        gSpy->RegisterSymbol("glHint", reinterpret_cast<void*>(glHint));
        gSpy->RegisterSymbol("glFramebufferRenderbuffer",
                             reinterpret_cast<void*>(glFramebufferRenderbuffer));
        gSpy->RegisterSymbol("glFramebufferTexture2D",
                             reinterpret_cast<void*>(glFramebufferTexture2D));
        gSpy->RegisterSymbol("glGetFramebufferAttachmentParameteriv",
                             reinterpret_cast<void*>(glGetFramebufferAttachmentParameteriv));
        gSpy->RegisterSymbol("glDrawElements", reinterpret_cast<void*>(glDrawElements));
        gSpy->RegisterSymbol("glDrawArrays", reinterpret_cast<void*>(glDrawArrays));
        gSpy->RegisterSymbol("glFlush", reinterpret_cast<void*>(glFlush));
        gSpy->RegisterSymbol("glFinish", reinterpret_cast<void*>(glFinish));
        gSpy->RegisterSymbol("glGetBooleanv", reinterpret_cast<void*>(glGetBooleanv));
        gSpy->RegisterSymbol("glGetFloatv", reinterpret_cast<void*>(glGetFloatv));
        gSpy->RegisterSymbol("glGetIntegerv", reinterpret_cast<void*>(glGetIntegerv));
        gSpy->RegisterSymbol("glGetString", reinterpret_cast<void*>(glGetString));
        gSpy->RegisterSymbol("glEnable", reinterpret_cast<void*>(glEnable));
        gSpy->RegisterSymbol("glDisable", reinterpret_cast<void*>(glDisable));
        gSpy->RegisterSymbol("glIsEnabled", reinterpret_cast<void*>(glIsEnabled));
        gSpy->RegisterSymbol("glMapBufferRange", reinterpret_cast<void*>(glMapBufferRange));
        gSpy->RegisterSymbol("glUnmapBuffer", reinterpret_cast<void*>(glUnmapBuffer));
        gSpy->RegisterSymbol("glInvalidateFramebuffer",
                             reinterpret_cast<void*>(glInvalidateFramebuffer));
        gSpy->RegisterSymbol("glRenderbufferStorageMultisample",
                             reinterpret_cast<void*>(glRenderbufferStorageMultisample));
        gSpy->RegisterSymbol("glBlitFramebuffer", reinterpret_cast<void*>(glBlitFramebuffer));
        gSpy->RegisterSymbol("glGenQueries", reinterpret_cast<void*>(glGenQueries));
        gSpy->RegisterSymbol("glBeginQuery", reinterpret_cast<void*>(glBeginQuery));
        gSpy->RegisterSymbol("glEndQuery", reinterpret_cast<void*>(glEndQuery));
        gSpy->RegisterSymbol("glDeleteQueries", reinterpret_cast<void*>(glDeleteQueries));
        gSpy->RegisterSymbol("glIsQuery", reinterpret_cast<void*>(glIsQuery));
        gSpy->RegisterSymbol("glGetQueryiv", reinterpret_cast<void*>(glGetQueryiv));
        gSpy->RegisterSymbol("glGetQueryObjectuiv", reinterpret_cast<void*>(glGetQueryObjectuiv));
        gSpy->RegisterSymbol("glGenQueriesEXT", reinterpret_cast<void*>(glGenQueriesEXT));
        gSpy->RegisterSymbol("glBeginQueryEXT", reinterpret_cast<void*>(glBeginQueryEXT));
        gSpy->RegisterSymbol("glEndQueryEXT", reinterpret_cast<void*>(glEndQueryEXT));
        gSpy->RegisterSymbol("glDeleteQueriesEXT", reinterpret_cast<void*>(glDeleteQueriesEXT));
        gSpy->RegisterSymbol("glIsQueryEXT", reinterpret_cast<void*>(glIsQueryEXT));
        gSpy->RegisterSymbol("glQueryCounterEXT", reinterpret_cast<void*>(glQueryCounterEXT));
        gSpy->RegisterSymbol("glGetQueryivEXT", reinterpret_cast<void*>(glGetQueryivEXT));
        gSpy->RegisterSymbol("glGetQueryObjectivEXT",
                             reinterpret_cast<void*>(glGetQueryObjectivEXT));
        gSpy->RegisterSymbol("glGetQueryObjectuivEXT",
                             reinterpret_cast<void*>(glGetQueryObjectuivEXT));
        gSpy->RegisterSymbol("glGetQueryObjecti64vEXT",
                             reinterpret_cast<void*>(glGetQueryObjecti64vEXT));
        gSpy->RegisterSymbol("glGetQueryObjectui64vEXT",
                             reinterpret_cast<void*>(glGetQueryObjectui64vEXT));
        gSpy->RegisterSymbol("eglGetProcAddress", reinterpret_cast<void*>(eglGetProcAddress));
        gSpy->RegisterSymbol("wglGetProcAddress", reinterpret_cast<void*>(wglGetProcAddress));
        gSpy->RegisterSymbol("glXGetProcAddress", reinterpret_cast<void*>(glXGetProcAddress));
        gSpy->RegisterSymbol("glXGetProcAddressARB", reinterpret_cast<void*>(glXGetProcAddressARB));
        initializedOnce = true;
    }
    return gSpy.get();
}

void* STDCALL GetSpyProcAddress(const char* name) {
    if (void* proc = spy()->LookupSymbol(name)) {
        return proc;
    } else {
        GAPID_WARNING("%s will NOT be captured.\n", name);
        return gapic::GetGfxProcAddress(name, true);
    }
}

}  // anonymous namespace

extern "C" {

EXPORT int STDCALL eglInitialize(void* dpy, int* major, int* minor) {
    GAPID_INFO("eglInitialize()\n");
    return spy()->eglInitialize(dpy, major, minor);
}
EXPORT void* STDCALL
eglCreateContext(void* display, void* config, void* share_context, int* attrib_list) {
    GAPID_INFO("eglCreateContext()\n");
    return spy()->eglCreateContext(display, config, share_context, attrib_list);
}
EXPORT int STDCALL eglMakeCurrent(void* display, void* draw, void* read, void* context) {
    GAPID_INFO("eglMakeCurrent()\n");
    return spy()->eglMakeCurrent(display, draw, read, context);
}
EXPORT int STDCALL eglSwapBuffers(void* display, void* surface) {
    GAPID_INFO("eglSwapBuffers()\n");
    return spy()->eglSwapBuffers(display, surface);
}
EXPORT int STDCALL eglQuerySurface(void* display, void* surface, int attribute, int* value) {
    GAPID_INFO("eglQuerySurface()\n");
    return spy()->eglQuerySurface(display, surface, attribute, value);
}
EXPORT void* STDCALL glXCreateContext(void* dpy, void* vis, void* shareList, bool direct) {
    GAPID_INFO("glXCreateContext()\n");
    return spy()->glXCreateContext(dpy, vis, shareList, direct);
}
EXPORT void* STDCALL
glXCreateNewContext(void* display, void* fbconfig, uint32_t type, void* shared, bool direct) {
    GAPID_INFO("glXCreateNewContext()\n");
    return spy()->glXCreateNewContext(display, fbconfig, type, shared, direct);
}
EXPORT void STDCALL glXMakeContextCurrent(void* display, void* draw, void* read, void* ctx) {
    GAPID_INFO("glXMakeContextCurrent()\n");
    spy()->glXMakeContextCurrent(display, draw, read, ctx);
}
EXPORT void STDCALL glXSwapBuffers(void* display, void* drawable) {
    GAPID_INFO("glXSwapBuffers()\n");
    spy()->glXSwapBuffers(display, drawable);
}
EXPORT void* STDCALL wglCreateContext(void* hdc) {
    GAPID_INFO("wglCreateContext()\n");
    return spy()->wglCreateContext(hdc);
}
EXPORT void* STDCALL wglCreateContextAttribsARB(void* hdc, void* hShareContext, int* attribList) {
    GAPID_INFO("wglCreateContextAttribsARB()\n");
    return spy()->wglCreateContextAttribsARB(hdc, hShareContext, attribList);
}
EXPORT int STDCALL wglMakeCurrent(void* hdc, void* hglrc) {
    GAPID_INFO("wglMakeCurrent()\n");
    return spy()->wglMakeCurrent(hdc, hglrc);
}
EXPORT void STDCALL wglSwapBuffers(void* hdc) {
    GAPID_INFO("wglSwapBuffers()\n");
    spy()->wglSwapBuffers(hdc);
}
EXPORT int STDCALL CGLCreateContext(void* pix, void* share, void** ctx) {
    GAPID_INFO("CGLCreateContext()\n");
    return spy()->CGLCreateContext(pix, share, ctx);
}
EXPORT int STDCALL CGLSetCurrentContext(void* ctx) {
    GAPID_INFO("CGLSetCurrentContext()\n");
    return spy()->CGLSetCurrentContext(ctx);
}
EXPORT void STDCALL glEnableClientState(uint32_t type) {
    GAPID_INFO("glEnableClientState()\n");
    spy()->glEnableClientState(type);
}
EXPORT void STDCALL glDisableClientState(uint32_t type) {
    GAPID_INFO("glDisableClientState()\n");
    spy()->glDisableClientState(type);
}
EXPORT void STDCALL glGetProgramBinaryOES(uint32_t program, int32_t buffer_size,
                                          int32_t* bytes_written, uint32_t* binary_format,
                                          void* binary) {
    GAPID_INFO("glGetProgramBinaryOES()\n");
    spy()->glGetProgramBinaryOES(program, buffer_size, bytes_written, binary_format, binary);
}
EXPORT void STDCALL
glProgramBinaryOES(uint32_t program, uint32_t binary_format, void* binary, int32_t binary_size) {
    GAPID_INFO("glProgramBinaryOES()\n");
    spy()->glProgramBinaryOES(program, binary_format, binary, binary_size);
}
EXPORT void STDCALL
glStartTilingQCOM(int32_t x, int32_t y, int32_t width, int32_t height, uint32_t preserveMask) {
    GAPID_INFO("glStartTilingQCOM()\n");
    spy()->glStartTilingQCOM(x, y, width, height, preserveMask);
}
EXPORT void STDCALL glEndTilingQCOM(uint32_t preserve_mask) {
    GAPID_INFO("glEndTilingQCOM()\n");
    spy()->glEndTilingQCOM(preserve_mask);
}
EXPORT void STDCALL
glDiscardFramebufferEXT(uint32_t target, int32_t numAttachments, uint32_t* attachments) {
    GAPID_INFO("glDiscardFramebufferEXT()\n");
    spy()->glDiscardFramebufferEXT(target, numAttachments, attachments);
}
EXPORT void STDCALL glInsertEventMarkerEXT(int32_t length, char* marker) {
    GAPID_INFO("glInsertEventMarkerEXT()\n");
    spy()->glInsertEventMarkerEXT(length, marker);
}
EXPORT void STDCALL glPushGroupMarkerEXT(int32_t length, char* marker) {
    GAPID_INFO("glPushGroupMarkerEXT()\n");
    spy()->glPushGroupMarkerEXT(length, marker);
}
EXPORT void STDCALL glPopGroupMarkerEXT() {
    GAPID_INFO("glPopGroupMarkerEXT()\n");
    spy()->glPopGroupMarkerEXT();
}
EXPORT void STDCALL
glTexStorage1DEXT(uint32_t target, int32_t levels, uint32_t format, int32_t width) {
    GAPID_INFO("glTexStorage1DEXT()\n");
    spy()->glTexStorage1DEXT(target, levels, format, width);
}
EXPORT void STDCALL
glTexStorage2DEXT(uint32_t target, int32_t levels, uint32_t format, int32_t width, int32_t height) {
    GAPID_INFO("glTexStorage2DEXT()\n");
    spy()->glTexStorage2DEXT(target, levels, format, width, height);
}
EXPORT void STDCALL glTexStorage3DEXT(uint32_t target, int32_t levels, uint32_t format,
                                      int32_t width, int32_t height, int32_t depth) {
    GAPID_INFO("glTexStorage3DEXT()\n");
    spy()->glTexStorage3DEXT(target, levels, format, width, height, depth);
}
EXPORT void STDCALL glTextureStorage1DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width) {
    GAPID_INFO("glTextureStorage1DEXT()\n");
    spy()->glTextureStorage1DEXT(texture, target, levels, format, width);
}
EXPORT void STDCALL glTextureStorage2DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width, int32_t height) {
    GAPID_INFO("glTextureStorage2DEXT()\n");
    spy()->glTextureStorage2DEXT(texture, target, levels, format, width, height);
}
EXPORT void STDCALL glTextureStorage3DEXT(uint32_t texture, uint32_t target, int32_t levels,
                                          uint32_t format, int32_t width, int32_t height,
                                          int32_t depth) {
    GAPID_INFO("glTextureStorage3DEXT()\n");
    spy()->glTextureStorage3DEXT(texture, target, levels, format, width, height, depth);
}
EXPORT void STDCALL glGenVertexArraysOES(int32_t count, uint32_t* arrays) {
    GAPID_INFO("glGenVertexArraysOES()\n");
    spy()->glGenVertexArraysOES(count, arrays);
}
EXPORT void STDCALL glBindVertexArrayOES(uint32_t array) {
    GAPID_INFO("glBindVertexArrayOES()\n");
    spy()->glBindVertexArrayOES(array);
}
EXPORT void STDCALL glDeleteVertexArraysOES(int32_t count, uint32_t* arrays) {
    GAPID_INFO("glDeleteVertexArraysOES()\n");
    spy()->glDeleteVertexArraysOES(count, arrays);
}
EXPORT bool STDCALL glIsVertexArrayOES(uint32_t array) {
    GAPID_INFO("glIsVertexArrayOES()\n");
    return spy()->glIsVertexArrayOES(array);
}
EXPORT void STDCALL glEGLImageTargetTexture2DOES(uint32_t target, void* image) {
    GAPID_INFO("glEGLImageTargetTexture2DOES()\n");
    spy()->glEGLImageTargetTexture2DOES(target, image);
}
EXPORT void STDCALL glEGLImageTargetRenderbufferStorageOES(uint32_t target, void* image) {
    GAPID_INFO("glEGLImageTargetRenderbufferStorageOES()\n");
    spy()->glEGLImageTargetRenderbufferStorageOES(target, image);
}
EXPORT uint32_t STDCALL glGetGraphicsResetStatusEXT() {
    GAPID_INFO("glGetGraphicsResetStatusEXT()\n");
    return spy()->glGetGraphicsResetStatusEXT();
}
EXPORT void STDCALL glBindAttribLocation(uint32_t program, uint32_t location, char* name) {
    GAPID_INFO("glBindAttribLocation()\n");
    spy()->glBindAttribLocation(program, location, name);
}
EXPORT void STDCALL glBlendFunc(uint32_t src_factor, uint32_t dst_factor) {
    GAPID_INFO("glBlendFunc()\n");
    spy()->glBlendFunc(src_factor, dst_factor);
}
EXPORT void STDCALL glBlendFuncSeparate(uint32_t src_factor_rgb, uint32_t dst_factor_rgb,
                                        uint32_t src_factor_alpha, uint32_t dst_factor_alpha) {
    GAPID_INFO("glBlendFuncSeparate()\n");
    spy()->glBlendFuncSeparate(src_factor_rgb, dst_factor_rgb, src_factor_alpha, dst_factor_alpha);
}
EXPORT void STDCALL glBlendEquation(uint32_t equation) {
    GAPID_INFO("glBlendEquation()\n");
    spy()->glBlendEquation(equation);
}
EXPORT void STDCALL glBlendEquationSeparate(uint32_t rgb, uint32_t alpha) {
    GAPID_INFO("glBlendEquationSeparate()\n");
    spy()->glBlendEquationSeparate(rgb, alpha);
}
EXPORT void STDCALL glBlendColor(float red, float green, float blue, float alpha) {
    GAPID_INFO("glBlendColor()\n");
    spy()->glBlendColor(red, green, blue, alpha);
}
EXPORT void STDCALL glEnableVertexAttribArray(uint32_t location) {
    GAPID_INFO("glEnableVertexAttribArray()\n");
    spy()->glEnableVertexAttribArray(location);
}
EXPORT void STDCALL glDisableVertexAttribArray(uint32_t location) {
    GAPID_INFO("glDisableVertexAttribArray()\n");
    spy()->glDisableVertexAttribArray(location);
}
EXPORT void STDCALL glVertexAttribPointer(uint32_t location, int32_t size, uint32_t type,
                                          bool normalized, int32_t stride, void* data) {
    GAPID_INFO("glVertexAttribPointer()\n");
    spy()->glVertexAttribPointer(location, size, type, normalized, stride, data);
}
EXPORT void STDCALL glGetActiveAttrib(uint32_t program, uint32_t location, int32_t buffer_size,
                                      int32_t* buffer_bytes_written, int32_t* vector_count,
                                      uint32_t* type, char* name) {
    GAPID_INFO("glGetActiveAttrib()\n");
    spy()->glGetActiveAttrib(program, location, buffer_size, buffer_bytes_written, vector_count,
                             type, name);
}
EXPORT void STDCALL glGetActiveUniform(uint32_t program, int32_t location, int32_t buffer_size,
                                       int32_t* buffer_bytes_written, int32_t* vector_count,
                                       uint32_t* type, char* name) {
    GAPID_INFO("glGetActiveUniform()\n");
    spy()->glGetActiveUniform(program, location, buffer_size, buffer_bytes_written, vector_count,
                              type, name);
}
EXPORT uint32_t STDCALL glGetError() {
    GAPID_INFO("glGetError()\n");
    return spy()->glGetError();
}
EXPORT void STDCALL glGetProgramiv(uint32_t program, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetProgramiv()\n");
    spy()->glGetProgramiv(program, parameter, value);
}
EXPORT void STDCALL glGetShaderiv(uint32_t shader, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetShaderiv()\n");
    spy()->glGetShaderiv(shader, parameter, value);
}
EXPORT int32_t STDCALL glGetUniformLocation(uint32_t program, char* name) {
    GAPID_INFO("glGetUniformLocation()\n");
    return spy()->glGetUniformLocation(program, name);
}
EXPORT uint32_t STDCALL glGetAttribLocation(uint32_t program, char* name) {
    GAPID_INFO("glGetAttribLocation()\n");
    return spy()->glGetAttribLocation(program, name);
}
EXPORT void STDCALL glPixelStorei(uint32_t parameter, int32_t value) {
    GAPID_INFO("glPixelStorei()\n");
    spy()->glPixelStorei(parameter, value);
}
EXPORT void STDCALL glTexParameteri(uint32_t target, uint32_t parameter, int32_t value) {
    GAPID_INFO("glTexParameteri()\n");
    spy()->glTexParameteri(target, parameter, value);
}
EXPORT void STDCALL glTexParameterf(uint32_t target, uint32_t parameter, float value) {
    GAPID_INFO("glTexParameterf()\n");
    spy()->glTexParameterf(target, parameter, value);
}
EXPORT void STDCALL glGetTexParameteriv(uint32_t target, uint32_t parameter, int32_t* values) {
    GAPID_INFO("glGetTexParameteriv()\n");
    spy()->glGetTexParameteriv(target, parameter, values);
}
EXPORT void STDCALL glGetTexParameterfv(uint32_t target, uint32_t parameter, float* values) {
    GAPID_INFO("glGetTexParameterfv()\n");
    spy()->glGetTexParameterfv(target, parameter, values);
}
EXPORT void STDCALL glUniform1i(int32_t location, int32_t value) {
    GAPID_INFO("glUniform1i()\n");
    spy()->glUniform1i(location, value);
}
EXPORT void STDCALL glUniform2i(int32_t location, int32_t value0, int32_t value1) {
    GAPID_INFO("glUniform2i()\n");
    spy()->glUniform2i(location, value0, value1);
}
EXPORT void STDCALL glUniform3i(int32_t location, int32_t value0, int32_t value1, int32_t value2) {
    GAPID_INFO("glUniform3i()\n");
    spy()->glUniform3i(location, value0, value1, value2);
}
EXPORT void STDCALL
glUniform4i(int32_t location, int32_t value0, int32_t value1, int32_t value2, int32_t value3) {
    GAPID_INFO("glUniform4i()\n");
    spy()->glUniform4i(location, value0, value1, value2, value3);
}
EXPORT void STDCALL glUniform1iv(int32_t location, int32_t count, int32_t* value) {
    GAPID_INFO("glUniform1iv()\n");
    spy()->glUniform1iv(location, count, value);
}
EXPORT void STDCALL glUniform2iv(int32_t location, int32_t count, int32_t* value) {
    GAPID_INFO("glUniform2iv()\n");
    spy()->glUniform2iv(location, count, value);
}
EXPORT void STDCALL glUniform3iv(int32_t location, int32_t count, int32_t* value) {
    GAPID_INFO("glUniform3iv()\n");
    spy()->glUniform3iv(location, count, value);
}
EXPORT void STDCALL glUniform4iv(int32_t location, int32_t count, int32_t* value) {
    GAPID_INFO("glUniform4iv()\n");
    spy()->glUniform4iv(location, count, value);
}
EXPORT void STDCALL glUniform1f(int32_t location, float value) {
    GAPID_INFO("glUniform1f()\n");
    spy()->glUniform1f(location, value);
}
EXPORT void STDCALL glUniform2f(int32_t location, float value0, float value1) {
    GAPID_INFO("glUniform2f()\n");
    spy()->glUniform2f(location, value0, value1);
}
EXPORT void STDCALL glUniform3f(int32_t location, float value0, float value1, float value2) {
    GAPID_INFO("glUniform3f()\n");
    spy()->glUniform3f(location, value0, value1, value2);
}
EXPORT void STDCALL
glUniform4f(int32_t location, float value0, float value1, float value2, float value3) {
    GAPID_INFO("glUniform4f()\n");
    spy()->glUniform4f(location, value0, value1, value2, value3);
}
EXPORT void STDCALL glUniform1fv(int32_t location, int32_t count, float* value) {
    GAPID_INFO("glUniform1fv()\n");
    spy()->glUniform1fv(location, count, value);
}
EXPORT void STDCALL glUniform2fv(int32_t location, int32_t count, float* value) {
    GAPID_INFO("glUniform2fv()\n");
    spy()->glUniform2fv(location, count, value);
}
EXPORT void STDCALL glUniform3fv(int32_t location, int32_t count, float* value) {
    GAPID_INFO("glUniform3fv()\n");
    spy()->glUniform3fv(location, count, value);
}
EXPORT void STDCALL glUniform4fv(int32_t location, int32_t count, float* value) {
    GAPID_INFO("glUniform4fv()\n");
    spy()->glUniform4fv(location, count, value);
}
EXPORT void STDCALL
glUniformMatrix2fv(int32_t location, int32_t count, bool transpose, float* values) {
    GAPID_INFO("glUniformMatrix2fv()\n");
    spy()->glUniformMatrix2fv(location, count, transpose, values);
}
EXPORT void STDCALL
glUniformMatrix3fv(int32_t location, int32_t count, bool transpose, float* values) {
    GAPID_INFO("glUniformMatrix3fv()\n");
    spy()->glUniformMatrix3fv(location, count, transpose, values);
}
EXPORT void STDCALL
glUniformMatrix4fv(int32_t location, int32_t count, bool transpose, float* values) {
    GAPID_INFO("glUniformMatrix4fv()\n");
    spy()->glUniformMatrix4fv(location, count, transpose, values);
}
EXPORT void STDCALL glGetUniformfv(uint32_t program, int32_t location, float* values) {
    GAPID_INFO("glGetUniformfv()\n");
    spy()->glGetUniformfv(program, location, values);
}
EXPORT void STDCALL glGetUniformiv(uint32_t program, int32_t location, int32_t* values) {
    GAPID_INFO("glGetUniformiv()\n");
    spy()->glGetUniformiv(program, location, values);
}
EXPORT void STDCALL glVertexAttrib1f(uint32_t location, float value0) {
    GAPID_INFO("glVertexAttrib1f()\n");
    spy()->glVertexAttrib1f(location, value0);
}
EXPORT void STDCALL glVertexAttrib2f(uint32_t location, float value0, float value1) {
    GAPID_INFO("glVertexAttrib2f()\n");
    spy()->glVertexAttrib2f(location, value0, value1);
}
EXPORT void STDCALL glVertexAttrib3f(uint32_t location, float value0, float value1, float value2) {
    GAPID_INFO("glVertexAttrib3f()\n");
    spy()->glVertexAttrib3f(location, value0, value1, value2);
}
EXPORT void STDCALL
glVertexAttrib4f(uint32_t location, float value0, float value1, float value2, float value3) {
    GAPID_INFO("glVertexAttrib4f()\n");
    spy()->glVertexAttrib4f(location, value0, value1, value2, value3);
}
EXPORT void STDCALL glVertexAttrib1fv(uint32_t location, float* value) {
    GAPID_INFO("glVertexAttrib1fv()\n");
    spy()->glVertexAttrib1fv(location, value);
}
EXPORT void STDCALL glVertexAttrib2fv(uint32_t location, float* value) {
    GAPID_INFO("glVertexAttrib2fv()\n");
    spy()->glVertexAttrib2fv(location, value);
}
EXPORT void STDCALL glVertexAttrib3fv(uint32_t location, float* value) {
    GAPID_INFO("glVertexAttrib3fv()\n");
    spy()->glVertexAttrib3fv(location, value);
}
EXPORT void STDCALL glVertexAttrib4fv(uint32_t location, float* value) {
    GAPID_INFO("glVertexAttrib4fv()\n");
    spy()->glVertexAttrib4fv(location, value);
}
EXPORT void STDCALL glGetShaderPrecisionFormat(uint32_t shader_type, uint32_t precision_type,
                                               int32_t* range, int32_t* precision) {
    GAPID_INFO("glGetShaderPrecisionFormat()\n");
    spy()->glGetShaderPrecisionFormat(shader_type, precision_type, range, precision);
}
EXPORT void STDCALL glDepthMask(bool enabled) {
    GAPID_INFO("glDepthMask()\n");
    spy()->glDepthMask(enabled);
}
EXPORT void STDCALL glDepthFunc(uint32_t function) {
    GAPID_INFO("glDepthFunc()\n");
    spy()->glDepthFunc(function);
}
EXPORT void STDCALL glDepthRangef(float near, float far) {
    GAPID_INFO("glDepthRangef()\n");
    spy()->glDepthRangef(near, far);
}
EXPORT void STDCALL glColorMask(bool red, bool green, bool blue, bool alpha) {
    GAPID_INFO("glColorMask()\n");
    spy()->glColorMask(red, green, blue, alpha);
}
EXPORT void STDCALL glStencilMask(uint32_t mask) {
    GAPID_INFO("glStencilMask()\n");
    spy()->glStencilMask(mask);
}
EXPORT void STDCALL glStencilMaskSeparate(uint32_t face, uint32_t mask) {
    GAPID_INFO("glStencilMaskSeparate()\n");
    spy()->glStencilMaskSeparate(face, mask);
}
EXPORT void STDCALL
glStencilFuncSeparate(uint32_t face, uint32_t function, int32_t reference_value, int32_t mask) {
    GAPID_INFO("glStencilFuncSeparate()\n");
    spy()->glStencilFuncSeparate(face, function, reference_value, mask);
}
EXPORT void STDCALL glStencilOpSeparate(uint32_t face, uint32_t stencil_fail,
                                        uint32_t stencil_pass_depth_fail,
                                        uint32_t stencil_pass_depth_pass) {
    GAPID_INFO("glStencilOpSeparate()\n");
    spy()->glStencilOpSeparate(face, stencil_fail, stencil_pass_depth_fail,
                               stencil_pass_depth_pass);
}
EXPORT void STDCALL glFrontFace(uint32_t orientation) {
    GAPID_INFO("glFrontFace()\n");
    spy()->glFrontFace(orientation);
}
EXPORT void STDCALL glViewport(int32_t x, int32_t y, int32_t width, int32_t height) {
    GAPID_INFO("glViewport()\n");
    spy()->glViewport(x, y, width, height);
}
EXPORT void STDCALL glScissor(int32_t x, int32_t y, int32_t width, int32_t height) {
    GAPID_INFO("glScissor()\n");
    spy()->glScissor(x, y, width, height);
}
EXPORT void STDCALL glActiveTexture(uint32_t unit) {
    GAPID_INFO("glActiveTexture()\n");
    spy()->glActiveTexture(unit);
}
EXPORT void STDCALL glGenTextures(int32_t count, uint32_t* textures) {
    GAPID_INFO("glGenTextures()\n");
    spy()->glGenTextures(count, textures);
}
EXPORT void STDCALL glDeleteTextures(int32_t count, uint32_t* textures) {
    GAPID_INFO("glDeleteTextures()\n");
    spy()->glDeleteTextures(count, textures);
}
EXPORT bool STDCALL glIsTexture(uint32_t texture) {
    GAPID_INFO("glIsTexture()\n");
    return spy()->glIsTexture(texture);
}
EXPORT void STDCALL glBindTexture(uint32_t target, uint32_t texture) {
    GAPID_INFO("glBindTexture()\n");
    spy()->glBindTexture(target, texture);
}
EXPORT void STDCALL glTexImage2D(uint32_t target, int32_t level, uint32_t internal_format,
                                 int32_t width, int32_t height, int32_t border, uint32_t format,
                                 uint32_t type, void* data) {
    GAPID_INFO("glTexImage2D()\n");
    spy()->glTexImage2D(target, level, internal_format, width, height, border, format, type, data);
}
EXPORT void STDCALL glTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                    int32_t yoffset, int32_t width, int32_t height, uint32_t format,
                                    uint32_t type, void* data) {
    GAPID_INFO("glTexSubImage2D()\n");
    spy()->glTexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, data);
}
EXPORT void STDCALL glCopyTexImage2D(uint32_t target, int32_t level, uint32_t format, int32_t x,
                                     int32_t y, int32_t width, int32_t height, int32_t border) {
    GAPID_INFO("glCopyTexImage2D()\n");
    spy()->glCopyTexImage2D(target, level, format, x, y, width, height, border);
}
EXPORT void STDCALL glCopyTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                        int32_t yoffset, int32_t x, int32_t y, int32_t width,
                                        int32_t height) {
    GAPID_INFO("glCopyTexSubImage2D()\n");
    spy()->glCopyTexSubImage2D(target, level, xoffset, yoffset, x, y, width, height);
}
EXPORT void STDCALL glCompressedTexImage2D(uint32_t target, int32_t level, uint32_t format,
                                           int32_t width, int32_t height, int32_t border,
                                           int32_t image_size, void* data) {
    GAPID_INFO("glCompressedTexImage2D()\n");
    spy()->glCompressedTexImage2D(target, level, format, width, height, border, image_size, data);
}
EXPORT void STDCALL glCompressedTexSubImage2D(uint32_t target, int32_t level, int32_t xoffset,
                                              int32_t yoffset, int32_t width, int32_t height,
                                              uint32_t format, int32_t image_size, void* data) {
    GAPID_INFO("glCompressedTexSubImage2D()\n");
    spy()->glCompressedTexSubImage2D(target, level, xoffset, yoffset, width, height, format,
                                     image_size, data);
}
EXPORT void STDCALL glGenerateMipmap(uint32_t target) {
    GAPID_INFO("glGenerateMipmap()\n");
    spy()->glGenerateMipmap(target);
}
EXPORT void STDCALL glReadPixels(int32_t x, int32_t y, int32_t width, int32_t height,
                                 uint32_t format, uint32_t type, void* data) {
    GAPID_INFO("glReadPixels()\n");
    spy()->glReadPixels(x, y, width, height, format, type, data);
}
EXPORT void STDCALL glGenFramebuffers(int32_t count, uint32_t* framebuffers) {
    GAPID_INFO("glGenFramebuffers()\n");
    spy()->glGenFramebuffers(count, framebuffers);
}
EXPORT void STDCALL glBindFramebuffer(uint32_t target, uint32_t framebuffer) {
    GAPID_INFO("glBindFramebuffer()\n");
    spy()->glBindFramebuffer(target, framebuffer);
}
EXPORT uint32_t STDCALL glCheckFramebufferStatus(uint32_t target) {
    GAPID_INFO("glCheckFramebufferStatus()\n");
    return spy()->glCheckFramebufferStatus(target);
}
EXPORT void STDCALL glDeleteFramebuffers(int32_t count, uint32_t* framebuffers) {
    GAPID_INFO("glDeleteFramebuffers()\n");
    spy()->glDeleteFramebuffers(count, framebuffers);
}
EXPORT bool STDCALL glIsFramebuffer(uint32_t framebuffer) {
    GAPID_INFO("glIsFramebuffer()\n");
    return spy()->glIsFramebuffer(framebuffer);
}
EXPORT void STDCALL glGenRenderbuffers(int32_t count, uint32_t* renderbuffers) {
    GAPID_INFO("glGenRenderbuffers()\n");
    spy()->glGenRenderbuffers(count, renderbuffers);
}
EXPORT void STDCALL glBindRenderbuffer(uint32_t target, uint32_t renderbuffer) {
    GAPID_INFO("glBindRenderbuffer()\n");
    spy()->glBindRenderbuffer(target, renderbuffer);
}
EXPORT void STDCALL
glRenderbufferStorage(uint32_t target, uint32_t format, int32_t width, int32_t height) {
    GAPID_INFO("glRenderbufferStorage()\n");
    spy()->glRenderbufferStorage(target, format, width, height);
}
EXPORT void STDCALL glDeleteRenderbuffers(int32_t count, uint32_t* renderbuffers) {
    GAPID_INFO("glDeleteRenderbuffers()\n");
    spy()->glDeleteRenderbuffers(count, renderbuffers);
}
EXPORT bool STDCALL glIsRenderbuffer(uint32_t renderbuffer) {
    GAPID_INFO("glIsRenderbuffer()\n");
    return spy()->glIsRenderbuffer(renderbuffer);
}
EXPORT void STDCALL
glGetRenderbufferParameteriv(uint32_t target, uint32_t parameter, int32_t* values) {
    GAPID_INFO("glGetRenderbufferParameteriv()\n");
    spy()->glGetRenderbufferParameteriv(target, parameter, values);
}
EXPORT void STDCALL glGenBuffers(int32_t count, uint32_t* buffers) {
    GAPID_INFO("glGenBuffers()\n");
    spy()->glGenBuffers(count, buffers);
}
EXPORT void STDCALL glBindBuffer(uint32_t target, uint32_t buffer) {
    GAPID_INFO("glBindBuffer()\n");
    spy()->glBindBuffer(target, buffer);
}
EXPORT void STDCALL glBufferData(uint32_t target, int32_t size, void* data, uint32_t usage) {
    GAPID_INFO("glBufferData()\n");
    spy()->glBufferData(target, size, data, usage);
}
EXPORT void STDCALL glBufferSubData(uint32_t target, int32_t offset, int32_t size, void* data) {
    GAPID_INFO("glBufferSubData()\n");
    spy()->glBufferSubData(target, offset, size, data);
}
EXPORT void STDCALL glDeleteBuffers(int32_t count, uint32_t* buffers) {
    GAPID_INFO("glDeleteBuffers()\n");
    spy()->glDeleteBuffers(count, buffers);
}
EXPORT bool STDCALL glIsBuffer(uint32_t buffer) {
    GAPID_INFO("glIsBuffer()\n");
    return spy()->glIsBuffer(buffer);
}
EXPORT void STDCALL glGetBufferParameteriv(uint32_t target, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetBufferParameteriv()\n");
    spy()->glGetBufferParameteriv(target, parameter, value);
}
EXPORT uint32_t STDCALL glCreateShader(uint32_t type) {
    GAPID_INFO("glCreateShader()\n");
    return spy()->glCreateShader(type);
}
EXPORT void STDCALL glDeleteShader(uint32_t shader) {
    GAPID_INFO("glDeleteShader()\n");
    spy()->glDeleteShader(shader);
}
EXPORT void STDCALL glShaderSource(uint32_t shader, int32_t count, char** source, int32_t* length) {
    GAPID_INFO("glShaderSource()\n");
    spy()->glShaderSource(shader, count, source, length);
}
EXPORT void STDCALL glShaderBinary(int32_t count, uint32_t* shaders, uint32_t binary_format,
                                   void* binary, int32_t binary_size) {
    GAPID_INFO("glShaderBinary()\n");
    spy()->glShaderBinary(count, shaders, binary_format, binary, binary_size);
}
EXPORT void STDCALL glGetShaderInfoLog(uint32_t shader, int32_t buffer_length,
                                       int32_t* string_length_written, char* info) {
    GAPID_INFO("glGetShaderInfoLog()\n");
    spy()->glGetShaderInfoLog(shader, buffer_length, string_length_written, info);
}
EXPORT void STDCALL glGetShaderSource(uint32_t shader, int32_t buffer_length,
                                      int32_t* string_length_written, char* source) {
    GAPID_INFO("glGetShaderSource()\n");
    spy()->glGetShaderSource(shader, buffer_length, string_length_written, source);
}
EXPORT void STDCALL glReleaseShaderCompiler() {
    GAPID_INFO("glReleaseShaderCompiler()\n");
    spy()->glReleaseShaderCompiler();
}
EXPORT void STDCALL glCompileShader(uint32_t shader) {
    GAPID_INFO("glCompileShader()\n");
    spy()->glCompileShader(shader);
}
EXPORT bool STDCALL glIsShader(uint32_t shader) {
    GAPID_INFO("glIsShader()\n");
    return spy()->glIsShader(shader);
}
EXPORT uint32_t STDCALL glCreateProgram() {
    GAPID_INFO("glCreateProgram()\n");
    return spy()->glCreateProgram();
}
EXPORT void STDCALL glDeleteProgram(uint32_t program) {
    GAPID_INFO("glDeleteProgram()\n");
    spy()->glDeleteProgram(program);
}
EXPORT void STDCALL glAttachShader(uint32_t program, uint32_t shader) {
    GAPID_INFO("glAttachShader()\n");
    spy()->glAttachShader(program, shader);
}
EXPORT void STDCALL glDetachShader(uint32_t program, uint32_t shader) {
    GAPID_INFO("glDetachShader()\n");
    spy()->glDetachShader(program, shader);
}
EXPORT void STDCALL glGetAttachedShaders(uint32_t program, int32_t buffer_length,
                                         int32_t* shaders_length_written, uint32_t* shaders) {
    GAPID_INFO("glGetAttachedShaders()\n");
    spy()->glGetAttachedShaders(program, buffer_length, shaders_length_written, shaders);
}
EXPORT void STDCALL glLinkProgram(uint32_t program) {
    GAPID_INFO("glLinkProgram()\n");
    spy()->glLinkProgram(program);
}
EXPORT void STDCALL glGetProgramInfoLog(uint32_t program, int32_t buffer_length,
                                        int32_t* string_length_written, char* info) {
    GAPID_INFO("glGetProgramInfoLog()\n");
    spy()->glGetProgramInfoLog(program, buffer_length, string_length_written, info);
}
EXPORT void STDCALL glUseProgram(uint32_t program) {
    GAPID_INFO("glUseProgram()\n");
    spy()->glUseProgram(program);
}
EXPORT bool STDCALL glIsProgram(uint32_t program) {
    GAPID_INFO("glIsProgram()\n");
    return spy()->glIsProgram(program);
}
EXPORT void STDCALL glValidateProgram(uint32_t program) {
    GAPID_INFO("glValidateProgram()\n");
    spy()->glValidateProgram(program);
}
EXPORT void STDCALL glClearColor(float r, float g, float b, float a) {
    GAPID_INFO("glClearColor()\n");
    spy()->glClearColor(r, g, b, a);
}
EXPORT void STDCALL glClearDepthf(float depth) {
    GAPID_INFO("glClearDepthf()\n");
    spy()->glClearDepthf(depth);
}
EXPORT void STDCALL glClearStencil(int32_t stencil) {
    GAPID_INFO("glClearStencil()\n");
    spy()->glClearStencil(stencil);
}
EXPORT void STDCALL glClear(uint32_t mask) {
    GAPID_INFO("glClear()\n");
    spy()->glClear(mask);
}
EXPORT void STDCALL glCullFace(uint32_t mode) {
    GAPID_INFO("glCullFace()\n");
    spy()->glCullFace(mode);
}
EXPORT void STDCALL glPolygonOffset(float scale_factor, float units) {
    GAPID_INFO("glPolygonOffset()\n");
    spy()->glPolygonOffset(scale_factor, units);
}
EXPORT void STDCALL glLineWidth(float width) {
    GAPID_INFO("glLineWidth()\n");
    spy()->glLineWidth(width);
}
EXPORT void STDCALL glSampleCoverage(float value, bool invert) {
    GAPID_INFO("glSampleCoverage()\n");
    spy()->glSampleCoverage(value, invert);
}
EXPORT void STDCALL glHint(uint32_t target, uint32_t mode) {
    GAPID_INFO("glHint()\n");
    spy()->glHint(target, mode);
}
EXPORT void STDCALL glFramebufferRenderbuffer(uint32_t framebuffer_target,
                                              uint32_t framebuffer_attachment,
                                              uint32_t renderbuffer_target, uint32_t renderbuffer) {
    GAPID_INFO("glFramebufferRenderbuffer()\n");
    spy()->glFramebufferRenderbuffer(framebuffer_target, framebuffer_attachment,
                                     renderbuffer_target, renderbuffer);
}
EXPORT void STDCALL glFramebufferTexture2D(uint32_t framebuffer_target,
                                           uint32_t framebuffer_attachment, uint32_t texture_target,
                                           uint32_t texture, int32_t level) {
    GAPID_INFO("glFramebufferTexture2D()\n");
    spy()->glFramebufferTexture2D(framebuffer_target, framebuffer_attachment, texture_target,
                                  texture, level);
}
EXPORT void STDCALL glGetFramebufferAttachmentParameteriv(uint32_t framebuffer_target,
                                                          uint32_t attachment, uint32_t parameter,
                                                          int32_t* value) {
    GAPID_INFO("glGetFramebufferAttachmentParameteriv()\n");
    spy()->glGetFramebufferAttachmentParameteriv(framebuffer_target, attachment, parameter, value);
}
EXPORT void STDCALL
glDrawElements(uint32_t draw_mode, int32_t element_count, uint32_t indices_type, void* indices) {
    GAPID_INFO("glDrawElements()\n");
    spy()->glDrawElements(draw_mode, element_count, indices_type, indices);
}
EXPORT void STDCALL glDrawArrays(uint32_t draw_mode, int32_t first_index, int32_t index_count) {
    GAPID_INFO("glDrawArrays()\n");
    spy()->glDrawArrays(draw_mode, first_index, index_count);
}
EXPORT void STDCALL glFlush() {
    GAPID_INFO("glFlush()\n");
    spy()->glFlush();
}
EXPORT void STDCALL glFinish() {
    GAPID_INFO("glFinish()\n");
    spy()->glFinish();
}
EXPORT void STDCALL glGetBooleanv(uint32_t param, bool* values) {
    GAPID_INFO("glGetBooleanv()\n");
    spy()->glGetBooleanv(param, values);
}
EXPORT void STDCALL glGetFloatv(uint32_t param, float* values) {
    GAPID_INFO("glGetFloatv()\n");
    spy()->glGetFloatv(param, values);
}
EXPORT void STDCALL glGetIntegerv(uint32_t param, int32_t* values) {
    GAPID_INFO("glGetIntegerv()\n");
    spy()->glGetIntegerv(param, values);
}
EXPORT char* STDCALL glGetString(uint32_t param) {
    GAPID_INFO("glGetString()\n");
    return spy()->glGetString(param);
}
EXPORT void STDCALL glEnable(uint32_t capability) {
    GAPID_INFO("glEnable()\n");
    spy()->glEnable(capability);
}
EXPORT void STDCALL glDisable(uint32_t capability) {
    GAPID_INFO("glDisable()\n");
    spy()->glDisable(capability);
}
EXPORT bool STDCALL glIsEnabled(uint32_t capability) {
    GAPID_INFO("glIsEnabled()\n");
    return spy()->glIsEnabled(capability);
}
EXPORT void* STDCALL
glMapBufferRange(uint32_t target, int32_t offset, int32_t length, uint32_t access) {
    GAPID_INFO("glMapBufferRange()\n");
    return spy()->glMapBufferRange(target, offset, length, access);
}
EXPORT void STDCALL glUnmapBuffer(uint32_t target) {
    GAPID_INFO("glUnmapBuffer()\n");
    spy()->glUnmapBuffer(target);
}
EXPORT void STDCALL glInvalidateFramebuffer(uint32_t target, int32_t count, uint32_t* attachments) {
    GAPID_INFO("glInvalidateFramebuffer()\n");
    spy()->glInvalidateFramebuffer(target, count, attachments);
}
EXPORT void STDCALL glRenderbufferStorageMultisample(uint32_t target, int32_t samples,
                                                     uint32_t format, int32_t width,
                                                     int32_t height) {
    GAPID_INFO("glRenderbufferStorageMultisample()\n");
    spy()->glRenderbufferStorageMultisample(target, samples, format, width, height);
}
EXPORT void STDCALL glBlitFramebuffer(int32_t srcX0, int32_t srcY0, int32_t srcX1, int32_t srcY1,
                                      int32_t dstX0, int32_t dstY0, int32_t dstX1, int32_t dstY1,
                                      uint32_t mask, uint32_t filter) {
    GAPID_INFO("glBlitFramebuffer()\n");
    spy()->glBlitFramebuffer(srcX0, srcY0, srcX1, srcY1, dstX0, dstY0, dstX1, dstY1, mask, filter);
}
EXPORT void STDCALL glGenQueries(int32_t count, uint32_t* queries) {
    GAPID_INFO("glGenQueries()\n");
    spy()->glGenQueries(count, queries);
}
EXPORT void STDCALL glBeginQuery(uint32_t target, uint32_t query) {
    GAPID_INFO("glBeginQuery()\n");
    spy()->glBeginQuery(target, query);
}
EXPORT void STDCALL glEndQuery(uint32_t target) {
    GAPID_INFO("glEndQuery()\n");
    spy()->glEndQuery(target);
}
EXPORT void STDCALL glDeleteQueries(int32_t count, uint32_t* queries) {
    GAPID_INFO("glDeleteQueries()\n");
    spy()->glDeleteQueries(count, queries);
}
EXPORT bool STDCALL glIsQuery(uint32_t query) {
    GAPID_INFO("glIsQuery()\n");
    return spy()->glIsQuery(query);
}
EXPORT void STDCALL glGetQueryiv(uint32_t target, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetQueryiv()\n");
    spy()->glGetQueryiv(target, parameter, value);
}
EXPORT void STDCALL glGetQueryObjectuiv(uint32_t query, uint32_t parameter, uint32_t* value) {
    GAPID_INFO("glGetQueryObjectuiv()\n");
    spy()->glGetQueryObjectuiv(query, parameter, value);
}
EXPORT void STDCALL glGenQueriesEXT(int32_t count, uint32_t* queries) {
    GAPID_INFO("glGenQueriesEXT()\n");
    spy()->glGenQueriesEXT(count, queries);
}
EXPORT void STDCALL glBeginQueryEXT(uint32_t target, uint32_t query) {
    GAPID_INFO("glBeginQueryEXT()\n");
    spy()->glBeginQueryEXT(target, query);
}
EXPORT void STDCALL glEndQueryEXT(uint32_t target) {
    GAPID_INFO("glEndQueryEXT()\n");
    spy()->glEndQueryEXT(target);
}
EXPORT void STDCALL glDeleteQueriesEXT(int32_t count, uint32_t* queries) {
    GAPID_INFO("glDeleteQueriesEXT()\n");
    spy()->glDeleteQueriesEXT(count, queries);
}
EXPORT bool STDCALL glIsQueryEXT(uint32_t query) {
    GAPID_INFO("glIsQueryEXT()\n");
    return spy()->glIsQueryEXT(query);
}
EXPORT void STDCALL glQueryCounterEXT(uint32_t query, uint32_t target) {
    GAPID_INFO("glQueryCounterEXT()\n");
    spy()->glQueryCounterEXT(query, target);
}
EXPORT void STDCALL glGetQueryivEXT(uint32_t target, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetQueryivEXT()\n");
    spy()->glGetQueryivEXT(target, parameter, value);
}
EXPORT void STDCALL glGetQueryObjectivEXT(uint32_t query, uint32_t parameter, int32_t* value) {
    GAPID_INFO("glGetQueryObjectivEXT()\n");
    spy()->glGetQueryObjectivEXT(query, parameter, value);
}
EXPORT void STDCALL glGetQueryObjectuivEXT(uint32_t query, uint32_t parameter, uint32_t* value) {
    GAPID_INFO("glGetQueryObjectuivEXT()\n");
    spy()->glGetQueryObjectuivEXT(query, parameter, value);
}
EXPORT void STDCALL glGetQueryObjecti64vEXT(uint32_t query, uint32_t parameter, int64_t* value) {
    GAPID_INFO("glGetQueryObjecti64vEXT()\n");
    spy()->glGetQueryObjecti64vEXT(query, parameter, value);
}
EXPORT void STDCALL glGetQueryObjectui64vEXT(uint32_t query, uint32_t parameter, uint64_t* value) {
    GAPID_INFO("glGetQueryObjectui64vEXT()\n");
    spy()->glGetQueryObjectui64vEXT(query, parameter, value);
}

EXPORT void* STDCALL eglGetProcAddress(const char* name) { return GetSpyProcAddress(name); }
EXPORT void* STDCALL wglGetProcAddress(const char* name) { return GetSpyProcAddress(name); }
EXPORT void* STDCALL glXGetProcAddress(const char* name) { return GetSpyProcAddress(name); }
EXPORT void* STDCALL glXGetProcAddressARB(const char* name) { return GetSpyProcAddress(name); }

}  // extern "C"