/*
 * Copyright 2015, The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY apic. DO NOT EDIT.
 */

#ifndef GAPII_GLES_IMPORTS_H
#define GAPII_GLES_IMPORTS_H

#include "gles_types.h"

#include <gapic/target.h>  // STDCALL

namespace gapii {

struct GlesImports {
    void Resolve();

    typedef int(STDCALL *PFNEGLINITIALIZE)(void *dpy, int *major, int *minor);
    typedef void *(STDCALL *PFNEGLCREATECONTEXT)(void *display, void *config, void *share_context,
                                                 int *attrib_list);
    typedef int(STDCALL *PFNEGLMAKECURRENT)(void *display, void *draw, void *read, void *context);
    typedef int(STDCALL *PFNEGLSWAPBUFFERS)(void *display, void *surface);
    typedef int(STDCALL *PFNEGLQUERYSURFACE)(void *display, void *surface, int attribute,
                                             int *value);
    typedef void *(STDCALL *PFNGLXCREATECONTEXT)(void *dpy, void *vis, void *shareList,
                                                 bool direct);
    typedef void *(STDCALL *PFNGLXCREATENEWCONTEXT)(void *display, void *fbconfig, uint32_t type,
                                                    void *shared, bool direct);
    typedef void(STDCALL *PFNGLXMAKECONTEXTCURRENT)(void *display, void *draw, void *read,
                                                    void *ctx);
    typedef void(STDCALL *PFNGLXSWAPBUFFERS)(void *display, void *drawable);
    typedef void *(STDCALL *PFNWGLCREATECONTEXT)(void *hdc);
    typedef void *(STDCALL *PFNWGLCREATECONTEXTATTRIBSARB)(void *hdc, void *hShareContext,
                                                           int *attribList);
    typedef int(STDCALL *PFNWGLMAKECURRENT)(void *hdc, void *hglrc);
    typedef void(STDCALL *PFNWGLSWAPBUFFERS)(void *hdc);
    typedef int(STDCALL *PFNCGLCREATECONTEXT)(void *pix, void *share, void **ctx);
    typedef int(STDCALL *PFNCGLSETCURRENTCONTEXT)(void *ctx);
    typedef void(STDCALL *PFNGLENABLECLIENTSTATE)(uint32_t type);
    typedef void(STDCALL *PFNGLDISABLECLIENTSTATE)(uint32_t type);
    typedef void(STDCALL *PFNGLGETPROGRAMBINARYOES)(uint32_t program, int32_t buffer_size,
                                                    int32_t *bytes_written, uint32_t *binary_format,
                                                    void *binary);
    typedef void(STDCALL *PFNGLPROGRAMBINARYOES)(uint32_t program, uint32_t binary_format,
                                                 void *binary, int32_t binary_size);
    typedef void(STDCALL *PFNGLSTARTTILINGQCOM)(int32_t x, int32_t y, int32_t width, int32_t height,
                                                uint32_t preserveMask);
    typedef void(STDCALL *PFNGLENDTILINGQCOM)(uint32_t preserve_mask);
    typedef void(STDCALL *PFNGLDISCARDFRAMEBUFFEREXT)(uint32_t target, int32_t numAttachments,
                                                      uint32_t *attachments);
    typedef void(STDCALL *PFNGLINSERTEVENTMARKEREXT)(int32_t length, char *marker);
    typedef void(STDCALL *PFNGLPUSHGROUPMARKEREXT)(int32_t length, char *marker);
    typedef void(STDCALL *PFNGLPOPGROUPMARKEREXT)();
    typedef void(STDCALL *PFNGLTEXSTORAGE1DEXT)(uint32_t target, int32_t levels, uint32_t format,
                                                int32_t width);
    typedef void(STDCALL *PFNGLTEXSTORAGE2DEXT)(uint32_t target, int32_t levels, uint32_t format,
                                                int32_t width, int32_t height);
    typedef void(STDCALL *PFNGLTEXSTORAGE3DEXT)(uint32_t target, int32_t levels, uint32_t format,
                                                int32_t width, int32_t height, int32_t depth);
    typedef void(STDCALL *PFNGLTEXTURESTORAGE1DEXT)(uint32_t texture, uint32_t target,
                                                    int32_t levels, uint32_t format, int32_t width);
    typedef void(STDCALL *PFNGLTEXTURESTORAGE2DEXT)(uint32_t texture, uint32_t target,
                                                    int32_t levels, uint32_t format, int32_t width,
                                                    int32_t height);
    typedef void(STDCALL *PFNGLTEXTURESTORAGE3DEXT)(uint32_t texture, uint32_t target,
                                                    int32_t levels, uint32_t format, int32_t width,
                                                    int32_t height, int32_t depth);
    typedef void(STDCALL *PFNGLGENVERTEXARRAYSOES)(int32_t count, uint32_t *arrays);
    typedef void(STDCALL *PFNGLBINDVERTEXARRAYOES)(uint32_t array);
    typedef void(STDCALL *PFNGLDELETEVERTEXARRAYSOES)(int32_t count, uint32_t *arrays);
    typedef bool(STDCALL *PFNGLISVERTEXARRAYOES)(uint32_t array);
    typedef void(STDCALL *PFNGLEGLIMAGETARGETTEXTURE2DOES)(uint32_t target, void *image);
    typedef void(STDCALL *PFNGLEGLIMAGETARGETRENDERBUFFERSTORAGEOES)(uint32_t target, void *image);
    typedef uint32_t(STDCALL *PFNGLGETGRAPHICSRESETSTATUSEXT)();
    typedef void(STDCALL *PFNGLBINDATTRIBLOCATION)(uint32_t program, uint32_t location, char *name);
    typedef void(STDCALL *PFNGLBLENDFUNC)(uint32_t src_factor, uint32_t dst_factor);
    typedef void(STDCALL *PFNGLBLENDFUNCSEPARATE)(uint32_t src_factor_rgb, uint32_t dst_factor_rgb,
                                                  uint32_t src_factor_alpha,
                                                  uint32_t dst_factor_alpha);
    typedef void(STDCALL *PFNGLBLENDEQUATION)(uint32_t equation);
    typedef void(STDCALL *PFNGLBLENDEQUATIONSEPARATE)(uint32_t rgb, uint32_t alpha);
    typedef void(STDCALL *PFNGLBLENDCOLOR)(float red, float green, float blue, float alpha);
    typedef void(STDCALL *PFNGLENABLEVERTEXATTRIBARRAY)(uint32_t location);
    typedef void(STDCALL *PFNGLDISABLEVERTEXATTRIBARRAY)(uint32_t location);
    typedef void(STDCALL *PFNGLVERTEXATTRIBPOINTER)(uint32_t location, int32_t size, uint32_t type,
                                                    bool normalized, int32_t stride, void *data);
    typedef void(STDCALL *PFNGLGETACTIVEATTRIB)(uint32_t program, uint32_t location,
                                                int32_t buffer_size, int32_t *buffer_bytes_written,
                                                int32_t *vector_count, uint32_t *type, char *name);
    typedef void(STDCALL *PFNGLGETACTIVEUNIFORM)(uint32_t program, int32_t location,
                                                 int32_t buffer_size, int32_t *buffer_bytes_written,
                                                 int32_t *vector_count, uint32_t *type, char *name);
    typedef uint32_t(STDCALL *PFNGLGETERROR)();
    typedef void(STDCALL *PFNGLGETPROGRAMIV)(uint32_t program, uint32_t parameter, int32_t *value);
    typedef void(STDCALL *PFNGLGETSHADERIV)(uint32_t shader, uint32_t parameter, int32_t *value);
    typedef int32_t(STDCALL *PFNGLGETUNIFORMLOCATION)(uint32_t program, char *name);
    typedef uint32_t(STDCALL *PFNGLGETATTRIBLOCATION)(uint32_t program, char *name);
    typedef void(STDCALL *PFNGLPIXELSTOREI)(uint32_t parameter, int32_t value);
    typedef void(STDCALL *PFNGLTEXPARAMETERI)(uint32_t target, uint32_t parameter, int32_t value);
    typedef void(STDCALL *PFNGLTEXPARAMETERF)(uint32_t target, uint32_t parameter, float value);
    typedef void(STDCALL *PFNGLGETTEXPARAMETERIV)(uint32_t target, uint32_t parameter,
                                                  int32_t *values);
    typedef void(STDCALL *PFNGLGETTEXPARAMETERFV)(uint32_t target, uint32_t parameter,
                                                  float *values);
    typedef void(STDCALL *PFNGLUNIFORM1I)(int32_t location, int32_t value);
    typedef void(STDCALL *PFNGLUNIFORM2I)(int32_t location, int32_t value0, int32_t value1);
    typedef void(STDCALL *PFNGLUNIFORM3I)(int32_t location, int32_t value0, int32_t value1,
                                          int32_t value2);
    typedef void(STDCALL *PFNGLUNIFORM4I)(int32_t location, int32_t value0, int32_t value1,
                                          int32_t value2, int32_t value3);
    typedef void(STDCALL *PFNGLUNIFORM1IV)(int32_t location, int32_t count, int32_t *value);
    typedef void(STDCALL *PFNGLUNIFORM2IV)(int32_t location, int32_t count, int32_t *value);
    typedef void(STDCALL *PFNGLUNIFORM3IV)(int32_t location, int32_t count, int32_t *value);
    typedef void(STDCALL *PFNGLUNIFORM4IV)(int32_t location, int32_t count, int32_t *value);
    typedef void(STDCALL *PFNGLUNIFORM1F)(int32_t location, float value);
    typedef void(STDCALL *PFNGLUNIFORM2F)(int32_t location, float value0, float value1);
    typedef void(STDCALL *PFNGLUNIFORM3F)(int32_t location, float value0, float value1,
                                          float value2);
    typedef void(STDCALL *PFNGLUNIFORM4F)(int32_t location, float value0, float value1,
                                          float value2, float value3);
    typedef void(STDCALL *PFNGLUNIFORM1FV)(int32_t location, int32_t count, float *value);
    typedef void(STDCALL *PFNGLUNIFORM2FV)(int32_t location, int32_t count, float *value);
    typedef void(STDCALL *PFNGLUNIFORM3FV)(int32_t location, int32_t count, float *value);
    typedef void(STDCALL *PFNGLUNIFORM4FV)(int32_t location, int32_t count, float *value);
    typedef void(STDCALL *PFNGLUNIFORMMATRIX2FV)(int32_t location, int32_t count, bool transpose,
                                                 float *values);
    typedef void(STDCALL *PFNGLUNIFORMMATRIX3FV)(int32_t location, int32_t count, bool transpose,
                                                 float *values);
    typedef void(STDCALL *PFNGLUNIFORMMATRIX4FV)(int32_t location, int32_t count, bool transpose,
                                                 float *values);
    typedef void(STDCALL *PFNGLGETUNIFORMFV)(uint32_t program, int32_t location, float *values);
    typedef void(STDCALL *PFNGLGETUNIFORMIV)(uint32_t program, int32_t location, int32_t *values);
    typedef void(STDCALL *PFNGLVERTEXATTRIB1F)(uint32_t location, float value0);
    typedef void(STDCALL *PFNGLVERTEXATTRIB2F)(uint32_t location, float value0, float value1);
    typedef void(STDCALL *PFNGLVERTEXATTRIB3F)(uint32_t location, float value0, float value1,
                                               float value2);
    typedef void(STDCALL *PFNGLVERTEXATTRIB4F)(uint32_t location, float value0, float value1,
                                               float value2, float value3);
    typedef void(STDCALL *PFNGLVERTEXATTRIB1FV)(uint32_t location, float *value);
    typedef void(STDCALL *PFNGLVERTEXATTRIB2FV)(uint32_t location, float *value);
    typedef void(STDCALL *PFNGLVERTEXATTRIB3FV)(uint32_t location, float *value);
    typedef void(STDCALL *PFNGLVERTEXATTRIB4FV)(uint32_t location, float *value);
    typedef void(STDCALL *PFNGLGETSHADERPRECISIONFORMAT)(uint32_t shader_type,
                                                         uint32_t precision_type, int32_t *range,
                                                         int32_t *precision);
    typedef void(STDCALL *PFNGLDEPTHMASK)(bool enabled);
    typedef void(STDCALL *PFNGLDEPTHFUNC)(uint32_t function);
    typedef void(STDCALL *PFNGLDEPTHRANGEF)(float near, float far);
    typedef void(STDCALL *PFNGLCOLORMASK)(bool red, bool green, bool blue, bool alpha);
    typedef void(STDCALL *PFNGLSTENCILMASK)(uint32_t mask);
    typedef void(STDCALL *PFNGLSTENCILMASKSEPARATE)(uint32_t face, uint32_t mask);
    typedef void(STDCALL *PFNGLSTENCILFUNCSEPARATE)(uint32_t face, uint32_t function,
                                                    int32_t reference_value, int32_t mask);
    typedef void(STDCALL *PFNGLSTENCILOPSEPARATE)(uint32_t face, uint32_t stencil_fail,
                                                  uint32_t stencil_pass_depth_fail,
                                                  uint32_t stencil_pass_depth_pass);
    typedef void(STDCALL *PFNGLFRONTFACE)(uint32_t orientation);
    typedef void(STDCALL *PFNGLVIEWPORT)(int32_t x, int32_t y, int32_t width, int32_t height);
    typedef void(STDCALL *PFNGLSCISSOR)(int32_t x, int32_t y, int32_t width, int32_t height);
    typedef void(STDCALL *PFNGLACTIVETEXTURE)(uint32_t unit);
    typedef void(STDCALL *PFNGLGENTEXTURES)(int32_t count, uint32_t *textures);
    typedef void(STDCALL *PFNGLDELETETEXTURES)(int32_t count, uint32_t *textures);
    typedef bool(STDCALL *PFNGLISTEXTURE)(uint32_t texture);
    typedef void(STDCALL *PFNGLBINDTEXTURE)(uint32_t target, uint32_t texture);
    typedef void(STDCALL *PFNGLTEXIMAGE2D)(uint32_t target, int32_t level, uint32_t internal_format,
                                           int32_t width, int32_t height, int32_t border,
                                           uint32_t format, uint32_t type, void *data);
    typedef void(STDCALL *PFNGLTEXSUBIMAGE2D)(uint32_t target, int32_t level, int32_t xoffset,
                                              int32_t yoffset, int32_t width, int32_t height,
                                              uint32_t format, uint32_t type, void *data);
    typedef void(STDCALL *PFNGLCOPYTEXIMAGE2D)(uint32_t target, int32_t level, uint32_t format,
                                               int32_t x, int32_t y, int32_t width, int32_t height,
                                               int32_t border);
    typedef void(STDCALL *PFNGLCOPYTEXSUBIMAGE2D)(uint32_t target, int32_t level, int32_t xoffset,
                                                  int32_t yoffset, int32_t x, int32_t y,
                                                  int32_t width, int32_t height);
    typedef void(STDCALL *PFNGLCOMPRESSEDTEXIMAGE2D)(uint32_t target, int32_t level,
                                                     uint32_t format, int32_t width, int32_t height,
                                                     int32_t border, int32_t image_size,
                                                     void *data);
    typedef void(STDCALL *PFNGLCOMPRESSEDTEXSUBIMAGE2D)(uint32_t target, int32_t level,
                                                        int32_t xoffset, int32_t yoffset,
                                                        int32_t width, int32_t height,
                                                        uint32_t format, int32_t image_size,
                                                        void *data);
    typedef void(STDCALL *PFNGLGENERATEMIPMAP)(uint32_t target);
    typedef void(STDCALL *PFNGLREADPIXELS)(int32_t x, int32_t y, int32_t width, int32_t height,
                                           uint32_t format, uint32_t type, void *data);
    typedef void(STDCALL *PFNGLGENFRAMEBUFFERS)(int32_t count, uint32_t *framebuffers);
    typedef void(STDCALL *PFNGLBINDFRAMEBUFFER)(uint32_t target, uint32_t framebuffer);
    typedef uint32_t(STDCALL *PFNGLCHECKFRAMEBUFFERSTATUS)(uint32_t target);
    typedef void(STDCALL *PFNGLDELETEFRAMEBUFFERS)(int32_t count, uint32_t *framebuffers);
    typedef bool(STDCALL *PFNGLISFRAMEBUFFER)(uint32_t framebuffer);
    typedef void(STDCALL *PFNGLGENRENDERBUFFERS)(int32_t count, uint32_t *renderbuffers);
    typedef void(STDCALL *PFNGLBINDRENDERBUFFER)(uint32_t target, uint32_t renderbuffer);
    typedef void(STDCALL *PFNGLRENDERBUFFERSTORAGE)(uint32_t target, uint32_t format, int32_t width,
                                                    int32_t height);
    typedef void(STDCALL *PFNGLDELETERENDERBUFFERS)(int32_t count, uint32_t *renderbuffers);
    typedef bool(STDCALL *PFNGLISRENDERBUFFER)(uint32_t renderbuffer);
    typedef void(STDCALL *PFNGLGETRENDERBUFFERPARAMETERIV)(uint32_t target, uint32_t parameter,
                                                           int32_t *values);
    typedef void(STDCALL *PFNGLGENBUFFERS)(int32_t count, uint32_t *buffers);
    typedef void(STDCALL *PFNGLBINDBUFFER)(uint32_t target, uint32_t buffer);
    typedef void(STDCALL *PFNGLBUFFERDATA)(uint32_t target, int32_t size, void *data,
                                           uint32_t usage);
    typedef void(STDCALL *PFNGLBUFFERSUBDATA)(uint32_t target, int32_t offset, int32_t size,
                                              void *data);
    typedef void(STDCALL *PFNGLDELETEBUFFERS)(int32_t count, uint32_t *buffers);
    typedef bool(STDCALL *PFNGLISBUFFER)(uint32_t buffer);
    typedef void(STDCALL *PFNGLGETBUFFERPARAMETERIV)(uint32_t target, uint32_t parameter,
                                                     int32_t *value);
    typedef uint32_t(STDCALL *PFNGLCREATESHADER)(uint32_t type);
    typedef void(STDCALL *PFNGLDELETESHADER)(uint32_t shader);
    typedef void(STDCALL *PFNGLSHADERSOURCE)(uint32_t shader, int32_t count, char **source,
                                             int32_t *length);
    typedef void(STDCALL *PFNGLSHADERBINARY)(int32_t count, uint32_t *shaders,
                                             uint32_t binary_format, void *binary,
                                             int32_t binary_size);
    typedef void(STDCALL *PFNGLGETSHADERINFOLOG)(uint32_t shader, int32_t buffer_length,
                                                 int32_t *string_length_written, char *info);
    typedef void(STDCALL *PFNGLGETSHADERSOURCE)(uint32_t shader, int32_t buffer_length,
                                                int32_t *string_length_written, char *source);
    typedef void(STDCALL *PFNGLRELEASESHADERCOMPILER)();
    typedef void(STDCALL *PFNGLCOMPILESHADER)(uint32_t shader);
    typedef bool(STDCALL *PFNGLISSHADER)(uint32_t shader);
    typedef uint32_t(STDCALL *PFNGLCREATEPROGRAM)();
    typedef void(STDCALL *PFNGLDELETEPROGRAM)(uint32_t program);
    typedef void(STDCALL *PFNGLATTACHSHADER)(uint32_t program, uint32_t shader);
    typedef void(STDCALL *PFNGLDETACHSHADER)(uint32_t program, uint32_t shader);
    typedef void(STDCALL *PFNGLGETATTACHEDSHADERS)(uint32_t program, int32_t buffer_length,
                                                   int32_t *shaders_length_written,
                                                   uint32_t *shaders);
    typedef void(STDCALL *PFNGLLINKPROGRAM)(uint32_t program);
    typedef void(STDCALL *PFNGLGETPROGRAMINFOLOG)(uint32_t program, int32_t buffer_length,
                                                  int32_t *string_length_written, char *info);
    typedef void(STDCALL *PFNGLUSEPROGRAM)(uint32_t program);
    typedef bool(STDCALL *PFNGLISPROGRAM)(uint32_t program);
    typedef void(STDCALL *PFNGLVALIDATEPROGRAM)(uint32_t program);
    typedef void(STDCALL *PFNGLCLEARCOLOR)(float r, float g, float b, float a);
    typedef void(STDCALL *PFNGLCLEARDEPTHF)(float depth);
    typedef void(STDCALL *PFNGLCLEARSTENCIL)(int32_t stencil);
    typedef void(STDCALL *PFNGLCLEAR)(uint32_t mask);
    typedef void(STDCALL *PFNGLCULLFACE)(uint32_t mode);
    typedef void(STDCALL *PFNGLPOLYGONOFFSET)(float scale_factor, float units);
    typedef void(STDCALL *PFNGLLINEWIDTH)(float width);
    typedef void(STDCALL *PFNGLSAMPLECOVERAGE)(float value, bool invert);
    typedef void(STDCALL *PFNGLHINT)(uint32_t target, uint32_t mode);
    typedef void(STDCALL *PFNGLFRAMEBUFFERRENDERBUFFER)(uint32_t framebuffer_target,
                                                        uint32_t framebuffer_attachment,
                                                        uint32_t renderbuffer_target,
                                                        uint32_t renderbuffer);
    typedef void(STDCALL *PFNGLFRAMEBUFFERTEXTURE2D)(uint32_t framebuffer_target,
                                                     uint32_t framebuffer_attachment,
                                                     uint32_t texture_target, uint32_t texture,
                                                     int32_t level);
    typedef void(STDCALL *PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIV)(uint32_t framebuffer_target,
                                                                    uint32_t attachment,
                                                                    uint32_t parameter,
                                                                    int32_t *value);
    typedef void(STDCALL *PFNGLDRAWELEMENTS)(uint32_t draw_mode, int32_t element_count,
                                             uint32_t indices_type, void *indices);
    typedef void(STDCALL *PFNGLDRAWARRAYS)(uint32_t draw_mode, int32_t first_index,
                                           int32_t index_count);
    typedef void(STDCALL *PFNGLFLUSH)();
    typedef void(STDCALL *PFNGLFINISH)();
    typedef void(STDCALL *PFNGLGETBOOLEANV)(uint32_t param, bool *values);
    typedef void(STDCALL *PFNGLGETFLOATV)(uint32_t param, float *values);
    typedef void(STDCALL *PFNGLGETINTEGERV)(uint32_t param, int32_t *values);
    typedef char *(STDCALL *PFNGLGETSTRING)(uint32_t param);
    typedef void(STDCALL *PFNGLENABLE)(uint32_t capability);
    typedef void(STDCALL *PFNGLDISABLE)(uint32_t capability);
    typedef bool(STDCALL *PFNGLISENABLED)(uint32_t capability);
    typedef void *(STDCALL *PFNGLMAPBUFFERRANGE)(uint32_t target, int32_t offset, int32_t length,
                                                 uint32_t access);
    typedef void(STDCALL *PFNGLUNMAPBUFFER)(uint32_t target);
    typedef void(STDCALL *PFNGLINVALIDATEFRAMEBUFFER)(uint32_t target, int32_t count,
                                                      uint32_t *attachments);
    typedef void(STDCALL *PFNGLRENDERBUFFERSTORAGEMULTISAMPLE)(uint32_t target, int32_t samples,
                                                               uint32_t format, int32_t width,
                                                               int32_t height);
    typedef void(STDCALL *PFNGLBLITFRAMEBUFFER)(int32_t srcX0, int32_t srcY0, int32_t srcX1,
                                                int32_t srcY1, int32_t dstX0, int32_t dstY0,
                                                int32_t dstX1, int32_t dstY1, uint32_t mask,
                                                uint32_t filter);
    typedef void(STDCALL *PFNGLGENQUERIES)(int32_t count, uint32_t *queries);
    typedef void(STDCALL *PFNGLBEGINQUERY)(uint32_t target, uint32_t query);
    typedef void(STDCALL *PFNGLENDQUERY)(uint32_t target);
    typedef void(STDCALL *PFNGLDELETEQUERIES)(int32_t count, uint32_t *queries);
    typedef bool(STDCALL *PFNGLISQUERY)(uint32_t query);
    typedef void(STDCALL *PFNGLGETQUERYIV)(uint32_t target, uint32_t parameter, int32_t *value);
    typedef void(STDCALL *PFNGLGETQUERYOBJECTUIV)(uint32_t query, uint32_t parameter,
                                                  uint32_t *value);
    typedef void(STDCALL *PFNGLGENQUERIESEXT)(int32_t count, uint32_t *queries);
    typedef void(STDCALL *PFNGLBEGINQUERYEXT)(uint32_t target, uint32_t query);
    typedef void(STDCALL *PFNGLENDQUERYEXT)(uint32_t target);
    typedef void(STDCALL *PFNGLDELETEQUERIESEXT)(int32_t count, uint32_t *queries);
    typedef bool(STDCALL *PFNGLISQUERYEXT)(uint32_t query);
    typedef void(STDCALL *PFNGLQUERYCOUNTEREXT)(uint32_t query, uint32_t target);
    typedef void(STDCALL *PFNGLGETQUERYIVEXT)(uint32_t target, uint32_t parameter, int32_t *value);
    typedef void(STDCALL *PFNGLGETQUERYOBJECTIVEXT)(uint32_t query, uint32_t parameter,
                                                    int32_t *value);
    typedef void(STDCALL *PFNGLGETQUERYOBJECTUIVEXT)(uint32_t query, uint32_t parameter,
                                                     uint32_t *value);
    typedef void(STDCALL *PFNGLGETQUERYOBJECTI64VEXT)(uint32_t query, uint32_t parameter,
                                                      int64_t *value);
    typedef void(STDCALL *PFNGLGETQUERYOBJECTUI64VEXT)(uint32_t query, uint32_t parameter,
                                                       uint64_t *value);

    PFNEGLINITIALIZE eglInitialize;
    PFNEGLCREATECONTEXT eglCreateContext;
    PFNEGLMAKECURRENT eglMakeCurrent;
    PFNEGLSWAPBUFFERS eglSwapBuffers;
    PFNEGLQUERYSURFACE eglQuerySurface;
    PFNGLXCREATECONTEXT glXCreateContext;
    PFNGLXCREATENEWCONTEXT glXCreateNewContext;
    PFNGLXMAKECONTEXTCURRENT glXMakeContextCurrent;
    PFNGLXSWAPBUFFERS glXSwapBuffers;
    PFNWGLCREATECONTEXT wglCreateContext;
    PFNWGLCREATECONTEXTATTRIBSARB wglCreateContextAttribsARB;
    PFNWGLMAKECURRENT wglMakeCurrent;
    PFNWGLSWAPBUFFERS wglSwapBuffers;
    PFNCGLCREATECONTEXT CGLCreateContext;
    PFNCGLSETCURRENTCONTEXT CGLSetCurrentContext;
    PFNGLENABLECLIENTSTATE glEnableClientState;
    PFNGLDISABLECLIENTSTATE glDisableClientState;
    PFNGLGETPROGRAMBINARYOES glGetProgramBinaryOES;
    PFNGLPROGRAMBINARYOES glProgramBinaryOES;
    PFNGLSTARTTILINGQCOM glStartTilingQCOM;
    PFNGLENDTILINGQCOM glEndTilingQCOM;
    PFNGLDISCARDFRAMEBUFFEREXT glDiscardFramebufferEXT;
    PFNGLINSERTEVENTMARKEREXT glInsertEventMarkerEXT;
    PFNGLPUSHGROUPMARKEREXT glPushGroupMarkerEXT;
    PFNGLPOPGROUPMARKEREXT glPopGroupMarkerEXT;
    PFNGLTEXSTORAGE1DEXT glTexStorage1DEXT;
    PFNGLTEXSTORAGE2DEXT glTexStorage2DEXT;
    PFNGLTEXSTORAGE3DEXT glTexStorage3DEXT;
    PFNGLTEXTURESTORAGE1DEXT glTextureStorage1DEXT;
    PFNGLTEXTURESTORAGE2DEXT glTextureStorage2DEXT;
    PFNGLTEXTURESTORAGE3DEXT glTextureStorage3DEXT;
    PFNGLGENVERTEXARRAYSOES glGenVertexArraysOES;
    PFNGLBINDVERTEXARRAYOES glBindVertexArrayOES;
    PFNGLDELETEVERTEXARRAYSOES glDeleteVertexArraysOES;
    PFNGLISVERTEXARRAYOES glIsVertexArrayOES;
    PFNGLEGLIMAGETARGETTEXTURE2DOES glEGLImageTargetTexture2DOES;
    PFNGLEGLIMAGETARGETRENDERBUFFERSTORAGEOES glEGLImageTargetRenderbufferStorageOES;
    PFNGLGETGRAPHICSRESETSTATUSEXT glGetGraphicsResetStatusEXT;
    PFNGLBINDATTRIBLOCATION glBindAttribLocation;
    PFNGLBLENDFUNC glBlendFunc;
    PFNGLBLENDFUNCSEPARATE glBlendFuncSeparate;
    PFNGLBLENDEQUATION glBlendEquation;
    PFNGLBLENDEQUATIONSEPARATE glBlendEquationSeparate;
    PFNGLBLENDCOLOR glBlendColor;
    PFNGLENABLEVERTEXATTRIBARRAY glEnableVertexAttribArray;
    PFNGLDISABLEVERTEXATTRIBARRAY glDisableVertexAttribArray;
    PFNGLVERTEXATTRIBPOINTER glVertexAttribPointer;
    PFNGLGETACTIVEATTRIB glGetActiveAttrib;
    PFNGLGETACTIVEUNIFORM glGetActiveUniform;
    PFNGLGETERROR glGetError;
    PFNGLGETPROGRAMIV glGetProgramiv;
    PFNGLGETSHADERIV glGetShaderiv;
    PFNGLGETUNIFORMLOCATION glGetUniformLocation;
    PFNGLGETATTRIBLOCATION glGetAttribLocation;
    PFNGLPIXELSTOREI glPixelStorei;
    PFNGLTEXPARAMETERI glTexParameteri;
    PFNGLTEXPARAMETERF glTexParameterf;
    PFNGLGETTEXPARAMETERIV glGetTexParameteriv;
    PFNGLGETTEXPARAMETERFV glGetTexParameterfv;
    PFNGLUNIFORM1I glUniform1i;
    PFNGLUNIFORM2I glUniform2i;
    PFNGLUNIFORM3I glUniform3i;
    PFNGLUNIFORM4I glUniform4i;
    PFNGLUNIFORM1IV glUniform1iv;
    PFNGLUNIFORM2IV glUniform2iv;
    PFNGLUNIFORM3IV glUniform3iv;
    PFNGLUNIFORM4IV glUniform4iv;
    PFNGLUNIFORM1F glUniform1f;
    PFNGLUNIFORM2F glUniform2f;
    PFNGLUNIFORM3F glUniform3f;
    PFNGLUNIFORM4F glUniform4f;
    PFNGLUNIFORM1FV glUniform1fv;
    PFNGLUNIFORM2FV glUniform2fv;
    PFNGLUNIFORM3FV glUniform3fv;
    PFNGLUNIFORM4FV glUniform4fv;
    PFNGLUNIFORMMATRIX2FV glUniformMatrix2fv;
    PFNGLUNIFORMMATRIX3FV glUniformMatrix3fv;
    PFNGLUNIFORMMATRIX4FV glUniformMatrix4fv;
    PFNGLGETUNIFORMFV glGetUniformfv;
    PFNGLGETUNIFORMIV glGetUniformiv;
    PFNGLVERTEXATTRIB1F glVertexAttrib1f;
    PFNGLVERTEXATTRIB2F glVertexAttrib2f;
    PFNGLVERTEXATTRIB3F glVertexAttrib3f;
    PFNGLVERTEXATTRIB4F glVertexAttrib4f;
    PFNGLVERTEXATTRIB1FV glVertexAttrib1fv;
    PFNGLVERTEXATTRIB2FV glVertexAttrib2fv;
    PFNGLVERTEXATTRIB3FV glVertexAttrib3fv;
    PFNGLVERTEXATTRIB4FV glVertexAttrib4fv;
    PFNGLGETSHADERPRECISIONFORMAT glGetShaderPrecisionFormat;
    PFNGLDEPTHMASK glDepthMask;
    PFNGLDEPTHFUNC glDepthFunc;
    PFNGLDEPTHRANGEF glDepthRangef;
    PFNGLCOLORMASK glColorMask;
    PFNGLSTENCILMASK glStencilMask;
    PFNGLSTENCILMASKSEPARATE glStencilMaskSeparate;
    PFNGLSTENCILFUNCSEPARATE glStencilFuncSeparate;
    PFNGLSTENCILOPSEPARATE glStencilOpSeparate;
    PFNGLFRONTFACE glFrontFace;
    PFNGLVIEWPORT glViewport;
    PFNGLSCISSOR glScissor;
    PFNGLACTIVETEXTURE glActiveTexture;
    PFNGLGENTEXTURES glGenTextures;
    PFNGLDELETETEXTURES glDeleteTextures;
    PFNGLISTEXTURE glIsTexture;
    PFNGLBINDTEXTURE glBindTexture;
    PFNGLTEXIMAGE2D glTexImage2D;
    PFNGLTEXSUBIMAGE2D glTexSubImage2D;
    PFNGLCOPYTEXIMAGE2D glCopyTexImage2D;
    PFNGLCOPYTEXSUBIMAGE2D glCopyTexSubImage2D;
    PFNGLCOMPRESSEDTEXIMAGE2D glCompressedTexImage2D;
    PFNGLCOMPRESSEDTEXSUBIMAGE2D glCompressedTexSubImage2D;
    PFNGLGENERATEMIPMAP glGenerateMipmap;
    PFNGLREADPIXELS glReadPixels;
    PFNGLGENFRAMEBUFFERS glGenFramebuffers;
    PFNGLBINDFRAMEBUFFER glBindFramebuffer;
    PFNGLCHECKFRAMEBUFFERSTATUS glCheckFramebufferStatus;
    PFNGLDELETEFRAMEBUFFERS glDeleteFramebuffers;
    PFNGLISFRAMEBUFFER glIsFramebuffer;
    PFNGLGENRENDERBUFFERS glGenRenderbuffers;
    PFNGLBINDRENDERBUFFER glBindRenderbuffer;
    PFNGLRENDERBUFFERSTORAGE glRenderbufferStorage;
    PFNGLDELETERENDERBUFFERS glDeleteRenderbuffers;
    PFNGLISRENDERBUFFER glIsRenderbuffer;
    PFNGLGETRENDERBUFFERPARAMETERIV glGetRenderbufferParameteriv;
    PFNGLGENBUFFERS glGenBuffers;
    PFNGLBINDBUFFER glBindBuffer;
    PFNGLBUFFERDATA glBufferData;
    PFNGLBUFFERSUBDATA glBufferSubData;
    PFNGLDELETEBUFFERS glDeleteBuffers;
    PFNGLISBUFFER glIsBuffer;
    PFNGLGETBUFFERPARAMETERIV glGetBufferParameteriv;
    PFNGLCREATESHADER glCreateShader;
    PFNGLDELETESHADER glDeleteShader;
    PFNGLSHADERSOURCE glShaderSource;
    PFNGLSHADERBINARY glShaderBinary;
    PFNGLGETSHADERINFOLOG glGetShaderInfoLog;
    PFNGLGETSHADERSOURCE glGetShaderSource;
    PFNGLRELEASESHADERCOMPILER glReleaseShaderCompiler;
    PFNGLCOMPILESHADER glCompileShader;
    PFNGLISSHADER glIsShader;
    PFNGLCREATEPROGRAM glCreateProgram;
    PFNGLDELETEPROGRAM glDeleteProgram;
    PFNGLATTACHSHADER glAttachShader;
    PFNGLDETACHSHADER glDetachShader;
    PFNGLGETATTACHEDSHADERS glGetAttachedShaders;
    PFNGLLINKPROGRAM glLinkProgram;
    PFNGLGETPROGRAMINFOLOG glGetProgramInfoLog;
    PFNGLUSEPROGRAM glUseProgram;
    PFNGLISPROGRAM glIsProgram;
    PFNGLVALIDATEPROGRAM glValidateProgram;
    PFNGLCLEARCOLOR glClearColor;
    PFNGLCLEARDEPTHF glClearDepthf;
    PFNGLCLEARSTENCIL glClearStencil;
    PFNGLCLEAR glClear;
    PFNGLCULLFACE glCullFace;
    PFNGLPOLYGONOFFSET glPolygonOffset;
    PFNGLLINEWIDTH glLineWidth;
    PFNGLSAMPLECOVERAGE glSampleCoverage;
    PFNGLHINT glHint;
    PFNGLFRAMEBUFFERRENDERBUFFER glFramebufferRenderbuffer;
    PFNGLFRAMEBUFFERTEXTURE2D glFramebufferTexture2D;
    PFNGLGETFRAMEBUFFERATTACHMENTPARAMETERIV glGetFramebufferAttachmentParameteriv;
    PFNGLDRAWELEMENTS glDrawElements;
    PFNGLDRAWARRAYS glDrawArrays;
    PFNGLFLUSH glFlush;
    PFNGLFINISH glFinish;
    PFNGLGETBOOLEANV glGetBooleanv;
    PFNGLGETFLOATV glGetFloatv;
    PFNGLGETINTEGERV glGetIntegerv;
    PFNGLGETSTRING glGetString;
    PFNGLENABLE glEnable;
    PFNGLDISABLE glDisable;
    PFNGLISENABLED glIsEnabled;
    PFNGLMAPBUFFERRANGE glMapBufferRange;
    PFNGLUNMAPBUFFER glUnmapBuffer;
    PFNGLINVALIDATEFRAMEBUFFER glInvalidateFramebuffer;
    PFNGLRENDERBUFFERSTORAGEMULTISAMPLE glRenderbufferStorageMultisample;
    PFNGLBLITFRAMEBUFFER glBlitFramebuffer;
    PFNGLGENQUERIES glGenQueries;
    PFNGLBEGINQUERY glBeginQuery;
    PFNGLENDQUERY glEndQuery;
    PFNGLDELETEQUERIES glDeleteQueries;
    PFNGLISQUERY glIsQuery;
    PFNGLGETQUERYIV glGetQueryiv;
    PFNGLGETQUERYOBJECTUIV glGetQueryObjectuiv;
    PFNGLGENQUERIESEXT glGenQueriesEXT;
    PFNGLBEGINQUERYEXT glBeginQueryEXT;
    PFNGLENDQUERYEXT glEndQueryEXT;
    PFNGLDELETEQUERIESEXT glDeleteQueriesEXT;
    PFNGLISQUERYEXT glIsQueryEXT;
    PFNGLQUERYCOUNTEREXT glQueryCounterEXT;
    PFNGLGETQUERYIVEXT glGetQueryivEXT;
    PFNGLGETQUERYOBJECTIVEXT glGetQueryObjectivEXT;
    PFNGLGETQUERYOBJECTUIVEXT glGetQueryObjectuivEXT;
    PFNGLGETQUERYOBJECTI64VEXT glGetQueryObjecti64vEXT;
    PFNGLGETQUERYOBJECTUI64VEXT glGetQueryObjectui64vEXT;
};
}  // namespace gapii

#endif  // GAPII_GLES_IMPORTS_H
