/*
 * Copyright 2015, The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * THIS FILE WAS GENERATED BY apic. DO NOT EDIT.
 */

#ifndef GAPII_GLES_TYPES_H
#define GAPII_GLES_TYPES_H

#include "slice.h"

#include <memory>
#include <string>
#include <unordered_map>
#include <vector>

#include <stdint.h>
#include <string.h>

namespace gapii {

namespace DrawMode {
static const uint32_t GL_LINE_LOOP = 2;
static const uint32_t GL_LINE_STRIP = 3;
static const uint32_t GL_LINES = 1;
static const uint32_t GL_POINTS = 0;
static const uint32_t GL_TRIANGLE_FAN = 6;
static const uint32_t GL_TRIANGLE_STRIP = 5;
static const uint32_t GL_TRIANGLES = 4;
}

namespace IndicesType {
static const uint32_t GL_UNSIGNED_BYTE = 5121;
static const uint32_t GL_UNSIGNED_SHORT = 5123;
static const uint32_t GL_UNSIGNED_INT = 5125;
}

namespace TextureTarget_GLES_1_1 {
static const uint32_t GL_TEXTURE_2D = 3553;
}

namespace TextureTarget_GLES_2_0 {
static const uint32_t GL_TEXTURE_CUBE_MAP = 34067;
}

namespace TextureTarget_OES_EGL_image_external {
static const uint32_t GL_TEXTURE_EXTERNAL_OES = 36197;
}

namespace TextureTarget {
static const uint32_t GL_TEXTURE_2D = 3553;
static const uint32_t GL_TEXTURE_CUBE_MAP = 34067;
static const uint32_t GL_TEXTURE_EXTERNAL_OES = 36197;
}

namespace CubeMapImageTarget {
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_X = 34070;
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_Y = 34072;
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_Z = 34074;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_X = 34069;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_Y = 34071;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_Z = 34073;
}

namespace Texture2DImageTarget {
static const uint32_t GL_TEXTURE_2D = 3553;
}

namespace TextureImageTarget {
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_X = 34070;
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_Y = 34072;
static const uint32_t GL_TEXTURE_CUBE_MAP_NEGATIVE_Z = 34074;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_X = 34069;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_Y = 34071;
static const uint32_t GL_TEXTURE_CUBE_MAP_POSITIVE_Z = 34073;
static const uint32_t GL_TEXTURE_2D = 3553;
}

namespace BaseTexelFormat {
static const uint32_t GL_ALPHA = 6406;
static const uint32_t GL_RGB = 6407;
static const uint32_t GL_RGBA = 6408;
}

namespace TexelFormat_GLES_1_1 {
static const uint32_t GL_LUMINANCE = 6409;
static const uint32_t GL_LUMINANCE_ALPHA = 6410;
static const uint32_t GL_ALPHA = 6406;
static const uint32_t GL_RGB = 6407;
static const uint32_t GL_RGBA = 6408;
}

namespace TexelFormat_GLES_3_0 {
static const uint32_t GL_RED = 6403;
static const uint32_t GL_RED_INTEGER = 36244;
static const uint32_t GL_RG = 33319;
static const uint32_t GL_RG_INTEGER = 33320;
static const uint32_t GL_RGB_INTEGER = 36248;
static const uint32_t GL_RGBA_INTEGER = 36249;
static const uint32_t GL_DEPTH_COMPONENT = 6402;
static const uint32_t GL_DEPTH_COMPONENT16 = 33189;
static const uint32_t GL_DEPTH_STENCIL = 34041;
static const uint32_t GL_DEPTH24_STENCIL8 = 35056;
}

namespace TexelFormat {
static const uint32_t GL_LUMINANCE = 6409;
static const uint32_t GL_LUMINANCE_ALPHA = 6410;
static const uint32_t GL_ALPHA = 6406;
static const uint32_t GL_RGB = 6407;
static const uint32_t GL_RGBA = 6408;
static const uint32_t GL_RED = 6403;
static const uint32_t GL_RED_INTEGER = 36244;
static const uint32_t GL_RG = 33319;
static const uint32_t GL_RG_INTEGER = 33320;
static const uint32_t GL_RGB_INTEGER = 36248;
static const uint32_t GL_RGBA_INTEGER = 36249;
static const uint32_t GL_DEPTH_COMPONENT = 6402;
static const uint32_t GL_DEPTH_COMPONENT16 = 33189;
static const uint32_t GL_DEPTH_STENCIL = 34041;
static const uint32_t GL_DEPTH24_STENCIL8 = 35056;
}

namespace RenderbufferFormat {
static const uint32_t GL_RGBA4 = 32854;
static const uint32_t GL_RGB5_A1 = 32855;
static const uint32_t GL_RGB565 = 36194;
static const uint32_t GL_RGBA8 = 32856;
static const uint32_t GL_DEPTH_COMPONENT16 = 33189;
static const uint32_t GL_STENCIL_INDEX8 = 36168;
}

namespace Type_ARB_half_float_vertex {
static const uint32_t GL_ARB_half_float_vertex = 5131;
}

namespace Type_OES_vertex_half_float {
static const uint32_t GL_HALF_FLOAT_OES = 36193;
}

namespace CompressedTexelFormat_OES_compressed_ETC1_RGB8_texture {
static const uint32_t GL_ETC1_RGB8_OES = 36196;
}

namespace CompressedTexelFormat_AMD_compressed_ATC_texture {
static const uint32_t GL_ATC_RGB_AMD = 35986;
static const uint32_t GL_ATC_RGBA_EXPLICIT_ALPHA_AMD = 35987;
static const uint32_t GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD = 34798;
}

namespace CompressedTexelFormat {
static const uint32_t GL_ETC1_RGB8_OES = 36196;
static const uint32_t GL_ATC_RGB_AMD = 35986;
static const uint32_t GL_ATC_RGBA_EXPLICIT_ALPHA_AMD = 35987;
static const uint32_t GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD = 34798;
}

namespace ImageTexelFormat {
static const uint32_t GL_LUMINANCE = 6409;
static const uint32_t GL_LUMINANCE_ALPHA = 6410;
static const uint32_t GL_ALPHA = 6406;
static const uint32_t GL_RGB = 6407;
static const uint32_t GL_RGBA = 6408;
static const uint32_t GL_RED = 6403;
static const uint32_t GL_RED_INTEGER = 36244;
static const uint32_t GL_RG = 33319;
static const uint32_t GL_RG_INTEGER = 33320;
static const uint32_t GL_RGB_INTEGER = 36248;
static const uint32_t GL_RGBA_INTEGER = 36249;
static const uint32_t GL_DEPTH_COMPONENT = 6402;
static const uint32_t GL_DEPTH_COMPONENT16 = 33189;
static const uint32_t GL_DEPTH_STENCIL = 34041;
static const uint32_t GL_DEPTH24_STENCIL8 = 35056;
static const uint32_t GL_ETC1_RGB8_OES = 36196;
static const uint32_t GL_ATC_RGB_AMD = 35986;
static const uint32_t GL_ATC_RGBA_EXPLICIT_ALPHA_AMD = 35987;
static const uint32_t GL_ATC_RGBA_INTERPOLATED_ALPHA_AMD = 34798;
}

namespace TexelType {
static const uint32_t GL_UNSIGNED_BYTE = 5121;
static const uint32_t GL_UNSIGNED_SHORT = 5123;
static const uint32_t GL_UNSIGNED_INT = 5125;
static const uint32_t GL_FLOAT = 5126;
static const uint32_t GL_UNSIGNED_SHORT_4_4_4_4 = 32819;
static const uint32_t GL_UNSIGNED_SHORT_5_5_5_1 = 32820;
static const uint32_t GL_UNSIGNED_SHORT_5_6_5 = 33635;
static const uint32_t GL_UNSIGNED_INT_24_8 = 34042;
}

namespace FramebufferAttachment {
static const uint32_t GL_COLOR_ATTACHMENT0 = 36064;
static const uint32_t GL_DEPTH_ATTACHMENT = 36096;
static const uint32_t GL_STENCIL_ATTACHMENT = 36128;
}

namespace FramebufferAttachmentType {
static const uint32_t GL_NONE = 0;
static const uint32_t GL_RENDERBUFFER = 36161;
static const uint32_t GL_TEXTURE = 5890;
}

namespace FramebufferTarget_GLES_2_0 {
static const uint32_t GL_FRAMEBUFFER = 36160;
}

namespace FramebufferTarget_GLES_3_1 {
static const uint32_t GL_READ_FRAMEBUFFER = 36008;
static const uint32_t GL_DRAW_FRAMEBUFFER = 36009;
}

namespace FramebufferTarget {
static const uint32_t GL_FRAMEBUFFER = 36160;
static const uint32_t GL_READ_FRAMEBUFFER = 36008;
static const uint32_t GL_DRAW_FRAMEBUFFER = 36009;
}

namespace FramebufferAttachmentParameter {
static const uint32_t GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE = 36048;
static const uint32_t GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME = 36049;
static const uint32_t GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL = 36050;
static const uint32_t GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE = 36051;
}

namespace FramebufferStatus {
static const uint32_t GL_FRAMEBUFFER_COMPLETE = 36053;
static const uint32_t GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT = 36054;
static const uint32_t GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT = 36055;
static const uint32_t GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS = 36057;
static const uint32_t GL_FRAMEBUFFER_UNSUPPORTED = 36061;
}

namespace RenderbufferTarget {
static const uint32_t GL_RENDERBUFFER = 36161;
}

namespace RenderbufferParameter {
static const uint32_t GL_RENDERBUFFER_WIDTH = 36162;
static const uint32_t GL_RENDERBUFFER_HEIGHT = 36163;
static const uint32_t GL_RENDERBUFFER_INTERNAL_FORMAT = 36164;
static const uint32_t GL_RENDERBUFFER_RED_SIZE = 36176;
static const uint32_t GL_RENDERBUFFER_GREEN_SIZE = 36177;
static const uint32_t GL_RENDERBUFFER_BLUE_SIZE = 36178;
static const uint32_t GL_RENDERBUFFER_ALPHA_SIZE = 36179;
static const uint32_t GL_RENDERBUFFER_DEPTH_SIZE = 36180;
static const uint32_t GL_RENDERBUFFER_STENCIL_SIZE = 36181;
}

namespace BufferParameter {
static const uint32_t GL_BUFFER_SIZE = 34660;
static const uint32_t GL_BUFFER_USAGE = 34661;
}

namespace TextureUnit {
static const uint32_t GL_TEXTURE0 = 33984;
static const uint32_t GL_TEXTURE1 = 33985;
static const uint32_t GL_TEXTURE2 = 33986;
static const uint32_t GL_TEXTURE3 = 33987;
static const uint32_t GL_TEXTURE4 = 33988;
static const uint32_t GL_TEXTURE5 = 33989;
static const uint32_t GL_TEXTURE6 = 33990;
static const uint32_t GL_TEXTURE7 = 33991;
static const uint32_t GL_TEXTURE8 = 33992;
static const uint32_t GL_TEXTURE9 = 33993;
static const uint32_t GL_TEXTURE10 = 33994;
static const uint32_t GL_TEXTURE11 = 33995;
static const uint32_t GL_TEXTURE12 = 33996;
static const uint32_t GL_TEXTURE13 = 33997;
static const uint32_t GL_TEXTURE14 = 33998;
static const uint32_t GL_TEXTURE15 = 33999;
static const uint32_t GL_TEXTURE16 = 34000;
static const uint32_t GL_TEXTURE17 = 34001;
static const uint32_t GL_TEXTURE18 = 34002;
static const uint32_t GL_TEXTURE19 = 34003;
static const uint32_t GL_TEXTURE20 = 34004;
static const uint32_t GL_TEXTURE21 = 34005;
static const uint32_t GL_TEXTURE22 = 34006;
static const uint32_t GL_TEXTURE23 = 34007;
static const uint32_t GL_TEXTURE24 = 34008;
static const uint32_t GL_TEXTURE25 = 34009;
static const uint32_t GL_TEXTURE26 = 34010;
static const uint32_t GL_TEXTURE27 = 34011;
static const uint32_t GL_TEXTURE28 = 34012;
static const uint32_t GL_TEXTURE29 = 34013;
static const uint32_t GL_TEXTURE30 = 34014;
static const uint32_t GL_TEXTURE31 = 34015;
}

namespace BufferUsage {
static const uint32_t GL_DYNAMIC_DRAW = 35048;
static const uint32_t GL_STATIC_DRAW = 35044;
static const uint32_t GL_STREAM_DRAW = 35040;
}

namespace ShaderType {
static const uint32_t GL_VERTEX_SHADER = 35633;
static const uint32_t GL_FRAGMENT_SHADER = 35632;
}

namespace StateVariable_GLES_2_0 {
static const uint32_t GL_ACTIVE_TEXTURE = 34016;
static const uint32_t GL_ALIASED_LINE_WIDTH_RANGE = 33902;
static const uint32_t GL_ALIASED_POINT_SIZE_RANGE = 33901;
static const uint32_t GL_ALPHA_BITS = 3413;
static const uint32_t GL_ARRAY_BUFFER_BINDING = 34964;
static const uint32_t GL_BLEND = 3042;
static const uint32_t GL_BLEND_COLOR = 32773;
static const uint32_t GL_BLEND_DST_ALPHA = 32970;
static const uint32_t GL_BLEND_DST_RGB = 32968;
static const uint32_t GL_BLEND_EQUATION_ALPHA = 34877;
static const uint32_t GL_BLEND_EQUATION_RGB = 32777;
static const uint32_t GL_BLEND_SRC_ALPHA = 32971;
static const uint32_t GL_BLEND_SRC_RGB = 32969;
static const uint32_t GL_BLUE_BITS = 3412;
static const uint32_t GL_COLOR_CLEAR_VALUE = 3106;
static const uint32_t GL_COLOR_WRITEMASK = 3107;
static const uint32_t GL_COMPRESSED_TEXTURE_FORMATS = 34467;
static const uint32_t GL_CULL_FACE = 2884;
static const uint32_t GL_CULL_FACE_MODE = 2885;
static const uint32_t GL_CURRENT_PROGRAM = 35725;
static const uint32_t GL_DEPTH_BITS = 3414;
static const uint32_t GL_DEPTH_CLEAR_VALUE = 2931;
static const uint32_t GL_DEPTH_FUNC = 2932;
static const uint32_t GL_DEPTH_RANGE = 2928;
static const uint32_t GL_DEPTH_TEST = 2929;
static const uint32_t GL_DEPTH_WRITEMASK = 2930;
static const uint32_t GL_DITHER = 3024;
static const uint32_t GL_ELEMENT_ARRAY_BUFFER_BINDING = 34965;
static const uint32_t GL_FRAMEBUFFER_BINDING = 36006;
static const uint32_t GL_FRONT_FACE = 2886;
static const uint32_t GL_GENERATE_MIPMAP_HINT = 33170;
static const uint32_t GL_GREEN_BITS = 3411;
static const uint32_t GL_IMPLEMENTATION_COLOR_READ_FORMAT = 35739;
static const uint32_t GL_IMPLEMENTATION_COLOR_READ_TYPE = 35738;
static const uint32_t GL_LINE_WIDTH = 2849;
static const uint32_t GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = 35661;
static const uint32_t GL_MAX_CUBE_MAP_TEXTURE_SIZE = 34076;
static const uint32_t GL_MAX_FRAGMENT_UNIFORM_VECTORS = 36349;
static const uint32_t GL_MAX_RENDERBUFFER_SIZE = 34024;
static const uint32_t GL_MAX_TEXTURE_IMAGE_UNITS = 34930;
static const uint32_t GL_MAX_TEXTURE_SIZE = 3379;
static const uint32_t GL_MAX_VARYING_VECTORS = 36348;
static const uint32_t GL_MAX_VERTEX_ATTRIBS = 34921;
static const uint32_t GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS = 35660;
static const uint32_t GL_MAX_VERTEX_UNIFORM_VECTORS = 36347;
static const uint32_t GL_MAX_VIEWPORT_DIMS = 3386;
static const uint32_t GL_NUM_COMPRESSED_TEXTURE_FORMATS = 34466;
static const uint32_t GL_NUM_SHADER_BINARY_FORMATS = 36345;
static const uint32_t GL_PACK_ALIGNMENT = 3333;
static const uint32_t GL_POLYGON_OFFSET_FACTOR = 32824;
static const uint32_t GL_POLYGON_OFFSET_FILL = 32823;
static const uint32_t GL_POLYGON_OFFSET_UNITS = 10752;
static const uint32_t GL_RED_BITS = 3410;
static const uint32_t GL_RENDERBUFFER_BINDING = 36007;
static const uint32_t GL_SAMPLE_ALPHA_TO_COVERAGE = 32926;
static const uint32_t GL_SAMPLE_BUFFERS = 32936;
static const uint32_t GL_SAMPLE_COVERAGE = 32928;
static const uint32_t GL_SAMPLE_COVERAGE_INVERT = 32939;
static const uint32_t GL_SAMPLE_COVERAGE_VALUE = 32938;
static const uint32_t GL_SAMPLES = 32937;
static const uint32_t GL_SCISSOR_BOX = 3088;
static const uint32_t GL_SCISSOR_TEST = 3089;
static const uint32_t GL_SHADER_BINARY_FORMATS = 36344;
static const uint32_t GL_SHADER_COMPILER = 36346;
static const uint32_t GL_STENCIL_BACK_FAIL = 34817;
static const uint32_t GL_STENCIL_BACK_FUNC = 34816;
static const uint32_t GL_STENCIL_BACK_PASS_DEPTH_FAIL = 34818;
static const uint32_t GL_STENCIL_BACK_PASS_DEPTH_PASS = 34819;
static const uint32_t GL_STENCIL_BACK_REF = 36003;
static const uint32_t GL_STENCIL_BACK_VALUE_MASK = 36004;
static const uint32_t GL_STENCIL_BACK_WRITEMASK = 36005;
static const uint32_t GL_STENCIL_BITS = 3415;
static const uint32_t GL_STENCIL_CLEAR_VALUE = 2961;
static const uint32_t GL_STENCIL_FAIL = 2964;
static const uint32_t GL_STENCIL_FUNC = 2962;
static const uint32_t GL_STENCIL_PASS_DEPTH_FAIL = 2965;
static const uint32_t GL_STENCIL_PASS_DEPTH_PASS = 2966;
static const uint32_t GL_STENCIL_REF = 2967;
static const uint32_t GL_STENCIL_TEST = 2960;
static const uint32_t GL_STENCIL_VALUE_MASK = 2963;
static const uint32_t GL_STENCIL_WRITEMASK = 2968;
static const uint32_t GL_SUBPIXEL_BITS = 3408;
static const uint32_t GL_TEXTURE_BINDING_2D = 32873;
static const uint32_t GL_TEXTURE_BINDING_CUBE_MAP = 34068;
static const uint32_t GL_UNPACK_ALIGNMENT = 3317;
static const uint32_t GL_VIEWPORT = 2978;
}

namespace StateVariable_GLES_3_1 {
static const uint32_t GL_READ_FRAMEBUFFER_BINDING = 36010;
}

namespace StateVariable_EXT_texture_filter_anisotropic {
static const uint32_t GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 34047;
}

namespace StateVariable_EXT_disjoint_timer_query {
static const uint32_t GL_GPU_DISJOINT_EXT = 36795;
}

namespace StateVariable {
static const uint32_t GL_ACTIVE_TEXTURE = 34016;
static const uint32_t GL_ALIASED_LINE_WIDTH_RANGE = 33902;
static const uint32_t GL_ALIASED_POINT_SIZE_RANGE = 33901;
static const uint32_t GL_ALPHA_BITS = 3413;
static const uint32_t GL_ARRAY_BUFFER_BINDING = 34964;
static const uint32_t GL_BLEND = 3042;
static const uint32_t GL_BLEND_COLOR = 32773;
static const uint32_t GL_BLEND_DST_ALPHA = 32970;
static const uint32_t GL_BLEND_DST_RGB = 32968;
static const uint32_t GL_BLEND_EQUATION_ALPHA = 34877;
static const uint32_t GL_BLEND_EQUATION_RGB = 32777;
static const uint32_t GL_BLEND_SRC_ALPHA = 32971;
static const uint32_t GL_BLEND_SRC_RGB = 32969;
static const uint32_t GL_BLUE_BITS = 3412;
static const uint32_t GL_COLOR_CLEAR_VALUE = 3106;
static const uint32_t GL_COLOR_WRITEMASK = 3107;
static const uint32_t GL_COMPRESSED_TEXTURE_FORMATS = 34467;
static const uint32_t GL_CULL_FACE = 2884;
static const uint32_t GL_CULL_FACE_MODE = 2885;
static const uint32_t GL_CURRENT_PROGRAM = 35725;
static const uint32_t GL_DEPTH_BITS = 3414;
static const uint32_t GL_DEPTH_CLEAR_VALUE = 2931;
static const uint32_t GL_DEPTH_FUNC = 2932;
static const uint32_t GL_DEPTH_RANGE = 2928;
static const uint32_t GL_DEPTH_TEST = 2929;
static const uint32_t GL_DEPTH_WRITEMASK = 2930;
static const uint32_t GL_DITHER = 3024;
static const uint32_t GL_ELEMENT_ARRAY_BUFFER_BINDING = 34965;
static const uint32_t GL_FRAMEBUFFER_BINDING = 36006;
static const uint32_t GL_FRONT_FACE = 2886;
static const uint32_t GL_GENERATE_MIPMAP_HINT = 33170;
static const uint32_t GL_GREEN_BITS = 3411;
static const uint32_t GL_IMPLEMENTATION_COLOR_READ_FORMAT = 35739;
static const uint32_t GL_IMPLEMENTATION_COLOR_READ_TYPE = 35738;
static const uint32_t GL_LINE_WIDTH = 2849;
static const uint32_t GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = 35661;
static const uint32_t GL_MAX_CUBE_MAP_TEXTURE_SIZE = 34076;
static const uint32_t GL_MAX_FRAGMENT_UNIFORM_VECTORS = 36349;
static const uint32_t GL_MAX_RENDERBUFFER_SIZE = 34024;
static const uint32_t GL_MAX_TEXTURE_IMAGE_UNITS = 34930;
static const uint32_t GL_MAX_TEXTURE_SIZE = 3379;
static const uint32_t GL_MAX_VARYING_VECTORS = 36348;
static const uint32_t GL_MAX_VERTEX_ATTRIBS = 34921;
static const uint32_t GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS = 35660;
static const uint32_t GL_MAX_VERTEX_UNIFORM_VECTORS = 36347;
static const uint32_t GL_MAX_VIEWPORT_DIMS = 3386;
static const uint32_t GL_NUM_COMPRESSED_TEXTURE_FORMATS = 34466;
static const uint32_t GL_NUM_SHADER_BINARY_FORMATS = 36345;
static const uint32_t GL_PACK_ALIGNMENT = 3333;
static const uint32_t GL_POLYGON_OFFSET_FACTOR = 32824;
static const uint32_t GL_POLYGON_OFFSET_FILL = 32823;
static const uint32_t GL_POLYGON_OFFSET_UNITS = 10752;
static const uint32_t GL_RED_BITS = 3410;
static const uint32_t GL_RENDERBUFFER_BINDING = 36007;
static const uint32_t GL_SAMPLE_ALPHA_TO_COVERAGE = 32926;
static const uint32_t GL_SAMPLE_BUFFERS = 32936;
static const uint32_t GL_SAMPLE_COVERAGE = 32928;
static const uint32_t GL_SAMPLE_COVERAGE_INVERT = 32939;
static const uint32_t GL_SAMPLE_COVERAGE_VALUE = 32938;
static const uint32_t GL_SAMPLES = 32937;
static const uint32_t GL_SCISSOR_BOX = 3088;
static const uint32_t GL_SCISSOR_TEST = 3089;
static const uint32_t GL_SHADER_BINARY_FORMATS = 36344;
static const uint32_t GL_SHADER_COMPILER = 36346;
static const uint32_t GL_STENCIL_BACK_FAIL = 34817;
static const uint32_t GL_STENCIL_BACK_FUNC = 34816;
static const uint32_t GL_STENCIL_BACK_PASS_DEPTH_FAIL = 34818;
static const uint32_t GL_STENCIL_BACK_PASS_DEPTH_PASS = 34819;
static const uint32_t GL_STENCIL_BACK_REF = 36003;
static const uint32_t GL_STENCIL_BACK_VALUE_MASK = 36004;
static const uint32_t GL_STENCIL_BACK_WRITEMASK = 36005;
static const uint32_t GL_STENCIL_BITS = 3415;
static const uint32_t GL_STENCIL_CLEAR_VALUE = 2961;
static const uint32_t GL_STENCIL_FAIL = 2964;
static const uint32_t GL_STENCIL_FUNC = 2962;
static const uint32_t GL_STENCIL_PASS_DEPTH_FAIL = 2965;
static const uint32_t GL_STENCIL_PASS_DEPTH_PASS = 2966;
static const uint32_t GL_STENCIL_REF = 2967;
static const uint32_t GL_STENCIL_TEST = 2960;
static const uint32_t GL_STENCIL_VALUE_MASK = 2963;
static const uint32_t GL_STENCIL_WRITEMASK = 2968;
static const uint32_t GL_SUBPIXEL_BITS = 3408;
static const uint32_t GL_TEXTURE_BINDING_2D = 32873;
static const uint32_t GL_TEXTURE_BINDING_CUBE_MAP = 34068;
static const uint32_t GL_UNPACK_ALIGNMENT = 3317;
static const uint32_t GL_VIEWPORT = 2978;
static const uint32_t GL_READ_FRAMEBUFFER_BINDING = 36010;
static const uint32_t GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 34047;
static const uint32_t GL_GPU_DISJOINT_EXT = 36795;
}

namespace FaceMode {
static const uint32_t GL_FRONT = 1028;
static const uint32_t GL_BACK = 1029;
static const uint32_t GL_FRONT_AND_BACK = 1032;
}

namespace ArrayType_GLES_1_1 {
static const uint32_t GL_VERTEX_ARRAY = 32884;
static const uint32_t GL_NORMAL_ARRAY = 32885;
static const uint32_t GL_COLOR_ARRAY = 32886;
static const uint32_t GL_TEXTURE_COORD_ARRAY = 32888;
}

namespace ArrayType_OES_point_size_array {
static const uint32_t GL_POINT_SIZE_ARRAY_OES = 35740;
}

namespace ArrayType {
static const uint32_t GL_VERTEX_ARRAY = 32884;
static const uint32_t GL_NORMAL_ARRAY = 32885;
static const uint32_t GL_COLOR_ARRAY = 32886;
static const uint32_t GL_TEXTURE_COORD_ARRAY = 32888;
static const uint32_t GL_POINT_SIZE_ARRAY_OES = 35740;
}

namespace Capability {
static const uint32_t GL_BLEND = 3042;
static const uint32_t GL_CULL_FACE = 2884;
static const uint32_t GL_DEPTH_TEST = 2929;
static const uint32_t GL_DITHER = 3024;
static const uint32_t GL_POLYGON_OFFSET_FILL = 32823;
static const uint32_t GL_SAMPLE_ALPHA_TO_COVERAGE = 32926;
static const uint32_t GL_SAMPLE_COVERAGE = 32928;
static const uint32_t GL_SCISSOR_TEST = 3089;
static const uint32_t GL_STENCIL_TEST = 2960;
static const uint32_t GL_VERTEX_ARRAY = 32884;
static const uint32_t GL_NORMAL_ARRAY = 32885;
static const uint32_t GL_COLOR_ARRAY = 32886;
static const uint32_t GL_TEXTURE_COORD_ARRAY = 32888;
static const uint32_t GL_POINT_SIZE_ARRAY_OES = 35740;
}

namespace StringConstant {
static const uint32_t GL_EXTENSIONS = 7939;
static const uint32_t GL_RENDERER = 7937;
static const uint32_t GL_VENDOR = 7936;
static const uint32_t GL_VERSION = 7938;
}

namespace VertexAttribType {
static const uint32_t GL_BYTE = 5120;
static const uint32_t GL_FIXED = 5132;
static const uint32_t GL_FLOAT = 5126;
static const uint32_t GL_SHORT = 5122;
static const uint32_t GL_UNSIGNED_BYTE = 5121;
static const uint32_t GL_UNSIGNED_SHORT = 5123;
static const uint32_t GL_HALF_FLOAT_OES = 36193;
static const uint32_t GL_ARB_half_float_vertex = 5131;
}

namespace ShaderAttribType {
static const uint32_t GL_FLOAT = 5126;
static const uint32_t GL_FLOAT_VEC2 = 35664;
static const uint32_t GL_FLOAT_VEC3 = 35665;
static const uint32_t GL_FLOAT_VEC4 = 35666;
static const uint32_t GL_FLOAT_MAT2 = 35674;
static const uint32_t GL_FLOAT_MAT3 = 35675;
static const uint32_t GL_FLOAT_MAT4 = 35676;
}

namespace ShaderUniformType {
static const uint32_t GL_FLOAT = 5126;
static const uint32_t GL_FLOAT_VEC2 = 35664;
static const uint32_t GL_FLOAT_VEC3 = 35665;
static const uint32_t GL_FLOAT_VEC4 = 35666;
static const uint32_t GL_INT = 5124;
static const uint32_t GL_INT_VEC2 = 35667;
static const uint32_t GL_INT_VEC3 = 35668;
static const uint32_t GL_INT_VEC4 = 35669;
static const uint32_t GL_BOOL = 35670;
static const uint32_t GL_BOOL_VEC2 = 35671;
static const uint32_t GL_BOOL_VEC3 = 35672;
static const uint32_t GL_BOOL_VEC4 = 35673;
static const uint32_t GL_FLOAT_MAT2 = 35674;
static const uint32_t GL_FLOAT_MAT3 = 35675;
static const uint32_t GL_FLOAT_MAT4 = 35676;
static const uint32_t GL_SAMPLER_2D = 35678;
static const uint32_t GL_SAMPLER_CUBE = 35680;
}

namespace Error {
static const uint32_t GL_NO_ERROR = 0;
static const uint32_t GL_INVALID_ENUM = 1280;
static const uint32_t GL_INVALID_VALUE = 1281;
static const uint32_t GL_INVALID_OPERATION = 1282;
static const uint32_t GL_INVALID_FRAMEBUFFER_OPERATION = 1286;
static const uint32_t GL_OUT_OF_MEMORY = 1285;
}

namespace HintTarget {
static const uint32_t GL_GENERATE_MIPMAP_HINT = 33170;
}

namespace HintMode {
static const uint32_t GL_DONT_CARE = 4352;
static const uint32_t GL_FASTEST = 4353;
static const uint32_t GL_NICEST = 4354;
}

namespace DiscardFramebufferAttachment {
static const uint32_t GL_COLOR_EXT = 6144;
static const uint32_t GL_DEPTH_EXT = 6145;
static const uint32_t GL_STENCIL_EXT = 6146;
}

namespace ProgramParameter {
static const uint32_t GL_DELETE_STATUS = 35712;
static const uint32_t GL_LINK_STATUS = 35714;
static const uint32_t GL_VALIDATE_STATUS = 35715;
static const uint32_t GL_INFO_LOG_LENGTH = 35716;
static const uint32_t GL_ATTACHED_SHADERS = 35717;
static const uint32_t GL_ACTIVE_ATTRIBUTES = 35721;
static const uint32_t GL_ACTIVE_ATTRIBUTE_MAX_LENGTH = 35722;
static const uint32_t GL_ACTIVE_UNIFORMS = 35718;
static const uint32_t GL_ACTIVE_UNIFORM_MAX_LENGTH = 35719;
}

namespace ShaderParameter {
static const uint32_t GL_SHADER_TYPE = 35663;
static const uint32_t GL_DELETE_STATUS = 35712;
static const uint32_t GL_COMPILE_STATUS = 35713;
static const uint32_t GL_INFO_LOG_LENGTH = 35716;
static const uint32_t GL_SHADER_SOURCE_LENGTH = 35720;
}

namespace PixelStoreParameter {
static const uint32_t GL_PACK_ALIGNMENT = 3333;
static const uint32_t GL_UNPACK_ALIGNMENT = 3317;
}

namespace TextureParameter_FilterMode {
static const uint32_t GL_TEXTURE_MIN_FILTER = 10241;
static const uint32_t GL_TEXTURE_MAG_FILTER = 10240;
}

namespace TextureParameter_WrapMode {
static const uint32_t GL_TEXTURE_WRAP_S = 10242;
static const uint32_t GL_TEXTURE_WRAP_T = 10243;
}

namespace TextureParameter_EXT_texture_filter_anisotropic {
static const uint32_t GL_TEXTURE_MAX_ANISOTROPY_EXT = 34046;
}

namespace TextureParameter_SwizzleMode {
static const uint32_t GL_TEXTURE_SWIZZLE_R = 36418;
static const uint32_t GL_TEXTURE_SWIZZLE_G = 36419;
static const uint32_t GL_TEXTURE_SWIZZLE_B = 36420;
static const uint32_t GL_TEXTURE_SWIZZLE_A = 36421;
}

namespace TextureParameter {
static const uint32_t GL_TEXTURE_MIN_FILTER = 10241;
static const uint32_t GL_TEXTURE_MAG_FILTER = 10240;
static const uint32_t GL_TEXTURE_WRAP_S = 10242;
static const uint32_t GL_TEXTURE_WRAP_T = 10243;
static const uint32_t GL_TEXTURE_SWIZZLE_R = 36418;
static const uint32_t GL_TEXTURE_SWIZZLE_G = 36419;
static const uint32_t GL_TEXTURE_SWIZZLE_B = 36420;
static const uint32_t GL_TEXTURE_SWIZZLE_A = 36421;
static const uint32_t GL_TEXTURE_MAX_ANISOTROPY_EXT = 34046;
}

namespace TextureFilterMode {
static const uint32_t GL_NEAREST = 9728;
static const uint32_t GL_LINEAR = 9729;
static const uint32_t GL_NEAREST_MIPMAP_NEAREST = 9984;
static const uint32_t GL_LINEAR_MIPMAP_NEAREST = 9985;
static const uint32_t GL_NEAREST_MIPMAP_LINEAR = 9986;
static const uint32_t GL_LINEAR_MIPMAP_LINEAR = 9987;
}

namespace TextureWrapMode {
static const uint32_t GL_CLAMP_TO_EDGE = 33071;
static const uint32_t GL_MIRRORED_REPEAT = 33648;
static const uint32_t GL_REPEAT = 10497;
}

namespace TexelComponent {
static const uint32_t GL_RED = 6403;
static const uint32_t GL_GREEN = 6404;
static const uint32_t GL_BLUE = 6405;
static const uint32_t GL_ALPHA = 6406;
}

namespace BlendFactor {
static const uint32_t GL_ZERO = 0;
static const uint32_t GL_ONE = 1;
static const uint32_t GL_SRC_COLOR = 768;
static const uint32_t GL_ONE_MINUS_SRC_COLOR = 769;
static const uint32_t GL_DST_COLOR = 774;
static const uint32_t GL_ONE_MINUS_DST_COLOR = 775;
static const uint32_t GL_SRC_ALPHA = 770;
static const uint32_t GL_ONE_MINUS_SRC_ALPHA = 771;
static const uint32_t GL_DST_ALPHA = 772;
static const uint32_t GL_ONE_MINUS_DST_ALPHA = 773;
static const uint32_t GL_CONSTANT_COLOR = 32769;
static const uint32_t GL_ONE_MINUS_CONSTANT_COLOR = 32770;
static const uint32_t GL_CONSTANT_ALPHA = 32771;
static const uint32_t GL_ONE_MINUS_CONSTANT_ALPHA = 32772;
static const uint32_t GL_SRC_ALPHA_SATURATE = 776;
}

namespace PrecisionType {
static const uint32_t GL_LOW_FLOAT = 36336;
static const uint32_t GL_MEDIUM_FLOAT = 36337;
static const uint32_t GL_HIGH_FLOAT = 36338;
static const uint32_t GL_LOW_INT = 36339;
static const uint32_t GL_MEDIUM_INT = 36340;
static const uint32_t GL_HIGH_INT = 36341;
}

namespace TestFunction {
static const uint32_t GL_NEVER = 512;
static const uint32_t GL_LESS = 513;
static const uint32_t GL_EQUAL = 514;
static const uint32_t GL_LEQUAL = 515;
static const uint32_t GL_GREATER = 516;
static const uint32_t GL_NOTEQUAL = 517;
static const uint32_t GL_GEQUAL = 518;
static const uint32_t GL_ALWAYS = 519;
}

namespace StencilAction {
static const uint32_t GL_KEEP = 7680;
static const uint32_t GL_ZERO = 0;
static const uint32_t GL_REPLACE = 7681;
static const uint32_t GL_INCR = 7682;
static const uint32_t GL_INCR_WRAP = 34055;
static const uint32_t GL_DECR = 7683;
static const uint32_t GL_DECR_WRAP = 34056;
static const uint32_t GL_INVERT = 5386;
}

namespace FaceOrientation {
static const uint32_t GL_CW = 2304;
static const uint32_t GL_CCW = 2305;
}

namespace BlendEquation {
static const uint32_t GL_FUNC_ADD = 32774;
static const uint32_t GL_FUNC_SUBTRACT = 32778;
static const uint32_t GL_FUNC_REVERSE_SUBTRACT = 32779;
}

namespace BufferTarget {
static const uint32_t GL_ARRAY_BUFFER = 34962;
static const uint32_t GL_COPY_READ_BUFFER = 36662;
static const uint32_t GL_COPY_WRITE_BUFFER = 36663;
static const uint32_t GL_ELEMENT_ARRAY_BUFFER = 34963;
static const uint32_t GL_PIXEL_PACK_BUFFER = 35051;
static const uint32_t GL_PIXEL_UNPACK_BUFFER = 35052;
static const uint32_t GL_TRANSFORM_FEEDBACK_BUFFER = 35982;
static const uint32_t GL_UNIFORM_BUFFER = 35345;
}

namespace ImageTargetTexture_OES_EGL_image {
static const uint32_t GL_TEXTURE_2D = 3553;
}

namespace ImageTargetTexture_OES_EGL_image_external {
static const uint32_t GL_TEXTURE_EXTERNAL_OES = 36197;
}

namespace ImageTargetTexture {
static const uint32_t GL_TEXTURE_2D = 3553;
static const uint32_t GL_TEXTURE_EXTERNAL_OES = 36197;
}

namespace ImageTargetRenderbufferStorage {
static const uint32_t GL_RENDERBUFFER_OES = 36161;
}

namespace ResetStatus {
static const uint32_t GL_NO_ERROR = 0;
static const uint32_t GL_GUILTY_CONTEXT_RESET_EXT = 33363;
static const uint32_t GL_INNOCENT_CONTEXT_RESET_EXT = 33364;
static const uint32_t GL_UNKNOWN_CONTEXT_RESET_EXT = 33365;
}

namespace TextureKind {
static const uint32_t UNDEFINED = 0;
static const uint32_t TEXTURE2D = 1;
static const uint32_t CUBEMAP = 2;
}

namespace QueryParameter_GLES_3 {
static const uint32_t GL_CURRENT_QUERY = 34917;
}

namespace QueryParameter_EXT_disjoint_timer_query {
static const uint32_t GL_QUERY_COUNTER_BITS_EXT = 34916;
}

namespace QueryParameter {
static const uint32_t GL_CURRENT_QUERY = 34917;
static const uint32_t GL_QUERY_COUNTER_BITS_EXT = 34916;
}

namespace QueryObjectParameter_GLES_3 {
static const uint32_t GL_QUERY_RESULT = 34918;
static const uint32_t GL_QUERY_RESULT_AVAILABLE = 34919;
}

namespace QueryObjectParameter_EXT_disjoint_timer_query {}

namespace QueryObjectParameter {
static const uint32_t GL_QUERY_RESULT = 34918;
static const uint32_t GL_QUERY_RESULT_AVAILABLE = 34919;
}

namespace QueryTarget_GLES_3 {
static const uint32_t GL_ANY_SAMPLES_PASSED = 35887;
static const uint32_t GL_ANY_SAMPLES_PASSED_CONSERVATIVE = 36202;
static const uint32_t GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN = 35976;
}

namespace QueryTarget_EXT_disjoint_timer_query {
static const uint32_t GL_TIME_ELAPSED_EXT = 35007;
static const uint32_t GL_TIMESTAMP_EXT = 36392;
}

namespace QueryTarget {
static const uint32_t GL_ANY_SAMPLES_PASSED = 35887;
static const uint32_t GL_ANY_SAMPLES_PASSED_CONSERVATIVE = 36202;
static const uint32_t GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN = 35976;
static const uint32_t GL_TIME_ELAPSED_EXT = 35007;
static const uint32_t GL_TIMESTAMP_EXT = 36392;
}

namespace TilePreserveMaskQCOM {
static const uint32_t GL_COLOR_BUFFER_BIT0_QCOM = 1;
static const uint32_t GL_COLOR_BUFFER_BIT1_QCOM = 2;
static const uint32_t GL_COLOR_BUFFER_BIT2_QCOM = 4;
static const uint32_t GL_COLOR_BUFFER_BIT3_QCOM = 8;
static const uint32_t GL_COLOR_BUFFER_BIT4_QCOM = 16;
static const uint32_t GL_COLOR_BUFFER_BIT5_QCOM = 32;
static const uint32_t GL_COLOR_BUFFER_BIT6_QCOM = 64;
static const uint32_t GL_COLOR_BUFFER_BIT7_QCOM = 128;
static const uint32_t GL_DEPTH_BUFFER_BIT0_QCOM = 256;
static const uint32_t GL_DEPTH_BUFFER_BIT1_QCOM = 512;
static const uint32_t GL_DEPTH_BUFFER_BIT2_QCOM = 1024;
static const uint32_t GL_DEPTH_BUFFER_BIT3_QCOM = 2048;
static const uint32_t GL_DEPTH_BUFFER_BIT4_QCOM = 4096;
static const uint32_t GL_DEPTH_BUFFER_BIT5_QCOM = 8192;
static const uint32_t GL_DEPTH_BUFFER_BIT6_QCOM = 16384;
static const uint32_t GL_DEPTH_BUFFER_BIT7_QCOM = 32768;
static const uint32_t GL_STENCIL_BUFFER_BIT0_QCOM = 65536;
static const uint32_t GL_STENCIL_BUFFER_BIT1_QCOM = 131072;
static const uint32_t GL_STENCIL_BUFFER_BIT2_QCOM = 262144;
static const uint32_t GL_STENCIL_BUFFER_BIT3_QCOM = 524288;
static const uint32_t GL_STENCIL_BUFFER_BIT4_QCOM = 1048576;
static const uint32_t GL_STENCIL_BUFFER_BIT5_QCOM = 2097152;
static const uint32_t GL_STENCIL_BUFFER_BIT6_QCOM = 4194304;
static const uint32_t GL_STENCIL_BUFFER_BIT7_QCOM = 8388608;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT0_QCOM = 16777216;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT1_QCOM = 33554432;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT2_QCOM = 67108864;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT3_QCOM = 134217728;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT4_QCOM = 268435456;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT5_QCOM = 536870912;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT6_QCOM = 1073741824;
static const uint32_t GL_MULTISAMPLE_BUFFER_BIT7_QCOM = 2147483648;
}

namespace ClearMask {
static const uint32_t GL_COLOR_BUFFER_BIT = 16384;
static const uint32_t GL_DEPTH_BUFFER_BIT = 256;
static const uint32_t GL_STENCIL_BUFFER_BIT = 1024;
}

namespace MapBufferRangeAccess {
static const uint32_t GL_MAP_READ_BIT = 1;
static const uint32_t GL_MAP_WRITE_BIT = 2;
static const uint32_t GL_MAP_INVALIDATE_RANGE_BIT = 4;
static const uint32_t GL_MAP_INVALIDATE_BUFFER_BIT = 8;
static const uint32_t GL_MAP_FLUSH_EXPLICIT_BIT = 16;
static const uint32_t GL_MAP_UNSYNCHRONIZED_BIT = 32;
}

typedef uint32_t RenderbufferId;

typedef uint32_t TextureId;

typedef uint32_t FramebufferId;

typedef uint32_t BufferId;

typedef uint32_t ShaderId;

typedef uint32_t ProgramId;

typedef uint32_t VertexArrayId;

typedef uint32_t QueryId;

typedef int32_t UniformLocation;

typedef uint32_t AttributeLocation;

typedef void* IndicesPointer;

typedef void* VertexPointer;

typedef void* TexturePointer;

typedef void* BufferDataPointer;

typedef uint32_t ContextID;

typedef uint32_t ThreadID;

typedef int EGLBoolean;

typedef int EGLint;

typedef void* EGLConfig;

typedef void* EGLContext;

typedef void* EGLDisplay;

typedef void* EGLSurface;

typedef void* GLXContext;

typedef void* GLXDrawable;

typedef void* HGLRC;

typedef void* HDC;

typedef int BOOL;

typedef int CGLError;

typedef void* CGLPixelFormatObj;

typedef void* CGLContextObj;

typedef void* ImageOES;

struct VertexAttributeArray {
    inline VertexAttributeArray& SetEnabled(bool v) {
        mEnabled = v;
        return *this;
    }
    inline VertexAttributeArray& SetSize(uint32_t v) {
        mSize = v;
        return *this;
    }
    inline VertexAttributeArray& SetType(uint32_t v) {
        mType = v;
        return *this;
    }
    inline VertexAttributeArray& SetNormalized(bool v) {
        mNormalized = v;
        return *this;
    }
    inline VertexAttributeArray& SetStride(int32_t v) {
        mStride = v;
        return *this;
    }
    inline VertexAttributeArray& SetBuffer(BufferId v) {
        mBuffer = v;
        return *this;
    }
    inline VertexAttributeArray& SetPointer(VertexPointer v) {
        mPointer = v;
        return *this;
    }

    bool mEnabled;
    uint32_t mSize;
    uint32_t mType;
    bool mNormalized;
    int32_t mStride;
    BufferId mBuffer;
    VertexPointer mPointer;
};

typedef std::unordered_map<AttributeLocation, std::shared_ptr<VertexAttributeArray>>
        AttributeLocationToVertexAttributeArrayRef;

struct Buffer {
    inline Buffer& SetData(Slice<uint8_t> v) {
        mData = v;
        return *this;
    }
    inline Buffer& SetSize(int32_t v) {
        mSize = v;
        return *this;
    }
    inline Buffer& SetUsage(uint32_t v) {
        mUsage = v;
        return *this;
    }

    Slice<uint8_t> mData;
    int32_t mSize;
    uint32_t mUsage;
};

typedef std::unordered_map<BufferId, std::shared_ptr<Buffer>> BufferIdToBufferRef;

typedef std::unordered_map<uint32_t, BufferId> BufferTargetToBufferId;

struct Color {
    inline Color& SetRed(float v) {
        mRed = v;
        return *this;
    }
    inline Color& SetGreen(float v) {
        mGreen = v;
        return *this;
    }
    inline Color& SetBlue(float v) {
        mBlue = v;
        return *this;
    }
    inline Color& SetAlpha(float v) {
        mAlpha = v;
        return *this;
    }

    float mRed;
    float mGreen;
    float mBlue;
    float mAlpha;
};

struct BlendState {
    inline BlendState& SetSrcRgbBlendFactor(uint32_t v) {
        mSrcRgbBlendFactor = v;
        return *this;
    }
    inline BlendState& SetSrcAlphaBlendFactor(uint32_t v) {
        mSrcAlphaBlendFactor = v;
        return *this;
    }
    inline BlendState& SetDstRgbBlendFactor(uint32_t v) {
        mDstRgbBlendFactor = v;
        return *this;
    }
    inline BlendState& SetDstAlphaBlendFactor(uint32_t v) {
        mDstAlphaBlendFactor = v;
        return *this;
    }
    inline BlendState& SetBlendEquationRgb(uint32_t v) {
        mBlendEquationRgb = v;
        return *this;
    }
    inline BlendState& SetBlendEquationAlpha(uint32_t v) {
        mBlendEquationAlpha = v;
        return *this;
    }
    inline BlendState& SetBlendColor(Color v) {
        mBlendColor = v;
        return *this;
    }

    uint32_t mSrcRgbBlendFactor;
    uint32_t mSrcAlphaBlendFactor;
    uint32_t mDstRgbBlendFactor;
    uint32_t mDstAlphaBlendFactor;
    uint32_t mBlendEquationRgb;
    uint32_t mBlendEquationAlpha;
    Color mBlendColor;
};

typedef std::unordered_map<uint32_t, uint32_t> FaceModeToU32;

struct Rect {
    inline Rect& SetX(int32_t v) {
        mX = v;
        return *this;
    }
    inline Rect& SetY(int32_t v) {
        mY = v;
        return *this;
    }
    inline Rect& SetWidth(int32_t v) {
        mWidth = v;
        return *this;
    }
    inline Rect& SetHeight(int32_t v) {
        mHeight = v;
        return *this;
    }

    int32_t mX;
    int32_t mY;
    int32_t mWidth;
    int32_t mHeight;
};

struct RasterizerState {
    inline RasterizerState& SetDepthMask(bool v) {
        mDepthMask = v;
        return *this;
    }
    inline RasterizerState& SetDepthTestFunction(uint32_t v) {
        mDepthTestFunction = v;
        return *this;
    }
    inline RasterizerState& SetDepthNear(float v) {
        mDepthNear = v;
        return *this;
    }
    inline RasterizerState& SetDepthFar(float v) {
        mDepthFar = v;
        return *this;
    }
    inline RasterizerState& SetColorMaskRed(bool v) {
        mColorMaskRed = v;
        return *this;
    }
    inline RasterizerState& SetColorMaskGreen(bool v) {
        mColorMaskGreen = v;
        return *this;
    }
    inline RasterizerState& SetColorMaskBlue(bool v) {
        mColorMaskBlue = v;
        return *this;
    }
    inline RasterizerState& SetColorMaskAlpha(bool v) {
        mColorMaskAlpha = v;
        return *this;
    }
    inline RasterizerState& SetStencilMask(FaceModeToU32 v) {
        mStencilMask = v;
        return *this;
    }
    inline RasterizerState& SetViewport(Rect v) {
        mViewport = v;
        return *this;
    }
    inline RasterizerState& SetScissor(Rect v) {
        mScissor = v;
        return *this;
    }
    inline RasterizerState& SetFrontFace(uint32_t v) {
        mFrontFace = v;
        return *this;
    }
    inline RasterizerState& SetCullFace(uint32_t v) {
        mCullFace = v;
        return *this;
    }
    inline RasterizerState& SetLineWidth(float v) {
        mLineWidth = v;
        return *this;
    }
    inline RasterizerState& SetPolygonOffsetFactor(float v) {
        mPolygonOffsetFactor = v;
        return *this;
    }
    inline RasterizerState& SetPolygonOffsetUnits(float v) {
        mPolygonOffsetUnits = v;
        return *this;
    }
    inline RasterizerState& SetSampleCoverageValue(float v) {
        mSampleCoverageValue = v;
        return *this;
    }
    inline RasterizerState& SetSampleCoverageInvert(bool v) {
        mSampleCoverageInvert = v;
        return *this;
    }

    bool mDepthMask;
    uint32_t mDepthTestFunction;
    float mDepthNear;
    float mDepthFar;
    bool mColorMaskRed;
    bool mColorMaskGreen;
    bool mColorMaskBlue;
    bool mColorMaskAlpha;
    FaceModeToU32 mStencilMask;
    Rect mViewport;
    Rect mScissor;
    uint32_t mFrontFace;
    uint32_t mCullFace;
    float mLineWidth;
    float mPolygonOffsetFactor;
    float mPolygonOffsetUnits;
    float mSampleCoverageValue;
    bool mSampleCoverageInvert;
};

struct ClearState {
    inline ClearState& SetClearColor(Color v) {
        mClearColor = v;
        return *this;
    }
    inline ClearState& SetClearDepth(float v) {
        mClearDepth = v;
        return *this;
    }
    inline ClearState& SetClearStencil(int32_t v) {
        mClearStencil = v;
        return *this;
    }

    Color mClearColor;
    float mClearDepth;
    int32_t mClearStencil;
};

typedef std::unordered_map<uint32_t, FramebufferId> FramebufferTargetToFramebufferId;

typedef std::unordered_map<uint32_t, RenderbufferId> RenderbufferTargetToRenderbufferId;

typedef std::unordered_map<uint32_t, TextureId> TextureTargetToTextureId;

typedef std::unordered_map<uint32_t, TextureTargetToTextureId>
        TextureUnitToTextureTargetToTextureId;

typedef std::unordered_map<uint32_t, bool> CapabilityToBool;

typedef std::unordered_map<uint32_t, int32_t> PixelStoreParameterToS32;

struct Renderbuffer {
    inline Renderbuffer& SetWidth(int32_t v) {
        mWidth = v;
        return *this;
    }
    inline Renderbuffer& SetHeight(int32_t v) {
        mHeight = v;
        return *this;
    }
    inline Renderbuffer& SetData(Slice<uint8_t> v) {
        mData = v;
        return *this;
    }
    inline Renderbuffer& SetFormat(uint32_t v) {
        mFormat = v;
        return *this;
    }

    int32_t mWidth;
    int32_t mHeight;
    Slice<uint8_t> mData;
    uint32_t mFormat;
};

typedef std::unordered_map<RenderbufferId, std::shared_ptr<Renderbuffer>>
        RenderbufferIdToRenderbufferRef;

struct Image {
    inline Image& SetWidth(int32_t v) {
        mWidth = v;
        return *this;
    }
    inline Image& SetHeight(int32_t v) {
        mHeight = v;
        return *this;
    }
    inline Image& SetData(Slice<uint8_t> v) {
        mData = v;
        return *this;
    }
    inline Image& SetSize(uint32_t v) {
        mSize = v;
        return *this;
    }
    inline Image& SetFormat(uint32_t v) {
        mFormat = v;
        return *this;
    }

    int32_t mWidth;
    int32_t mHeight;
    Slice<uint8_t> mData;
    uint32_t mSize;
    uint32_t mFormat;
};

typedef std::unordered_map<int32_t, Image> S32ToImage;

typedef std::unordered_map<uint32_t, Image> CubeMapImageTargetToImage;

struct CubemapLevel {
    inline CubemapLevel& SetFaces(CubeMapImageTargetToImage v) {
        mFaces = v;
        return *this;
    }

    CubeMapImageTargetToImage mFaces;
};

typedef std::unordered_map<int32_t, CubemapLevel> S32ToCubemapLevel;

struct Texture {
    inline Texture& SetKind(uint32_t v) {
        mKind = v;
        return *this;
    }
    inline Texture& SetFormat(uint32_t v) {
        mFormat = v;
        return *this;
    }
    inline Texture& SetTexture2D(S32ToImage v) {
        mTexture2D = v;
        return *this;
    }
    inline Texture& SetCubemap(S32ToCubemapLevel v) {
        mCubemap = v;
        return *this;
    }
    inline Texture& SetMagFilter(uint32_t v) {
        mMagFilter = v;
        return *this;
    }
    inline Texture& SetMinFilter(uint32_t v) {
        mMinFilter = v;
        return *this;
    }
    inline Texture& SetWrapS(uint32_t v) {
        mWrapS = v;
        return *this;
    }
    inline Texture& SetWrapT(uint32_t v) {
        mWrapT = v;
        return *this;
    }
    inline Texture& SetSwizzleR(uint32_t v) {
        mSwizzleR = v;
        return *this;
    }
    inline Texture& SetSwizzleG(uint32_t v) {
        mSwizzleG = v;
        return *this;
    }
    inline Texture& SetSwizzleB(uint32_t v) {
        mSwizzleB = v;
        return *this;
    }
    inline Texture& SetSwizzleA(uint32_t v) {
        mSwizzleA = v;
        return *this;
    }
    inline Texture& SetMaxAnisotropy(float v) {
        mMaxAnisotropy = v;
        return *this;
    }

    uint32_t mKind;
    uint32_t mFormat;
    S32ToImage mTexture2D;
    S32ToCubemapLevel mCubemap;
    uint32_t mMagFilter;
    uint32_t mMinFilter;
    uint32_t mWrapS;
    uint32_t mWrapT;
    uint32_t mSwizzleR;
    uint32_t mSwizzleG;
    uint32_t mSwizzleB;
    uint32_t mSwizzleA;
    float mMaxAnisotropy;
};

typedef std::unordered_map<TextureId, std::shared_ptr<Texture>> TextureIdToTextureRef;

struct FramebufferAttachmentInfo {
    inline FramebufferAttachmentInfo& SetObject(uint32_t v) {
        mObject = v;
        return *this;
    }
    inline FramebufferAttachmentInfo& SetType(uint32_t v) {
        mType = v;
        return *this;
    }
    inline FramebufferAttachmentInfo& SetTextureLevel(int32_t v) {
        mTextureLevel = v;
        return *this;
    }
    inline FramebufferAttachmentInfo& SetCubeMapFace(uint32_t v) {
        mCubeMapFace = v;
        return *this;
    }

    uint32_t mObject;
    uint32_t mType;
    int32_t mTextureLevel;
    uint32_t mCubeMapFace;
};

typedef std::unordered_map<uint32_t, FramebufferAttachmentInfo>
        FramebufferAttachmentToFramebufferAttachmentInfo;

struct Framebuffer {
    inline Framebuffer& SetAttachments(FramebufferAttachmentToFramebufferAttachmentInfo v) {
        mAttachments = v;
        return *this;
    }

    FramebufferAttachmentToFramebufferAttachmentInfo mAttachments;
};

typedef std::unordered_map<FramebufferId, std::shared_ptr<Framebuffer>>
        FramebufferIdToFramebufferRef;

struct Shader {
    inline Shader& SetBinary(Slice<uint8_t> v) {
        mBinary = v;
        return *this;
    }
    inline Shader& SetCompiled(bool v) {
        mCompiled = v;
        return *this;
    }
    inline Shader& SetDeletable(bool v) {
        mDeletable = v;
        return *this;
    }
    inline Shader& SetInfoLog(Slice<char> v) {
        mInfoLog = v;
        return *this;
    }
    inline Shader& SetSource(std::string v) {
        mSource = v;
        return *this;
    }
    inline Shader& SetType(uint32_t v) {
        mType = v;
        return *this;
    }

    Slice<uint8_t> mBinary;
    bool mCompiled;
    bool mDeletable;
    Slice<char> mInfoLog;
    std::string mSource;
    uint32_t mType;
};

typedef std::unordered_map<ShaderId, std::shared_ptr<Shader>> ShaderIdToShaderRef;

typedef std::unordered_map<uint32_t, ShaderId> ShaderTypeToShaderId;

typedef std::unordered_map<std::string, AttributeLocation> StringToAttributeLocation;

struct VertexAttribute {
    inline VertexAttribute& SetName(Slice<char> v) {
        mName = v;
        return *this;
    }
    inline VertexAttribute& SetVectorCount(int32_t v) {
        mVectorCount = v;
        return *this;
    }
    inline VertexAttribute& SetType(uint32_t v) {
        mType = v;
        return *this;
    }

    Slice<char> mName;
    int32_t mVectorCount;
    uint32_t mType;
};

typedef std::unordered_map<int32_t, VertexAttribute> S32ToVertexAttribute;

struct Vec2f {
    inline Vec2f& SetX(float v) {
        mX = v;
        return *this;
    }
    inline Vec2f& SetY(float v) {
        mY = v;
        return *this;
    }

    float mX;
    float mY;
};

struct Vec3f {
    inline Vec3f& SetX(float v) {
        mX = v;
        return *this;
    }
    inline Vec3f& SetY(float v) {
        mY = v;
        return *this;
    }
    inline Vec3f& SetZ(float v) {
        mZ = v;
        return *this;
    }

    float mX;
    float mY;
    float mZ;
};

struct Vec4f {
    inline Vec4f& SetX(float v) {
        mX = v;
        return *this;
    }
    inline Vec4f& SetY(float v) {
        mY = v;
        return *this;
    }
    inline Vec4f& SetZ(float v) {
        mZ = v;
        return *this;
    }
    inline Vec4f& SetW(float v) {
        mW = v;
        return *this;
    }

    float mX;
    float mY;
    float mZ;
    float mW;
};

struct Vec2i {
    inline Vec2i& SetX(int32_t v) {
        mX = v;
        return *this;
    }
    inline Vec2i& SetY(int32_t v) {
        mY = v;
        return *this;
    }

    int32_t mX;
    int32_t mY;
};

struct Vec3i {
    inline Vec3i& SetX(int32_t v) {
        mX = v;
        return *this;
    }
    inline Vec3i& SetY(int32_t v) {
        mY = v;
        return *this;
    }
    inline Vec3i& SetZ(int32_t v) {
        mZ = v;
        return *this;
    }

    int32_t mX;
    int32_t mY;
    int32_t mZ;
};

struct Vec4i {
    inline Vec4i& SetX(int32_t v) {
        mX = v;
        return *this;
    }
    inline Vec4i& SetY(int32_t v) {
        mY = v;
        return *this;
    }
    inline Vec4i& SetZ(int32_t v) {
        mZ = v;
        return *this;
    }
    inline Vec4i& SetW(int32_t v) {
        mW = v;
        return *this;
    }

    int32_t mX;
    int32_t mY;
    int32_t mZ;
    int32_t mW;
};

struct Mat2f {
    inline Mat2f& SetCol0(Vec2f v) {
        mCol0 = v;
        return *this;
    }
    inline Mat2f& SetCol1(Vec2f v) {
        mCol1 = v;
        return *this;
    }

    Vec2f mCol0;
    Vec2f mCol1;
};

struct Mat3f {
    inline Mat3f& SetCol0(Vec3f v) {
        mCol0 = v;
        return *this;
    }
    inline Mat3f& SetCol1(Vec3f v) {
        mCol1 = v;
        return *this;
    }
    inline Mat3f& SetCol2(Vec3f v) {
        mCol2 = v;
        return *this;
    }

    Vec3f mCol0;
    Vec3f mCol1;
    Vec3f mCol2;
};

struct Mat4f {
    inline Mat4f& SetCol0(Vec4f v) {
        mCol0 = v;
        return *this;
    }
    inline Mat4f& SetCol1(Vec4f v) {
        mCol1 = v;
        return *this;
    }
    inline Mat4f& SetCol2(Vec4f v) {
        mCol2 = v;
        return *this;
    }
    inline Mat4f& SetCol3(Vec4f v) {
        mCol3 = v;
        return *this;
    }

    Vec4f mCol0;
    Vec4f mCol1;
    Vec4f mCol2;
    Vec4f mCol3;
};

struct UniformValue {
    inline UniformValue& SetF32(float v) {
        mF32 = v;
        return *this;
    }
    inline UniformValue& SetVec2f(Vec2f v) {
        mVec2f = v;
        return *this;
    }
    inline UniformValue& SetVec3f(Vec3f v) {
        mVec3f = v;
        return *this;
    }
    inline UniformValue& SetVec4f(Vec4f v) {
        mVec4f = v;
        return *this;
    }
    inline UniformValue& SetS32(int32_t v) {
        mS32 = v;
        return *this;
    }
    inline UniformValue& SetVec2i(Vec2i v) {
        mVec2i = v;
        return *this;
    }
    inline UniformValue& SetVec3i(Vec3i v) {
        mVec3i = v;
        return *this;
    }
    inline UniformValue& SetVec4i(Vec4i v) {
        mVec4i = v;
        return *this;
    }
    inline UniformValue& SetMat2f(Mat2f v) {
        mMat2f = v;
        return *this;
    }
    inline UniformValue& SetMat3f(Mat3f v) {
        mMat3f = v;
        return *this;
    }
    inline UniformValue& SetMat4f(Mat4f v) {
        mMat4f = v;
        return *this;
    }

    float mF32;
    Vec2f mVec2f;
    Vec3f mVec3f;
    Vec4f mVec4f;
    int32_t mS32;
    Vec2i mVec2i;
    Vec3i mVec3i;
    Vec4i mVec4i;
    Mat2f mMat2f;
    Mat3f mMat3f;
    Mat4f mMat4f;
};

struct Uniform {
    inline Uniform& SetName(std::string v) {
        mName = v;
        return *this;
    }
    inline Uniform& SetType(uint32_t v) {
        mType = v;
        return *this;
    }
    inline Uniform& SetValue(UniformValue v) {
        mValue = v;
        return *this;
    }

    std::string mName;
    uint32_t mType;
    UniformValue mValue;
};

typedef std::unordered_map<UniformLocation, Uniform> UniformLocationToUniform;

struct Program {
    inline Program& SetShaders(ShaderTypeToShaderId v) {
        mShaders = v;
        return *this;
    }
    inline Program& SetLinked(bool v) {
        mLinked = v;
        return *this;
    }
    inline Program& SetBinary(Slice<uint8_t> v) {
        mBinary = v;
        return *this;
    }
    inline Program& SetAttributeBindings(StringToAttributeLocation v) {
        mAttributeBindings = v;
        return *this;
    }
    inline Program& SetAttributes(S32ToVertexAttribute v) {
        mAttributes = v;
        return *this;
    }
    inline Program& SetUniforms(UniformLocationToUniform v) {
        mUniforms = v;
        return *this;
    }
    inline Program& SetInfoLog(Slice<char> v) {
        mInfoLog = v;
        return *this;
    }

    ShaderTypeToShaderId mShaders;
    bool mLinked;
    Slice<uint8_t> mBinary;
    StringToAttributeLocation mAttributeBindings;
    S32ToVertexAttribute mAttributes;
    UniformLocationToUniform mUniforms;
    Slice<char> mInfoLog;
};

typedef std::unordered_map<ProgramId, std::shared_ptr<Program>> ProgramIdToProgramRef;

struct VertexArray {};

typedef std::unordered_map<VertexArrayId, std::shared_ptr<VertexArray>>
        VertexArrayIdToVertexArrayRef;

struct Query {};

typedef std::unordered_map<QueryId, std::shared_ptr<Query>> QueryIdToQueryRef;

struct Objects {
    inline Objects& SetRenderbuffers(RenderbufferIdToRenderbufferRef v) {
        mRenderbuffers = v;
        return *this;
    }
    inline Objects& SetTextures(TextureIdToTextureRef v) {
        mTextures = v;
        return *this;
    }
    inline Objects& SetFramebuffers(FramebufferIdToFramebufferRef v) {
        mFramebuffers = v;
        return *this;
    }
    inline Objects& SetBuffers(BufferIdToBufferRef v) {
        mBuffers = v;
        return *this;
    }
    inline Objects& SetShaders(ShaderIdToShaderRef v) {
        mShaders = v;
        return *this;
    }
    inline Objects& SetPrograms(ProgramIdToProgramRef v) {
        mPrograms = v;
        return *this;
    }
    inline Objects& SetVertexArrays(VertexArrayIdToVertexArrayRef v) {
        mVertexArrays = v;
        return *this;
    }
    inline Objects& SetQueries(QueryIdToQueryRef v) {
        mQueries = v;
        return *this;
    }

    RenderbufferIdToRenderbufferRef mRenderbuffers;
    TextureIdToTextureRef mTextures;
    FramebufferIdToFramebufferRef mFramebuffers;
    BufferIdToBufferRef mBuffers;
    ShaderIdToShaderRef mShaders;
    ProgramIdToProgramRef mPrograms;
    VertexArrayIdToVertexArrayRef mVertexArrays;
    QueryIdToQueryRef mQueries;
};

struct Context {
    inline Context& SetIdentifier(ContextID v) {
        mIdentifier = v;
        return *this;
    }
    inline Context& SetBlending(BlendState v) {
        mBlending = v;
        return *this;
    }
    inline Context& SetRasterizing(RasterizerState v) {
        mRasterizing = v;
        return *this;
    }
    inline Context& SetClearing(ClearState v) {
        mClearing = v;
        return *this;
    }
    inline Context& SetBoundFramebuffers(FramebufferTargetToFramebufferId v) {
        mBoundFramebuffers = v;
        return *this;
    }
    inline Context& SetBoundRenderbuffers(RenderbufferTargetToRenderbufferId v) {
        mBoundRenderbuffers = v;
        return *this;
    }
    inline Context& SetBoundBuffers(BufferTargetToBufferId v) {
        mBoundBuffers = v;
        return *this;
    }
    inline Context& SetBoundProgram(ProgramId v) {
        mBoundProgram = v;
        return *this;
    }
    inline Context& SetBoundVertexArray(VertexArrayId v) {
        mBoundVertexArray = v;
        return *this;
    }
    inline Context& SetVertexAttributeArrays(AttributeLocationToVertexAttributeArrayRef v) {
        mVertexAttributeArrays = v;
        return *this;
    }
    inline Context& SetTextureUnits(TextureUnitToTextureTargetToTextureId v) {
        mTextureUnits = v;
        return *this;
    }
    inline Context& SetActiveTextureUnit(uint32_t v) {
        mActiveTextureUnit = v;
        return *this;
    }
    inline Context& SetCapabilities(CapabilityToBool v) {
        mCapabilities = v;
        return *this;
    }
    inline Context& SetGenerateMipmapHint(uint32_t v) {
        mGenerateMipmapHint = v;
        return *this;
    }
    inline Context& SetPixelStorage(PixelStoreParameterToS32 v) {
        mPixelStorage = v;
        return *this;
    }
    inline Context& SetInstances(Objects v) {
        mInstances = v;
        return *this;
    }

    ContextID mIdentifier;
    BlendState mBlending;
    RasterizerState mRasterizing;
    ClearState mClearing;
    FramebufferTargetToFramebufferId mBoundFramebuffers;
    RenderbufferTargetToRenderbufferId mBoundRenderbuffers;
    BufferTargetToBufferId mBoundBuffers;
    ProgramId mBoundProgram;
    VertexArrayId mBoundVertexArray;
    AttributeLocationToVertexAttributeArrayRef mVertexAttributeArrays;
    TextureUnitToTextureTargetToTextureId mTextureUnits;
    uint32_t mActiveTextureUnit;
    CapabilityToBool mCapabilities;
    uint32_t mGenerateMipmapHint;
    PixelStoreParameterToS32 mPixelStorage;
    Objects mInstances;
};

typedef std::unordered_map<CGLContextObj, std::shared_ptr<Context>> CGLContextObjToContextRef;

typedef std::unordered_map<EGLContext, std::shared_ptr<Context>> EGLContextToContextRef;

typedef std::unordered_map<GLXContext, std::shared_ptr<Context>> GLXContextToContextRef;

typedef std::unordered_map<HGLRC, std::shared_ptr<Context>> HGLRCToContextRef;

typedef std::unordered_map<ThreadID, std::shared_ptr<Context>> ThreadIDToContextRef;

}  // namespace gapii

#endif  // GAPII_GLES_TYPES_H
