////////////////////////////////////////////////////////////////////////////////
// Do not modify!
// Generated by codergen -cpp=coder
////////////////////////////////////////////////////////////////////////////////



namespace gapic {

class Encodable;
class Encoder;

namespace coder {
namespace gles {
    class Architecture: public Encodable {
    public:
        Architecture(atom::Observations observations, uint32_t PointerAlignment, uint32_t PointerSize, uint32_t IntegerSize, bool LittleEndian) :
            mobservations(observations),
            mPointerAlignment(PointerAlignment),
            mPointerSize(PointerSize),
            mIntegerSize(IntegerSize),
            mLittleEndian(LittleEndian) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x14, 0x53, 0xe8, 0x31, 0x7d, 0x20, 0x5f, 0xbd, 0xad, 0x68, 0x48, 0x67, 0xeb, 0xf6, 0x1c, 0x4f, 0xe8, 0xfc, 0x0e, 0x01,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mPointerAlignment);
            e->Uint32(this->mPointerSize);
            e->Uint32(this->mIntegerSize);
            e->Bool(this->mLittleEndian);
        }

        atom::Observations mobservations;
        uint32_t mPointerAlignment;
        uint32_t mPointerSize;
        uint32_t mIntegerSize;
        bool mLittleEndian;
    };

    class BackbufferInfo: public Encodable {
    public:
        BackbufferInfo(atom::Observations observations, int32_t Width, int32_t Height, RenderbufferFormat ColorFmt, RenderbufferFormat DepthFmt, RenderbufferFormat StencilFmt, bool ResetViewportScissor) :
            mobservations(observations),
            mWidth(Width),
            mHeight(Height),
            mColorFmt(ColorFmt),
            mDepthFmt(DepthFmt),
            mStencilFmt(StencilFmt),
            mResetViewportScissor(ResetViewportScissor) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x44, 0xeb, 0x57, 0x06, 0xf9, 0xfd, 0x06, 0xab, 0xc2, 0xa7, 0xdc, 0xa2, 0xba, 0xd0, 0xe3, 0x8f, 0x76, 0x7c, 0x81, 0x0f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Uint32(this->mColorFmt);
            e->Uint32(this->mDepthFmt);
            e->Uint32(this->mStencilFmt);
            e->Bool(this->mResetViewportScissor);
        }

        atom::Observations mobservations;
        int32_t mWidth;
        int32_t mHeight;
        RenderbufferFormat mColorFmt;
        RenderbufferFormat mDepthFmt;
        RenderbufferFormat mStencilFmt;
        bool mResetViewportScissor;
    };

    class Color: public Encodable {
    public:
        Color(atom::ID CreatedAt, float Red, float Green, float Blue, float Alpha) :
            mCreatedAt(CreatedAt),
            mRed(Red),
            mGreen(Green),
            mBlue(Blue),
            mAlpha(Alpha) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe7, 0x31, 0x0f, 0x05, 0x26, 0x27, 0x37, 0x3a, 0xc4, 0xbb, 0x59, 0xea, 0xc0, 0x41, 0xb0, 0xa7, 0x8f, 0x15, 0x58, 0xb4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Float32(this->mRed);
            e->Float32(this->mGreen);
            e->Float32(this->mBlue);
            e->Float32(this->mAlpha);
        }

        atom::ID mCreatedAt;
        float mRed;
        float mGreen;
        float mBlue;
        float mAlpha;
    };

    class BlendState: public Encodable {
    public:
        BlendState(atom::ID CreatedAt, BlendFactor SrcRgbBlendFactor, BlendFactor SrcAlphaBlendFactor, BlendFactor DstRgbBlendFactor, BlendFactor DstAlphaBlendFactor, BlendEquation BlendEquationRgb, BlendEquation BlendEquationAlpha, Color BlendColor) :
            mCreatedAt(CreatedAt),
            mSrcRgbBlendFactor(SrcRgbBlendFactor),
            mSrcAlphaBlendFactor(SrcAlphaBlendFactor),
            mDstRgbBlendFactor(DstRgbBlendFactor),
            mDstAlphaBlendFactor(DstAlphaBlendFactor),
            mBlendEquationRgb(BlendEquationRgb),
            mBlendEquationAlpha(BlendEquationAlpha),
            mBlendColor(BlendColor) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x29, 0x77, 0xc4, 0x8b, 0x77, 0xa3, 0x4d, 0x9c, 0x4d, 0x61, 0x12, 0xcf, 0x1f, 0x04, 0x1a, 0x82, 0x82, 0x33, 0xb3, 0xf2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Uint32(this->mSrcRgbBlendFactor);
            e->Uint32(this->mSrcAlphaBlendFactor);
            e->Uint32(this->mDstRgbBlendFactor);
            e->Uint32(this->mDstAlphaBlendFactor);
            e->Uint32(this->mBlendEquationRgb);
            e->Uint32(this->mBlendEquationAlpha);
            e->Value(&this->mBlendColor);
        }

        atom::ID mCreatedAt;
        BlendFactor mSrcRgbBlendFactor;
        BlendFactor mSrcAlphaBlendFactor;
        BlendFactor mDstRgbBlendFactor;
        BlendFactor mDstAlphaBlendFactor;
        BlendEquation mBlendEquationRgb;
        BlendEquation mBlendEquationAlpha;
        Color mBlendColor;
    };

    class Bool__S: public Encodable {
    public:
        Bool__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf2, 0x31, 0x4c, 0xf9, 0x86, 0x85, 0x72, 0x97, 0x87, 0x94, 0x51, 0x90, 0x4d, 0x16, 0x83, 0xd3, 0x87, 0xc0, 0xe7, 0x91,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Bool__P: public Encodable {
    public:
        Bool__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x99, 0x14, 0xff, 0xcd, 0xe4, 0x5a, 0xa6, 0x40, 0x28, 0xce, 0x7f, 0x59, 0x66, 0x8e, 0x03, 0x31, 0x08, 0x3e, 0x1b, 0x8a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class U8__S: public Encodable {
    public:
        U8__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf9, 0x82, 0x6b, 0xf3, 0x87, 0x60, 0x43, 0xc9, 0x9f, 0x38, 0x49, 0x47, 0xd0, 0x41, 0xc5, 0x84, 0x27, 0x96, 0xfd, 0x24,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Buffer: public Encodable {
    public:
        Buffer(atom::ID CreatedAt, U8__S Data, int32_t Size, BufferUsage Usage) :
            mCreatedAt(CreatedAt),
            mData(Data),
            mSize(Size),
            mUsage(Usage) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xcb, 0x13, 0xd8, 0x5c, 0x1e, 0x96, 0x94, 0x10, 0x35, 0x50, 0xc5, 0x56, 0x64, 0xc7, 0xa6, 0x9e, 0x0c, 0xe2, 0x7d, 0x9e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mData);
            e->Int32(this->mSize);
            e->Uint32(this->mUsage);
        }

        atom::ID mCreatedAt;
        U8__S mData;
        int32_t mSize;
        BufferUsage mUsage;
    };

    class BufferDataPointer: public Encodable {
    public:
        BufferDataPointer(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xec, 0x9b, 0x06, 0x05, 0x8b, 0x40, 0x9b, 0x3e, 0x3b, 0xf2, 0x28, 0x02, 0x1d, 0x73, 0xbb, 0xf2, 0x75, 0x70, 0x0e, 0x69,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class BufferId__S: public Encodable {
    public:
        BufferId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x9e, 0xbe, 0xba, 0x6e, 0x12, 0xa1, 0x4b, 0x3b, 0xc1, 0x33, 0xa6, 0xd2, 0x80, 0x9d, 0x7e, 0xf4, 0x4a, 0x72, 0x9a, 0x28,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class BufferId__P: public Encodable {
    public:
        BufferId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4e, 0x93, 0x7a, 0x49, 0x93, 0xb1, 0x5e, 0x9f, 0x01, 0x00, 0x5f, 0xa1, 0x77, 0xff, 0x03, 0x71, 0x93, 0x81, 0x7a, 0x22,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class CGLContextObj: public Encodable {
    public:
        CGLContextObj(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xab, 0x86, 0x6f, 0x74, 0x93, 0x88, 0x54, 0x0f, 0x24, 0x0f, 0x0b, 0xc0, 0x3c, 0x31, 0x13, 0xf7, 0x84, 0x0b, 0xc2, 0x53,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class CGLContextObj__S: public Encodable {
    public:
        CGLContextObj__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x54, 0x66, 0xf0, 0x00, 0xf0, 0x49, 0x85, 0x49, 0xc6, 0x59, 0x2b, 0x56, 0x85, 0xa2, 0x6d, 0xbc, 0xd7, 0x0d, 0xda, 0x14,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class CGLContextObj__P: public Encodable {
    public:
        CGLContextObj__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa5, 0xae, 0x0c, 0xd1, 0xe4, 0x8a, 0xce, 0xaa, 0x58, 0x17, 0x44, 0x03, 0x19, 0xcc, 0xf2, 0xea, 0x50, 0x88, 0x53, 0xb9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class CGLPixelFormatObj: public Encodable {
    public:
        CGLPixelFormatObj(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x81, 0x5b, 0xcb, 0x83, 0x09, 0xbc, 0x3d, 0x7e, 0x40, 0x9c, 0xdd, 0x21, 0x56, 0xa3, 0x69, 0xef, 0x28, 0xea, 0x84, 0x41,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class CGLCreateContext: public Encodable {
    public:
        CGLCreateContext(atom::Observations observations, CGLPixelFormatObj Pix, CGLContextObj Share, CGLContextObj__P Ctx, CGLError Result) :
            mobservations(observations),
            mPix(Pix),
            mShare(Share),
            mCtx(Ctx),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x87, 0xeb, 0x7f, 0x5e, 0x46, 0xd1, 0x7c, 0xf4, 0x3c, 0x36, 0x44, 0x4b, 0x60, 0x5d, 0xaf, 0xc5, 0x43, 0xc5, 0x2c, 0x61,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mPix);
            e->Value(&this->mShare);
            e->Value(&this->mCtx);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        CGLPixelFormatObj mPix;
        CGLContextObj mShare;
        CGLContextObj__P mCtx;
        CGLError mResult;
    };

    class CGLSetCurrentContext: public Encodable {
    public:
        CGLSetCurrentContext(atom::Observations observations, CGLContextObj Ctx, CGLError Result) :
            mobservations(observations),
            mCtx(Ctx),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x88, 0xc1, 0x83, 0x0a, 0xe8, 0x2c, 0x03, 0xa0, 0x88, 0x20, 0xb9, 0x75, 0xfd, 0xb0, 0x14, 0xca, 0xbd, 0x78, 0x2d, 0x6f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mCtx);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        CGLContextObj mCtx;
        CGLError mResult;
    };

    class Char__S: public Encodable {
    public:
        Char__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb2, 0xde, 0x84, 0xd8, 0x9f, 0x13, 0x4a, 0xfe, 0x30, 0xb6, 0xee, 0x4b, 0x75, 0x23, 0x79, 0x8e, 0xbf, 0x8f, 0xf0, 0xeb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Char__P: public Encodable {
    public:
        Char__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x67, 0xe3, 0xfd, 0x6e, 0x09, 0x7e, 0xa7, 0x65, 0x7f, 0x40, 0x8d, 0xd4, 0x35, 0x40, 0xcc, 0x38, 0x25, 0x23, 0x66, 0xdf,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class Char__P__S: public Encodable {
    public:
        Char__P__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4d, 0x87, 0xa4, 0x53, 0x04, 0x96, 0x09, 0x70, 0xea, 0xd3, 0xea, 0x46, 0x04, 0x87, 0x25, 0xbc, 0x66, 0xa2, 0x7c, 0xa9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Char__P__P: public Encodable {
    public:
        Char__P__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x1f, 0x0a, 0x07, 0xb4, 0xda, 0x1f, 0xda, 0x6d, 0x01, 0xbb, 0xd6, 0x9b, 0x33, 0xf9, 0x9c, 0x19, 0xa8, 0x14, 0x5b, 0x5e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class ClearState: public Encodable {
    public:
        ClearState(atom::ID CreatedAt, Color ClearColor, float ClearDepth, int32_t ClearStencil) :
            mCreatedAt(CreatedAt),
            mClearColor(ClearColor),
            mClearDepth(ClearDepth),
            mClearStencil(ClearStencil) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd3, 0xbe, 0x8f, 0x85, 0x49, 0x55, 0xe3, 0x17, 0x03, 0xb1, 0x02, 0x1c, 0xe0, 0x2d, 0x25, 0x8c, 0x17, 0x53, 0xc5, 0x62,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mClearColor);
            e->Float32(this->mClearDepth);
            e->Int32(this->mClearStencil);
        }

        atom::ID mCreatedAt;
        Color mClearColor;
        float mClearDepth;
        int32_t mClearStencil;
    };

    class Rect: public Encodable {
    public:
        Rect(atom::ID CreatedAt, int32_t X, int32_t Y, int32_t Width, int32_t Height) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x14, 0xc0, 0x01, 0xd8, 0x95, 0xd6, 0x6b, 0xab, 0xce, 0x31, 0x74, 0x35, 0x6b, 0x11, 0x57, 0xb5, 0xc8, 0x6f, 0x52, 0xdc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::ID mCreatedAt;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
    };

    class RasterizerState: public Encodable {
    public:
        RasterizerState(atom::ID CreatedAt, bool DepthMask, TestFunction DepthTestFunction, float DepthNear, float DepthFar, bool ColorMaskRed, bool ColorMaskGreen, bool ColorMaskBlue, bool ColorMaskAlpha, std::unordered_map<FaceMode,uint32_t>* StencilMask, Rect Viewport, Rect Scissor, FaceOrientation FrontFace, FaceMode CullFace, float LineWidth, float PolygonOffsetFactor, float PolygonOffsetUnits, float SampleCoverageValue, bool SampleCoverageInvert) :
            mCreatedAt(CreatedAt),
            mDepthMask(DepthMask),
            mDepthTestFunction(DepthTestFunction),
            mDepthNear(DepthNear),
            mDepthFar(DepthFar),
            mColorMaskRed(ColorMaskRed),
            mColorMaskGreen(ColorMaskGreen),
            mColorMaskBlue(ColorMaskBlue),
            mColorMaskAlpha(ColorMaskAlpha),
            mStencilMask(StencilMask),
            mViewport(Viewport),
            mScissor(Scissor),
            mFrontFace(FrontFace),
            mCullFace(CullFace),
            mLineWidth(LineWidth),
            mPolygonOffsetFactor(PolygonOffsetFactor),
            mPolygonOffsetUnits(PolygonOffsetUnits),
            mSampleCoverageValue(SampleCoverageValue),
            mSampleCoverageInvert(SampleCoverageInvert) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x51, 0x6b, 0x55, 0xed, 0xe3, 0x43, 0x1c, 0xe8, 0x28, 0x3f, 0x1d, 0xeb, 0x3b, 0x37, 0x21, 0x9f, 0x89, 0xbc, 0xdb, 0x28,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Bool(this->mDepthMask);
            e->Uint32(this->mDepthTestFunction);
            e->Float32(this->mDepthNear);
            e->Float32(this->mDepthFar);
            e->Bool(this->mColorMaskRed);
            e->Bool(this->mColorMaskGreen);
            e->Bool(this->mColorMaskBlue);
            e->Bool(this->mColorMaskAlpha);
            
            e->Value(&this->mViewport);
            e->Value(&this->mScissor);
            e->Uint32(this->mFrontFace);
            e->Uint32(this->mCullFace);
            e->Float32(this->mLineWidth);
            e->Float32(this->mPolygonOffsetFactor);
            e->Float32(this->mPolygonOffsetUnits);
            e->Float32(this->mSampleCoverageValue);
            e->Bool(this->mSampleCoverageInvert);
        }

        atom::ID mCreatedAt;
        bool mDepthMask;
        TestFunction mDepthTestFunction;
        float mDepthNear;
        float mDepthFar;
        bool mColorMaskRed;
        bool mColorMaskGreen;
        bool mColorMaskBlue;
        bool mColorMaskAlpha;
        std::unordered_map<FaceMode,uint32_t>* mStencilMask;
        Rect mViewport;
        Rect mScissor;
        FaceOrientation mFrontFace;
        FaceMode mCullFace;
        float mLineWidth;
        float mPolygonOffsetFactor;
        float mPolygonOffsetUnits;
        float mSampleCoverageValue;
        bool mSampleCoverageInvert;
    };

    class VertexPointer: public Encodable {
    public:
        VertexPointer(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbb, 0xd9, 0x9d, 0xbc, 0x5d, 0xd2, 0xa9, 0x87, 0x68, 0x91, 0xd2, 0xd2, 0xc2, 0xc9, 0x9d, 0xf6, 0xdd, 0xe2, 0x3c, 0x6c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class VertexAttributeArray: public Encodable {
    public:
        VertexAttributeArray(atom::ID CreatedAt, bool Enabled, uint32_t Size, VertexAttribType Type, bool Normalized, int32_t Stride, BufferId Buffer, VertexPointer Pointer) :
            mCreatedAt(CreatedAt),
            mEnabled(Enabled),
            mSize(Size),
            mType(Type),
            mNormalized(Normalized),
            mStride(Stride),
            mBuffer(Buffer),
            mPointer(Pointer) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa4, 0x7d, 0x5e, 0xd9, 0x3b, 0x4e, 0x4e, 0xc2, 0xc4, 0x2b, 0x81, 0xe9, 0xc8, 0x56, 0xf6, 0xf9, 0x63, 0x47, 0xca, 0x11,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Bool(this->mEnabled);
            e->Uint32(this->mSize);
            e->Uint32(this->mType);
            e->Bool(this->mNormalized);
            e->Int32(this->mStride);
            e->Uint32(this->mBuffer);
            e->Value(&this->mPointer);
        }

        atom::ID mCreatedAt;
        bool mEnabled;
        uint32_t mSize;
        VertexAttribType mType;
        bool mNormalized;
        int32_t mStride;
        BufferId mBuffer;
        VertexPointer mPointer;
    };

    class Renderbuffer: public Encodable {
    public:
        Renderbuffer(atom::ID CreatedAt, int32_t Width, int32_t Height, U8__S Data, RenderbufferFormat Format) :
            mCreatedAt(CreatedAt),
            mWidth(Width),
            mHeight(Height),
            mData(Data),
            mFormat(Format) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x84, 0x68, 0xd5, 0xd8, 0xde, 0xfc, 0xbd, 0x62, 0xda, 0xc3, 0x55, 0x74, 0xbf, 0xc5, 0x6c, 0xe8, 0xa5, 0xa3, 0xe7, 0x70,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Value(&this->mData);
            e->Uint32(this->mFormat);
        }

        atom::ID mCreatedAt;
        int32_t mWidth;
        int32_t mHeight;
        U8__S mData;
        RenderbufferFormat mFormat;
    };

    class Image: public Encodable {
    public:
        Image(atom::ID CreatedAt, int32_t Width, int32_t Height, U8__S Data, uint32_t Size, ImageTexelFormat Format) :
            mCreatedAt(CreatedAt),
            mWidth(Width),
            mHeight(Height),
            mData(Data),
            mSize(Size),
            mFormat(Format) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0a, 0x10, 0xd1, 0xf9, 0x89, 0x9f, 0x2a, 0xa6, 0xd6, 0xbf, 0x08, 0x1a, 0xf9, 0x7c, 0xb7, 0xa1, 0x48, 0xa1, 0xd8, 0xea,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Value(&this->mData);
            e->Uint32(this->mSize);
            e->Uint32(this->mFormat);
        }

        atom::ID mCreatedAt;
        int32_t mWidth;
        int32_t mHeight;
        U8__S mData;
        uint32_t mSize;
        ImageTexelFormat mFormat;
    };

    class CubemapLevel: public Encodable {
    public:
        CubemapLevel(atom::ID CreatedAt, std::unordered_map<CubeMapImageTarget,Image>* Faces) :
            mCreatedAt(CreatedAt),
            mFaces(Faces) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x51, 0xd8, 0xc2, 0xc5, 0x3b, 0xfd, 0x61, 0x52, 0x9f, 0xaa, 0xee, 0x67, 0x5e, 0x16, 0x51, 0xe7, 0x92, 0x04, 0x17, 0xd6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            
        }

        atom::ID mCreatedAt;
        std::unordered_map<CubeMapImageTarget,Image>* mFaces;
    };

    class Texture: public Encodable {
    public:
        Texture(atom::ID CreatedAt, TextureKind Kind, ImageTexelFormat Format, std::unordered_map<int32_t,Image>* Texture2D, std::unordered_map<int32_t,CubemapLevel>* Cubemap, TextureFilterMode MagFilter, TextureFilterMode MinFilter, TextureWrapMode WrapS, TextureWrapMode WrapT, TexelComponent SwizzleR, TexelComponent SwizzleG, TexelComponent SwizzleB, TexelComponent SwizzleA, float MaxAnisotropy) :
            mCreatedAt(CreatedAt),
            mKind(Kind),
            mFormat(Format),
            mTexture2D(Texture2D),
            mCubemap(Cubemap),
            mMagFilter(MagFilter),
            mMinFilter(MinFilter),
            mWrapS(WrapS),
            mWrapT(WrapT),
            mSwizzleR(SwizzleR),
            mSwizzleG(SwizzleG),
            mSwizzleB(SwizzleB),
            mSwizzleA(SwizzleA),
            mMaxAnisotropy(MaxAnisotropy) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa0, 0xdb, 0xfc, 0x07, 0xdf, 0x4d, 0x1d, 0x3c, 0x05, 0x98, 0x63, 0x48, 0x82, 0xd8, 0xc8, 0x09, 0x24, 0xa9, 0xe4, 0xb7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Uint32(this->mKind);
            e->Uint32(this->mFormat);
            
            
            e->Uint32(this->mMagFilter);
            e->Uint32(this->mMinFilter);
            e->Uint32(this->mWrapS);
            e->Uint32(this->mWrapT);
            e->Uint32(this->mSwizzleR);
            e->Uint32(this->mSwizzleG);
            e->Uint32(this->mSwizzleB);
            e->Uint32(this->mSwizzleA);
            e->Float32(this->mMaxAnisotropy);
        }

        atom::ID mCreatedAt;
        TextureKind mKind;
        ImageTexelFormat mFormat;
        std::unordered_map<int32_t,Image>* mTexture2D;
        std::unordered_map<int32_t,CubemapLevel>* mCubemap;
        TextureFilterMode mMagFilter;
        TextureFilterMode mMinFilter;
        TextureWrapMode mWrapS;
        TextureWrapMode mWrapT;
        TexelComponent mSwizzleR;
        TexelComponent mSwizzleG;
        TexelComponent mSwizzleB;
        TexelComponent mSwizzleA;
        float mMaxAnisotropy;
    };

    class FramebufferAttachmentInfo: public Encodable {
    public:
        FramebufferAttachmentInfo(atom::ID CreatedAt, uint32_t Object, FramebufferAttachmentType Type, int32_t TextureLevel, CubeMapImageTarget CubeMapFace) :
            mCreatedAt(CreatedAt),
            mObject(Object),
            mType(Type),
            mTextureLevel(TextureLevel),
            mCubeMapFace(CubeMapFace) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x28, 0x1b, 0x2d, 0xbd, 0x74, 0xc0, 0x84, 0xc8, 0xe5, 0xe1, 0x3e, 0xe3, 0x46, 0x08, 0xc7, 0xd0, 0x61, 0xb9, 0xa0, 0xb5,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Uint32(this->mObject);
            e->Uint32(this->mType);
            e->Int32(this->mTextureLevel);
            e->Uint32(this->mCubeMapFace);
        }

        atom::ID mCreatedAt;
        uint32_t mObject;
        FramebufferAttachmentType mType;
        int32_t mTextureLevel;
        CubeMapImageTarget mCubeMapFace;
    };

    class Framebuffer: public Encodable {
    public:
        Framebuffer(atom::ID CreatedAt, std::unordered_map<FramebufferAttachment,FramebufferAttachmentInfo>* Attachments) :
            mCreatedAt(CreatedAt),
            mAttachments(Attachments) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb2, 0x34, 0xfe, 0x22, 0x59, 0xe9, 0xe0, 0xaa, 0x31, 0xca, 0xad, 0xc9, 0x51, 0x2a, 0x24, 0x04, 0xb4, 0xfd, 0xa3, 0xa4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            
        }

        atom::ID mCreatedAt;
        std::unordered_map<FramebufferAttachment,FramebufferAttachmentInfo>* mAttachments;
    };

    class Shader: public Encodable {
    public:
        Shader(atom::ID CreatedAt, U8__S Binary, bool Compiled, bool Deletable, Char__S InfoLog, char* Source, ShaderType Type) :
            mCreatedAt(CreatedAt),
            mBinary(Binary),
            mCompiled(Compiled),
            mDeletable(Deletable),
            mInfoLog(InfoLog),
            mSource(Source),
            mType(Type) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x40, 0x98, 0xcd, 0x17, 0xd2, 0xcf, 0x4f, 0x55, 0x35, 0x5a, 0xb1, 0x03, 0x70, 0x31, 0x41, 0x01, 0x5b, 0x8d, 0x83, 0xf6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mBinary);
            e->Bool(this->mCompiled);
            e->Bool(this->mDeletable);
            e->Value(&this->mInfoLog);
            e->String(this->mSource);
            e->Uint32(this->mType);
        }

        atom::ID mCreatedAt;
        U8__S mBinary;
        bool mCompiled;
        bool mDeletable;
        Char__S mInfoLog;
        char* mSource;
        ShaderType mType;
    };

    class VertexAttribute: public Encodable {
    public:
        VertexAttribute(atom::ID CreatedAt, Char__S Name, int32_t VectorCount, ShaderAttribType Type) :
            mCreatedAt(CreatedAt),
            mName(Name),
            mVectorCount(VectorCount),
            mType(Type) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x88, 0x44, 0xf7, 0x6b, 0x96, 0x07, 0x99, 0x03, 0xe3, 0x56, 0xab, 0x34, 0x20, 0x80, 0xc6, 0x13, 0xbc, 0xd0, 0x53, 0xe8,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mName);
            e->Int32(this->mVectorCount);
            e->Uint32(this->mType);
        }

        atom::ID mCreatedAt;
        Char__S mName;
        int32_t mVectorCount;
        ShaderAttribType mType;
    };

    class Vec2f: public Encodable {
    public:
        Vec2f(atom::ID CreatedAt, float X, float Y) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x9a, 0x80, 0x74, 0xe4, 0x78, 0x9c, 0x6c, 0x16, 0xc7, 0xc6, 0x4e, 0x4c, 0x66, 0x6a, 0x86, 0x52, 0x06, 0x24, 0x41, 0x5d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Float32(this->mX);
            e->Float32(this->mY);
        }

        atom::ID mCreatedAt;
        float mX;
        float mY;
    };

    class Vec3f: public Encodable {
    public:
        Vec3f(atom::ID CreatedAt, float X, float Y, float Z) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y),
            mZ(Z) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x09, 0x06, 0xf7, 0xa9, 0xb3, 0xbf, 0x8f, 0x42, 0x96, 0xf4, 0xd6, 0xff, 0x4f, 0x93, 0x98, 0x44, 0x2e, 0xaf, 0x7b, 0x07,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Float32(this->mX);
            e->Float32(this->mY);
            e->Float32(this->mZ);
        }

        atom::ID mCreatedAt;
        float mX;
        float mY;
        float mZ;
    };

    class Vec4f: public Encodable {
    public:
        Vec4f(atom::ID CreatedAt, float X, float Y, float Z, float W) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y),
            mZ(Z),
            mW(W) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x94, 0x20, 0x1e, 0xeb, 0xde, 0x5b, 0xa9, 0xe1, 0xd7, 0x73, 0xcd, 0x9e, 0x3b, 0x09, 0x01, 0x8a, 0x9a, 0x41, 0xe7, 0x4b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Float32(this->mX);
            e->Float32(this->mY);
            e->Float32(this->mZ);
            e->Float32(this->mW);
        }

        atom::ID mCreatedAt;
        float mX;
        float mY;
        float mZ;
        float mW;
    };

    class Vec2i: public Encodable {
    public:
        Vec2i(atom::ID CreatedAt, int32_t X, int32_t Y) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x76, 0x85, 0xad, 0x18, 0xef, 0x9b, 0x0e, 0xea, 0x49, 0x44, 0xf7, 0x89, 0x4e, 0xdb, 0x0d, 0x34, 0xbb, 0x27, 0xb8, 0x43,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mX);
            e->Int32(this->mY);
        }

        atom::ID mCreatedAt;
        int32_t mX;
        int32_t mY;
    };

    class Vec3i: public Encodable {
    public:
        Vec3i(atom::ID CreatedAt, int32_t X, int32_t Y, int32_t Z) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y),
            mZ(Z) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc5, 0x31, 0xeb, 0x05, 0xd1, 0xdf, 0x5c, 0xf7, 0xc0, 0x7a, 0x20, 0xc9, 0x91, 0xb0, 0xf0, 0x2e, 0x1e, 0x9d, 0x94, 0xd5,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mZ);
        }

        atom::ID mCreatedAt;
        int32_t mX;
        int32_t mY;
        int32_t mZ;
    };

    class Vec4i: public Encodable {
    public:
        Vec4i(atom::ID CreatedAt, int32_t X, int32_t Y, int32_t Z, int32_t W) :
            mCreatedAt(CreatedAt),
            mX(X),
            mY(Y),
            mZ(Z),
            mW(W) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x61, 0x00, 0x31, 0xa3, 0x7a, 0x91, 0x14, 0x17, 0x6e, 0xd2, 0xe2, 0x62, 0x30, 0x92, 0xce, 0x4e, 0x0c, 0x72, 0xd1, 0x9c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mZ);
            e->Int32(this->mW);
        }

        atom::ID mCreatedAt;
        int32_t mX;
        int32_t mY;
        int32_t mZ;
        int32_t mW;
    };

    class Mat2f: public Encodable {
    public:
        Mat2f(atom::ID CreatedAt, Vec2f Col0, Vec2f Col1) :
            mCreatedAt(CreatedAt),
            mCol0(Col0),
            mCol1(Col1) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8a, 0xda, 0xb2, 0x20, 0xfa, 0xe4, 0xf7, 0x80, 0x3a, 0x25, 0xf4, 0xbf, 0xbc, 0x97, 0xea, 0x48, 0x14, 0xed, 0xcb, 0x98,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mCol0);
            e->Value(&this->mCol1);
        }

        atom::ID mCreatedAt;
        Vec2f mCol0;
        Vec2f mCol1;
    };

    class Mat3f: public Encodable {
    public:
        Mat3f(atom::ID CreatedAt, Vec3f Col0, Vec3f Col1, Vec3f Col2) :
            mCreatedAt(CreatedAt),
            mCol0(Col0),
            mCol1(Col1),
            mCol2(Col2) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x2c, 0xe7, 0xc3, 0x90, 0x92, 0x9b, 0xa6, 0xc1, 0x86, 0x6e, 0x89, 0xc7, 0x16, 0x6d, 0x9f, 0x83, 0x54, 0x64, 0x40, 0x3a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mCol0);
            e->Value(&this->mCol1);
            e->Value(&this->mCol2);
        }

        atom::ID mCreatedAt;
        Vec3f mCol0;
        Vec3f mCol1;
        Vec3f mCol2;
    };

    class Mat4f: public Encodable {
    public:
        Mat4f(atom::ID CreatedAt, Vec4f Col0, Vec4f Col1, Vec4f Col2, Vec4f Col3) :
            mCreatedAt(CreatedAt),
            mCol0(Col0),
            mCol1(Col1),
            mCol2(Col2),
            mCol3(Col3) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x5c, 0x2f, 0x64, 0xb8, 0x4e, 0xf0, 0xa8, 0x30, 0x10, 0x31, 0x81, 0x75, 0xb7, 0x82, 0xf3, 0x8f, 0x70, 0x68, 0x83, 0xdc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Value(&this->mCol0);
            e->Value(&this->mCol1);
            e->Value(&this->mCol2);
            e->Value(&this->mCol3);
        }

        atom::ID mCreatedAt;
        Vec4f mCol0;
        Vec4f mCol1;
        Vec4f mCol2;
        Vec4f mCol3;
    };

    class UniformValue: public Encodable {
    public:
        UniformValue(atom::ID CreatedAt, float F32, Vec2f Vec2f, Vec3f Vec3f, Vec4f Vec4f, int32_t S32, Vec2i Vec2i, Vec3i Vec3i, Vec4i Vec4i, Mat2f Mat2f, Mat3f Mat3f, Mat4f Mat4f) :
            mCreatedAt(CreatedAt),
            mF32(F32),
            mVec2f(Vec2f),
            mVec3f(Vec3f),
            mVec4f(Vec4f),
            mS32(S32),
            mVec2i(Vec2i),
            mVec3i(Vec3i),
            mVec4i(Vec4i),
            mMat2f(Mat2f),
            mMat3f(Mat3f),
            mMat4f(Mat4f) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xab, 0x2c, 0x54, 0x24, 0xdf, 0x48, 0x16, 0xcb, 0x4a, 0x5d, 0x7f, 0x47, 0x42, 0x4b, 0x4e, 0x3e, 0x5d, 0x0e, 0x54, 0x0c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Float32(this->mF32);
            e->Value(&this->mVec2f);
            e->Value(&this->mVec3f);
            e->Value(&this->mVec4f);
            e->Int32(this->mS32);
            e->Value(&this->mVec2i);
            e->Value(&this->mVec3i);
            e->Value(&this->mVec4i);
            e->Value(&this->mMat2f);
            e->Value(&this->mMat3f);
            e->Value(&this->mMat4f);
        }

        atom::ID mCreatedAt;
        float mF32;
        Vec2f mVec2f;
        Vec3f mVec3f;
        Vec4f mVec4f;
        int32_t mS32;
        Vec2i mVec2i;
        Vec3i mVec3i;
        Vec4i mVec4i;
        Mat2f mMat2f;
        Mat3f mMat3f;
        Mat4f mMat4f;
    };

    class Uniform: public Encodable {
    public:
        Uniform(atom::ID CreatedAt, char* Name, ShaderUniformType Type, UniformValue Value) :
            mCreatedAt(CreatedAt),
            mName(Name),
            mType(Type),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x92, 0x24, 0x45, 0xb8, 0x0b, 0xfa, 0x86, 0x62, 0xac, 0x08, 0xfd, 0xbc, 0xbc, 0x95, 0x50, 0x12, 0x22, 0x6e, 0xa5, 0x1d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->String(this->mName);
            e->Uint32(this->mType);
            e->Value(&this->mValue);
        }

        atom::ID mCreatedAt;
        char* mName;
        ShaderUniformType mType;
        UniformValue mValue;
    };

    class Program: public Encodable {
    public:
        Program(atom::ID CreatedAt, std::unordered_map<ShaderType,ShaderId>* Shaders, bool Linked, U8__S Binary, std::unordered_map<char*,AttributeLocation>* AttributeBindings, std::unordered_map<int32_t,VertexAttribute>* Attributes, std::unordered_map<UniformLocation,Uniform>* Uniforms, Char__S InfoLog) :
            mCreatedAt(CreatedAt),
            mShaders(Shaders),
            mLinked(Linked),
            mBinary(Binary),
            mAttributeBindings(AttributeBindings),
            mAttributes(Attributes),
            mUniforms(Uniforms),
            mInfoLog(InfoLog) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7f, 0x2e, 0x5d, 0xa3, 0x21, 0x31, 0xb3, 0x68, 0x3a, 0xae, 0x2d, 0x85, 0xc1, 0x89, 0xac, 0xe2, 0xa6, 0x14, 0x42, 0x2d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            
            e->Bool(this->mLinked);
            e->Value(&this->mBinary);
            
            
            
            e->Value(&this->mInfoLog);
        }

        atom::ID mCreatedAt;
        std::unordered_map<ShaderType,ShaderId>* mShaders;
        bool mLinked;
        U8__S mBinary;
        std::unordered_map<char*,AttributeLocation>* mAttributeBindings;
        std::unordered_map<int32_t,VertexAttribute>* mAttributes;
        std::unordered_map<UniformLocation,Uniform>* mUniforms;
        Char__S mInfoLog;
    };

    class VertexArray: public Encodable {
    public:
        VertexArray(atom::ID CreatedAt) :
            mCreatedAt(CreatedAt) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8c, 0x9a, 0x34, 0xfe, 0x61, 0x2a, 0x2d, 0x57, 0x19, 0x43, 0x24, 0x95, 0xf6, 0x1e, 0x79, 0x97, 0x85, 0x3f, 0xee, 0xc4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
        }

        atom::ID mCreatedAt;
    };

    class Query: public Encodable {
    public:
        Query(atom::ID CreatedAt) :
            mCreatedAt(CreatedAt) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x9e, 0x4e, 0xd0, 0x26, 0x26, 0xf8, 0x9d, 0x8e, 0xb5, 0x02, 0x2f, 0xde, 0x80, 0xb3, 0xe9, 0x09, 0xf5, 0x4c, 0x1e, 0xf2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
        }

        atom::ID mCreatedAt;
    };

    class Objects: public Encodable {
    public:
        Objects(atom::ID CreatedAt, std::unordered_map<RenderbufferId,Renderbuffer*>* Renderbuffers, std::unordered_map<TextureId,Texture*>* Textures, std::unordered_map<FramebufferId,Framebuffer*>* Framebuffers, std::unordered_map<BufferId,Buffer*>* Buffers, std::unordered_map<ShaderId,Shader*>* Shaders, std::unordered_map<ProgramId,Program*>* Programs, std::unordered_map<VertexArrayId,VertexArray*>* VertexArrays, std::unordered_map<QueryId,Query*>* Queries) :
            mCreatedAt(CreatedAt),
            mRenderbuffers(Renderbuffers),
            mTextures(Textures),
            mFramebuffers(Framebuffers),
            mBuffers(Buffers),
            mShaders(Shaders),
            mPrograms(Programs),
            mVertexArrays(VertexArrays),
            mQueries(Queries) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8a, 0x05, 0xaa, 0xf5, 0xa8, 0x57, 0xb0, 0xf1, 0x13, 0x48, 0x39, 0x76, 0xec, 0x1e, 0x47, 0x0b, 0x6c, 0x3b, 0xf6, 0xe0,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            
            
            
            
            
            
            
            
        }

        atom::ID mCreatedAt;
        std::unordered_map<RenderbufferId,Renderbuffer*>* mRenderbuffers;
        std::unordered_map<TextureId,Texture*>* mTextures;
        std::unordered_map<FramebufferId,Framebuffer*>* mFramebuffers;
        std::unordered_map<BufferId,Buffer*>* mBuffers;
        std::unordered_map<ShaderId,Shader*>* mShaders;
        std::unordered_map<ProgramId,Program*>* mPrograms;
        std::unordered_map<VertexArrayId,VertexArray*>* mVertexArrays;
        std::unordered_map<QueryId,Query*>* mQueries;
    };

    class Context: public Encodable {
    public:
        Context(atom::ID CreatedAt, ContextID Identifier, BlendState Blending, RasterizerState Rasterizing, ClearState Clearing, std::unordered_map<FramebufferTarget,FramebufferId>* BoundFramebuffers, std::unordered_map<RenderbufferTarget,RenderbufferId>* BoundRenderbuffers, std::unordered_map<BufferTarget,BufferId>* BoundBuffers, ProgramId BoundProgram, VertexArrayId BoundVertexArray, std::unordered_map<AttributeLocation,VertexAttributeArray*>* VertexAttributeArrays, std::unordered_map<TextureUnit,std::unordered_map<TextureTarget,TextureId>*>* TextureUnits, TextureUnit ActiveTextureUnit, std::unordered_map<Capability,bool>* Capabilities, HintMode GenerateMipmapHint, std::unordered_map<PixelStoreParameter,int32_t>* PixelStorage, Objects Instances) :
            mCreatedAt(CreatedAt),
            mIdentifier(Identifier),
            mBlending(Blending),
            mRasterizing(Rasterizing),
            mClearing(Clearing),
            mBoundFramebuffers(BoundFramebuffers),
            mBoundRenderbuffers(BoundRenderbuffers),
            mBoundBuffers(BoundBuffers),
            mBoundProgram(BoundProgram),
            mBoundVertexArray(BoundVertexArray),
            mVertexAttributeArrays(VertexAttributeArrays),
            mTextureUnits(TextureUnits),
            mActiveTextureUnit(ActiveTextureUnit),
            mCapabilities(Capabilities),
            mGenerateMipmapHint(GenerateMipmapHint),
            mPixelStorage(PixelStorage),
            mInstances(Instances) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc6, 0x81, 0x84, 0x13, 0x02, 0x9b, 0x76, 0x8b, 0x5b, 0x09, 0x10, 0xe4, 0x96, 0x22, 0xb2, 0x60, 0x14, 0xbd, 0x65, 0x01,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mCreatedAt);
            e->Uint32(this->mIdentifier);
            e->Value(&this->mBlending);
            e->Value(&this->mRasterizing);
            e->Value(&this->mClearing);
            
            
            
            e->Uint32(this->mBoundProgram);
            e->Uint32(this->mBoundVertexArray);
            
            
            e->Uint32(this->mActiveTextureUnit);
            
            e->Uint32(this->mGenerateMipmapHint);
            
            e->Value(&this->mInstances);
        }

        atom::ID mCreatedAt;
        ContextID mIdentifier;
        BlendState mBlending;
        RasterizerState mRasterizing;
        ClearState mClearing;
        std::unordered_map<FramebufferTarget,FramebufferId>* mBoundFramebuffers;
        std::unordered_map<RenderbufferTarget,RenderbufferId>* mBoundRenderbuffers;
        std::unordered_map<BufferTarget,BufferId>* mBoundBuffers;
        ProgramId mBoundProgram;
        VertexArrayId mBoundVertexArray;
        std::unordered_map<AttributeLocation,VertexAttributeArray*>* mVertexAttributeArrays;
        std::unordered_map<TextureUnit,std::unordered_map<TextureTarget,TextureId>*>* mTextureUnits;
        TextureUnit mActiveTextureUnit;
        std::unordered_map<Capability,bool>* mCapabilities;
        HintMode mGenerateMipmapHint;
        std::unordered_map<PixelStoreParameter,int32_t>* mPixelStorage;
        Objects mInstances;
    };

    class DiscardFramebufferAttachment__S: public Encodable {
    public:
        DiscardFramebufferAttachment__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x94, 0x48, 0xa1, 0x50, 0x59, 0xc0, 0xbd, 0xf5, 0x22, 0x5e, 0xae, 0xf4, 0x8b, 0x3c, 0xd2, 0x74, 0x8c, 0x58, 0x0b, 0x4b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class DiscardFramebufferAttachment__P: public Encodable {
    public:
        DiscardFramebufferAttachment__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x23, 0xd9, 0x67, 0x4f, 0x82, 0x7e, 0x62, 0x8d, 0x54, 0xc3, 0xec, 0x98, 0xc5, 0x3e, 0xba, 0xf5, 0xa6, 0x3f, 0x52, 0x1f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EGLConfig: public Encodable {
    public:
        EGLConfig(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x2a, 0xd8, 0x24, 0x8e, 0x95, 0xb5, 0x5d, 0x86, 0xe8, 0x84, 0x21, 0x3a, 0x2c, 0xee, 0xfd, 0x90, 0xd2, 0xab, 0xd8, 0x5c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EGLContext: public Encodable {
    public:
        EGLContext(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x29, 0x18, 0x4c, 0xdb, 0x8b, 0xf5, 0xcf, 0xcc, 0xfc, 0xf8, 0x62, 0x25, 0x1f, 0xf1, 0x45, 0x0e, 0x20, 0x23, 0xce, 0x8e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EGLDisplay: public Encodable {
    public:
        EGLDisplay(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x85, 0x54, 0x9a, 0x82, 0x0b, 0x08, 0xcc, 0x4c, 0x6b, 0x1c, 0xcc, 0x0e, 0x85, 0x09, 0x68, 0x5c, 0x93, 0x51, 0x24, 0x5e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EGLSurface: public Encodable {
    public:
        EGLSurface(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6b, 0xba, 0xab, 0x4f, 0xa1, 0xaa, 0x01, 0xdb, 0x61, 0xe3, 0xbb, 0x84, 0xf5, 0x1b, 0xf6, 0x39, 0xda, 0x3c, 0xf7, 0xb8,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EGLint__S: public Encodable {
    public:
        EGLint__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf7, 0x65, 0x4f, 0x39, 0xbd, 0x9c, 0x8d, 0x4a, 0x66, 0xfa, 0x0a, 0x73, 0x73, 0x6d, 0xd1, 0x2b, 0xa5, 0x60, 0xf9, 0xab,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class EGLint__P: public Encodable {
    public:
        EGLint__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xcf, 0x1c, 0x9b, 0x06, 0x5a, 0x46, 0x2e, 0x61, 0x7d, 0xe6, 0x2e, 0x95, 0x4e, 0xfb, 0xb4, 0x41, 0x15, 0xf6, 0x9e, 0x0d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EglCreateContext: public Encodable {
    public:
        EglCreateContext(atom::Observations observations, EGLDisplay Display, EGLConfig Config, EGLContext ShareContext, EGLint__P AttribList, EGLContext Result) :
            mobservations(observations),
            mDisplay(Display),
            mConfig(Config),
            mShareContext(ShareContext),
            mAttribList(AttribList),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xac, 0x3a, 0xa8, 0x3a, 0x28, 0xf3, 0x5a, 0xea, 0x3c, 0x91, 0x79, 0xd2, 0x7b, 0xc6, 0xf8, 0xb6, 0xd4, 0x07, 0x2b, 0x88,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mConfig);
            e->Value(&this->mShareContext);
            e->Value(&this->mAttribList);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        EGLDisplay mDisplay;
        EGLConfig mConfig;
        EGLContext mShareContext;
        EGLint__P mAttribList;
        EGLContext mResult;
    };

    class EglInitialize: public Encodable {
    public:
        EglInitialize(atom::Observations observations, EGLDisplay Dpy, EGLint__P Major, EGLint__P Minor, EGLBoolean Result) :
            mobservations(observations),
            mDpy(Dpy),
            mMajor(Major),
            mMinor(Minor),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa3, 0x4b, 0x10, 0xac, 0xe3, 0x34, 0x97, 0x4e, 0x72, 0xe2, 0x44, 0xc6, 0x21, 0x4b, 0x03, 0x0a, 0x2b, 0x01, 0x6e, 0xae,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDpy);
            e->Value(&this->mMajor);
            e->Value(&this->mMinor);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        EGLDisplay mDpy;
        EGLint__P mMajor;
        EGLint__P mMinor;
        EGLBoolean mResult;
    };

    class EglMakeCurrent: public Encodable {
    public:
        EglMakeCurrent(atom::Observations observations, EGLDisplay Display, EGLSurface Draw, EGLSurface Read, EGLContext Context, EGLBoolean Result) :
            mobservations(observations),
            mDisplay(Display),
            mDraw(Draw),
            mRead(Read),
            mContext(Context),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x11, 0xbc, 0xee, 0xf3, 0x15, 0x6b, 0x3c, 0x40, 0x07, 0x40, 0x4c, 0xb3, 0x12, 0x2d, 0x98, 0x0c, 0xd1, 0xf0, 0xb1, 0x1e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mDraw);
            e->Value(&this->mRead);
            e->Value(&this->mContext);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        EGLDisplay mDisplay;
        EGLSurface mDraw;
        EGLSurface mRead;
        EGLContext mContext;
        EGLBoolean mResult;
    };

    class EglQuerySurface: public Encodable {
    public:
        EglQuerySurface(atom::Observations observations, EGLDisplay Display, EGLSurface Surface, EGLint Attribute, EGLint__P Value, EGLBoolean Result) :
            mobservations(observations),
            mDisplay(Display),
            mSurface(Surface),
            mAttribute(Attribute),
            mValue(Value),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x14, 0x6c, 0x8d, 0x6c, 0x45, 0xd9, 0xcd, 0xde, 0xde, 0xd0, 0x12, 0xea, 0x3f, 0x95, 0xeb, 0x43, 0xc6, 0x33, 0x40, 0x22,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mSurface);
            e->Int64(this->mAttribute);
            e->Value(&this->mValue);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        EGLDisplay mDisplay;
        EGLSurface mSurface;
        EGLint mAttribute;
        EGLint__P mValue;
        EGLBoolean mResult;
    };

    class Void__P: public Encodable {
    public:
        Void__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa7, 0x86, 0xcc, 0x23, 0x0b, 0x73, 0x10, 0x9d, 0xda, 0xc6, 0x41, 0xcb, 0xf7, 0xe4, 0x97, 0x87, 0x01, 0x69, 0xc2, 0x2e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class EglSwapBuffers: public Encodable {
    public:
        EglSwapBuffers(atom::Observations observations, EGLDisplay Display, Void__P Surface, EGLBoolean Result) :
            mobservations(observations),
            mDisplay(Display),
            mSurface(Surface),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x57, 0x1f, 0xe4, 0x1b, 0x20, 0xa1, 0x87, 0x17, 0x6c, 0x31, 0x05, 0x59, 0x10, 0x83, 0xb5, 0x3a, 0xb0, 0xa9, 0x3c, 0x39,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mSurface);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        EGLDisplay mDisplay;
        Void__P mSurface;
        EGLBoolean mResult;
    };

    class F32__S: public Encodable {
    public:
        F32__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0f, 0xb3, 0x50, 0xa2, 0xcc, 0xa0, 0x63, 0x8a, 0x12, 0xd5, 0xeb, 0xa7, 0xe9, 0x3e, 0xf5, 0x0e, 0x37, 0xea, 0xce, 0xaa,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class F32__P: public Encodable {
    public:
        F32__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x25, 0x42, 0x8d, 0x14, 0xfa, 0x29, 0xc8, 0xad, 0xe4, 0x75, 0x2b, 0xfa, 0xf4, 0x35, 0x5b, 0x12, 0x23, 0x97, 0x38, 0x77,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class FlushPostBuffer: public Encodable {
    public:
        FlushPostBuffer(atom::Observations observations) :
            mobservations(observations) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x26, 0x4e, 0x20, 0xbb, 0xf9, 0x53, 0x75, 0xcd, 0x08, 0x98, 0x6d, 0x82, 0x25, 0x7d, 0xb5, 0xb6, 0x1e, 0xbb, 0xe1, 0xbf,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
        }

        atom::Observations mobservations;
    };

    class FramebufferAttachment__S: public Encodable {
    public:
        FramebufferAttachment__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x95, 0x05, 0xe7, 0xe0, 0x6a, 0xc5, 0x9d, 0x9e, 0xdf, 0x18, 0x61, 0x2f, 0xf7, 0x34, 0x79, 0x33, 0xed, 0xc9, 0xa8, 0x7c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class FramebufferAttachment__P: public Encodable {
    public:
        FramebufferAttachment__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc1, 0xc1, 0xe5, 0xa2, 0x3a, 0x14, 0xc7, 0x83, 0xf8, 0x0a, 0xf2, 0xc9, 0x7e, 0x42, 0x47, 0x17, 0x34, 0x93, 0x1a, 0x91,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class FramebufferId__S: public Encodable {
    public:
        FramebufferId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb2, 0x52, 0xd0, 0xde, 0x1a, 0xc2, 0xa8, 0xff, 0x28, 0x4f, 0xe8, 0x17, 0x8e, 0x60, 0xcc, 0x6e, 0x41, 0xcd, 0xcb, 0x0d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class FramebufferId__P: public Encodable {
    public:
        FramebufferId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x5a, 0x4f, 0x87, 0xa7, 0xe2, 0xf7, 0x6e, 0xe8, 0x7f, 0xf1, 0x5e, 0x27, 0x8c, 0x71, 0xbc, 0x66, 0x3c, 0xa5, 0x82, 0xce,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GLXContext: public Encodable {
    public:
        GLXContext(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x07, 0xef, 0xcc, 0x57, 0xc6, 0x16, 0xf2, 0x83, 0x9d, 0x0f, 0x7c, 0x71, 0xe8, 0xa6, 0xda, 0x1e, 0x45, 0xf1, 0xce, 0xfe,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GLXDrawable: public Encodable {
    public:
        GLXDrawable(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x43, 0x88, 0x91, 0x75, 0x90, 0x61, 0xe4, 0xc9, 0x61, 0xd0, 0x6d, 0xdb, 0x12, 0xae, 0xe1, 0xcb, 0x87, 0x07, 0xb3, 0x05,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlActiveTexture: public Encodable {
    public:
        GlActiveTexture(atom::Observations observations, TextureUnit Unit) :
            mobservations(observations),
            mUnit(Unit) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x86, 0x43, 0x07, 0xe6, 0xb5, 0x8c, 0x5b, 0x40, 0xd6, 0x5b, 0x88, 0x2a, 0x03, 0x47, 0x22, 0x92, 0x84, 0xd6, 0xd1, 0x71,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mUnit);
        }

        atom::Observations mobservations;
        TextureUnit mUnit;
    };

    class GlAttachShader: public Encodable {
    public:
        GlAttachShader(atom::Observations observations, ProgramId Program, ShaderId Shader) :
            mobservations(observations),
            mProgram(Program),
            mShader(Shader) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x25, 0x23, 0xee, 0xce, 0x3c, 0x37, 0xb6, 0x03, 0x61, 0xc4, 0xb6, 0xbf, 0x06, 0x38, 0xb9, 0x7f, 0x78, 0x85, 0xee, 0x77,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mShader);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        ShaderId mShader;
    };

    class GlBeginQuery: public Encodable {
    public:
        GlBeginQuery(atom::Observations observations, QueryTarget Target, QueryId Query) :
            mobservations(observations),
            mTarget(Target),
            mQuery(Query) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x42, 0xe9, 0xe3, 0x0b, 0x3b, 0x9a, 0x1f, 0x86, 0x6f, 0x95, 0xc8, 0x3a, 0x15, 0x06, 0xb2, 0x84, 0x6a, 0x95, 0xd2, 0xf4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mQuery);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
        QueryId mQuery;
    };

    class GlBeginQueryEXT: public Encodable {
    public:
        GlBeginQueryEXT(atom::Observations observations, QueryTarget Target, QueryId Query) :
            mobservations(observations),
            mTarget(Target),
            mQuery(Query) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x35, 0x2d, 0x3a, 0x78, 0xe5, 0xf5, 0xbe, 0x4d, 0x23, 0xd9, 0x25, 0xb4, 0x7c, 0xf5, 0x52, 0x5a, 0x7b, 0x3b, 0x51, 0x1b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mQuery);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
        QueryId mQuery;
    };

    class GlBindAttribLocation: public Encodable {
    public:
        GlBindAttribLocation(atom::Observations observations, ProgramId Program, AttributeLocation Location, char* Name) :
            mobservations(observations),
            mProgram(Program),
            mLocation(Location),
            mName(Name) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xab, 0xe2, 0x34, 0x53, 0x26, 0xbc, 0x1d, 0x86, 0xd6, 0x8b, 0xd8, 0xaa, 0xd9, 0x38, 0x2f, 0xca, 0x5a, 0x1d, 0xc0, 0x10,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mLocation);
            e->String(this->mName);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        AttributeLocation mLocation;
        char* mName;
    };

    class GlBindBuffer: public Encodable {
    public:
        GlBindBuffer(atom::Observations observations, BufferTarget Target, BufferId Buffer) :
            mobservations(observations),
            mTarget(Target),
            mBuffer(Buffer) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb3, 0xb1, 0xb5, 0x5e, 0xc2, 0xe9, 0x44, 0x46, 0x28, 0x6f, 0x55, 0x56, 0xc0, 0xa9, 0x57, 0xc2, 0x09, 0x9f, 0xbb, 0x04,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mBuffer);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
        BufferId mBuffer;
    };

    class GlBindFramebuffer: public Encodable {
    public:
        GlBindFramebuffer(atom::Observations observations, FramebufferTarget Target, FramebufferId Framebuffer) :
            mobservations(observations),
            mTarget(Target),
            mFramebuffer(Framebuffer) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x3b, 0x20, 0x3d, 0xca, 0x34, 0xac, 0x3e, 0x7c, 0x8b, 0xd7, 0xe0, 0xd8, 0x23, 0x84, 0xdb, 0x5b, 0xac, 0x43, 0x56, 0xa2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mFramebuffer);
        }

        atom::Observations mobservations;
        FramebufferTarget mTarget;
        FramebufferId mFramebuffer;
    };

    class GlBindRenderbuffer: public Encodable {
    public:
        GlBindRenderbuffer(atom::Observations observations, RenderbufferTarget Target, RenderbufferId Renderbuffer) :
            mobservations(observations),
            mTarget(Target),
            mRenderbuffer(Renderbuffer) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc4, 0xd9, 0xb9, 0x94, 0x42, 0x83, 0xf5, 0x48, 0xd1, 0x68, 0x54, 0x9d, 0x7d, 0x9c, 0x49, 0x6d, 0x0a, 0xcf, 0xdb, 0xa7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mRenderbuffer);
        }

        atom::Observations mobservations;
        RenderbufferTarget mTarget;
        RenderbufferId mRenderbuffer;
    };

    class GlBindTexture: public Encodable {
    public:
        GlBindTexture(atom::Observations observations, TextureTarget Target, TextureId Texture) :
            mobservations(observations),
            mTarget(Target),
            mTexture(Texture) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf9, 0x83, 0xaa, 0x55, 0xc0, 0x52, 0xe8, 0x65, 0xb0, 0x66, 0x1c, 0x7a, 0x33, 0xc9, 0x4a, 0xfd, 0xd1, 0xda, 0xf0, 0x69,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mTexture);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        TextureId mTexture;
    };

    class GlBindVertexArrayOES: public Encodable {
    public:
        GlBindVertexArrayOES(atom::Observations observations, VertexArrayId Array) :
            mobservations(observations),
            mArray(Array) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x2c, 0x88, 0xbc, 0x5d, 0x79, 0xf5, 0x34, 0x2a, 0x35, 0xca, 0x72, 0x5c, 0xcf, 0x78, 0xee, 0x4b, 0xe5, 0x5f, 0xc8, 0xb4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mArray);
        }

        atom::Observations mobservations;
        VertexArrayId mArray;
    };

    class GlBlendColor: public Encodable {
    public:
        GlBlendColor(atom::Observations observations, float Red, float Green, float Blue, float Alpha) :
            mobservations(observations),
            mRed(Red),
            mGreen(Green),
            mBlue(Blue),
            mAlpha(Alpha) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x60, 0xbd, 0x6d, 0x61, 0x66, 0xd6, 0x47, 0xea, 0x9c, 0xa7, 0x16, 0xba, 0xf4, 0x59, 0x00, 0x75, 0xaf, 0x03, 0x5a, 0x2b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mRed);
            e->Float32(this->mGreen);
            e->Float32(this->mBlue);
            e->Float32(this->mAlpha);
        }

        atom::Observations mobservations;
        float mRed;
        float mGreen;
        float mBlue;
        float mAlpha;
    };

    class GlBlendEquation: public Encodable {
    public:
        GlBlendEquation(atom::Observations observations, BlendEquation Equation) :
            mobservations(observations),
            mEquation(Equation) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe1, 0x81, 0x90, 0xcf, 0x2b, 0xd7, 0x3e, 0xfc, 0xa7, 0x45, 0x6d, 0xd6, 0x60, 0xa3, 0xbd, 0xbd, 0xbe, 0x14, 0xe5, 0x56,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mEquation);
        }

        atom::Observations mobservations;
        BlendEquation mEquation;
    };

    class GlBlendEquationSeparate: public Encodable {
    public:
        GlBlendEquationSeparate(atom::Observations observations, BlendEquation Rgb, BlendEquation Alpha) :
            mobservations(observations),
            mRgb(Rgb),
            mAlpha(Alpha) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8e, 0x3a, 0xa3, 0x46, 0xe9, 0xaa, 0xb3, 0x99, 0xbc, 0x96, 0x61, 0x40, 0xc8, 0x26, 0x4d, 0xb0, 0xb0, 0xe5, 0x34, 0x0f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mRgb);
            e->Uint32(this->mAlpha);
        }

        atom::Observations mobservations;
        BlendEquation mRgb;
        BlendEquation mAlpha;
    };

    class GlBlendFunc: public Encodable {
    public:
        GlBlendFunc(atom::Observations observations, BlendFactor SrcFactor, BlendFactor DstFactor) :
            mobservations(observations),
            mSrcFactor(SrcFactor),
            mDstFactor(DstFactor) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7a, 0x77, 0xed, 0x51, 0x85, 0x8e, 0x92, 0xde, 0xef, 0x7d, 0x54, 0x4e, 0xf3, 0x38, 0xc1, 0x50, 0x61, 0x2d, 0xc2, 0x10,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mSrcFactor);
            e->Uint32(this->mDstFactor);
        }

        atom::Observations mobservations;
        BlendFactor mSrcFactor;
        BlendFactor mDstFactor;
    };

    class GlBlendFuncSeparate: public Encodable {
    public:
        GlBlendFuncSeparate(atom::Observations observations, BlendFactor SrcFactorRgb, BlendFactor DstFactorRgb, BlendFactor SrcFactorAlpha, BlendFactor DstFactorAlpha) :
            mobservations(observations),
            mSrcFactorRgb(SrcFactorRgb),
            mDstFactorRgb(DstFactorRgb),
            mSrcFactorAlpha(SrcFactorAlpha),
            mDstFactorAlpha(DstFactorAlpha) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe5, 0xce, 0xe6, 0x57, 0x98, 0xac, 0x75, 0x43, 0x39, 0xd4, 0xc6, 0xf2, 0xa9, 0xfc, 0xfa, 0x55, 0xe0, 0xb0, 0x67, 0x33,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mSrcFactorRgb);
            e->Uint32(this->mDstFactorRgb);
            e->Uint32(this->mSrcFactorAlpha);
            e->Uint32(this->mDstFactorAlpha);
        }

        atom::Observations mobservations;
        BlendFactor mSrcFactorRgb;
        BlendFactor mDstFactorRgb;
        BlendFactor mSrcFactorAlpha;
        BlendFactor mDstFactorAlpha;
    };

    class GlBlitFramebuffer: public Encodable {
    public:
        GlBlitFramebuffer(atom::Observations observations, int32_t SrcX0, int32_t SrcY0, int32_t SrcX1, int32_t SrcY1, int32_t DstX0, int32_t DstY0, int32_t DstX1, int32_t DstY1, ClearMask Mask, TextureFilterMode Filter) :
            mobservations(observations),
            mSrcX0(SrcX0),
            mSrcY0(SrcY0),
            mSrcX1(SrcX1),
            mSrcY1(SrcY1),
            mDstX0(DstX0),
            mDstY0(DstY0),
            mDstX1(DstX1),
            mDstY1(DstY1),
            mMask(Mask),
            mFilter(Filter) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x1d, 0xc8, 0x10, 0x98, 0x4a, 0x04, 0x29, 0x7d, 0xc7, 0xa9, 0xca, 0xd3, 0x36, 0x40, 0xce, 0xfc, 0x3c, 0x98, 0x21, 0xf0,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mSrcX0);
            e->Int32(this->mSrcY0);
            e->Int32(this->mSrcX1);
            e->Int32(this->mSrcY1);
            e->Int32(this->mDstX0);
            e->Int32(this->mDstY0);
            e->Int32(this->mDstX1);
            e->Int32(this->mDstY1);
            e->Uint32(this->mMask);
            e->Uint32(this->mFilter);
        }

        atom::Observations mobservations;
        int32_t mSrcX0;
        int32_t mSrcY0;
        int32_t mSrcX1;
        int32_t mSrcY1;
        int32_t mDstX0;
        int32_t mDstY0;
        int32_t mDstX1;
        int32_t mDstY1;
        ClearMask mMask;
        TextureFilterMode mFilter;
    };

    class GlBufferData: public Encodable {
    public:
        GlBufferData(atom::Observations observations, BufferTarget Target, int32_t Size, BufferDataPointer Data, BufferUsage Usage) :
            mobservations(observations),
            mTarget(Target),
            mSize(Size),
            mData(Data),
            mUsage(Usage) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x84, 0x06, 0x18, 0x83, 0xbc, 0x39, 0xac, 0xad, 0x06, 0xb7, 0x9a, 0x64, 0xa2, 0x81, 0x4d, 0x92, 0x3e, 0xf7, 0x11, 0xb0,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mSize);
            e->Value(&this->mData);
            e->Uint32(this->mUsage);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
        int32_t mSize;
        BufferDataPointer mData;
        BufferUsage mUsage;
    };

    class GlBufferSubData: public Encodable {
    public:
        GlBufferSubData(atom::Observations observations, BufferTarget Target, int32_t Offset, int32_t Size, Void__P Data) :
            mobservations(observations),
            mTarget(Target),
            mOffset(Offset),
            mSize(Size),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x66, 0x8f, 0xae, 0x44, 0x51, 0x99, 0x0d, 0xb8, 0xb1, 0x8c, 0x65, 0x96, 0x3b, 0x3a, 0xec, 0x9a, 0x57, 0xd6, 0x9f, 0x38,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mOffset);
            e->Int32(this->mSize);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
        int32_t mOffset;
        int32_t mSize;
        Void__P mData;
    };

    class GlCheckFramebufferStatus: public Encodable {
    public:
        GlCheckFramebufferStatus(atom::Observations observations, FramebufferTarget Target, FramebufferStatus Result) :
            mobservations(observations),
            mTarget(Target),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0e, 0x53, 0x9b, 0x07, 0x3d, 0xec, 0x3a, 0x84, 0xf5, 0x1c, 0x0a, 0xfb, 0x31, 0x6a, 0x69, 0x88, 0xed, 0x78, 0x99, 0xba,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        FramebufferTarget mTarget;
        FramebufferStatus mResult;
    };

    class GlClear: public Encodable {
    public:
        GlClear(atom::Observations observations, ClearMask Mask) :
            mobservations(observations),
            mMask(Mask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4a, 0x0e, 0x2c, 0xc5, 0x7c, 0xbe, 0xd1, 0xa7, 0xeb, 0x57, 0xa1, 0x35, 0xcd, 0xb5, 0x0a, 0x42, 0x71, 0xfc, 0x13, 0xef,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mMask);
        }

        atom::Observations mobservations;
        ClearMask mMask;
    };

    class GlClearColor: public Encodable {
    public:
        GlClearColor(atom::Observations observations, float R, float G, float B, float A) :
            mobservations(observations),
            mR(R),
            mG(G),
            mB(B),
            mA(A) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x3b, 0x2c, 0x7f, 0xdf, 0xca, 0xea, 0x73, 0xe9, 0x9d, 0xaa, 0xb9, 0x94, 0x97, 0xc8, 0xc0, 0x1d, 0x7e, 0x0f, 0xa6, 0xc2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mR);
            e->Float32(this->mG);
            e->Float32(this->mB);
            e->Float32(this->mA);
        }

        atom::Observations mobservations;
        float mR;
        float mG;
        float mB;
        float mA;
    };

    class GlClearDepthf: public Encodable {
    public:
        GlClearDepthf(atom::Observations observations, float Depth) :
            mobservations(observations),
            mDepth(Depth) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x64, 0x57, 0xb0, 0xf4, 0x14, 0x5f, 0xfd, 0x32, 0x8a, 0x6d, 0x28, 0xec, 0xb9, 0x33, 0x25, 0xc9, 0x28, 0x9c, 0x97, 0x04,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mDepth);
        }

        atom::Observations mobservations;
        float mDepth;
    };

    class GlClearStencil: public Encodable {
    public:
        GlClearStencil(atom::Observations observations, int32_t Stencil) :
            mobservations(observations),
            mStencil(Stencil) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7c, 0xd3, 0x47, 0x40, 0xf0, 0x5d, 0xcc, 0xec, 0x2e, 0x49, 0xea, 0x0d, 0x3e, 0x90, 0xda, 0xf2, 0x95, 0xb8, 0xcb, 0xe2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mStencil);
        }

        atom::Observations mobservations;
        int32_t mStencil;
    };

    class GlColorMask: public Encodable {
    public:
        GlColorMask(atom::Observations observations, bool Red, bool Green, bool Blue, bool Alpha) :
            mobservations(observations),
            mRed(Red),
            mGreen(Green),
            mBlue(Blue),
            mAlpha(Alpha) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0b, 0x72, 0x03, 0xf6, 0x51, 0x6a, 0xe3, 0xca, 0x0c, 0x5d, 0x08, 0x46, 0xf6, 0x8b, 0x71, 0xdf, 0x67, 0xe5, 0xae, 0xf9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Bool(this->mRed);
            e->Bool(this->mGreen);
            e->Bool(this->mBlue);
            e->Bool(this->mAlpha);
        }

        atom::Observations mobservations;
        bool mRed;
        bool mGreen;
        bool mBlue;
        bool mAlpha;
    };

    class GlCompileShader: public Encodable {
    public:
        GlCompileShader(atom::Observations observations, ShaderId Shader) :
            mobservations(observations),
            mShader(Shader) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xce, 0x1e, 0x7c, 0xbf, 0xf7, 0xb7, 0x95, 0x6d, 0x38, 0x5d, 0x42, 0x6d, 0x1e, 0xba, 0x0e, 0xd5, 0xf4, 0xa9, 0xe7, 0x30,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
        }

        atom::Observations mobservations;
        ShaderId mShader;
    };

    class TexturePointer: public Encodable {
    public:
        TexturePointer(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb6, 0x31, 0x39, 0xfa, 0x37, 0x1c, 0x57, 0x16, 0x83, 0x12, 0x2a, 0xe9, 0x1c, 0xa8, 0x0f, 0x9d, 0xaf, 0xcf, 0xb3, 0xa3,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlCompressedTexImage2D: public Encodable {
    public:
        GlCompressedTexImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, CompressedTexelFormat Format, int32_t Width, int32_t Height, int32_t Border, int32_t ImageSize, TexturePointer Data) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height),
            mBorder(Border),
            mImageSize(ImageSize),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x88, 0x11, 0xf4, 0x37, 0xd8, 0xc0, 0xe3, 0x49, 0xc1, 0xc3, 0xdd, 0xcf, 0x50, 0xbf, 0xda, 0x61, 0xfb, 0xb4, 0x85, 0x1c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Int32(this->mBorder);
            e->Int32(this->mImageSize);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        CompressedTexelFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
        int32_t mBorder;
        int32_t mImageSize;
        TexturePointer mData;
    };

    class GlCompressedTexSubImage2D: public Encodable {
    public:
        GlCompressedTexSubImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, int32_t Xoffset, int32_t Yoffset, int32_t Width, int32_t Height, CompressedTexelFormat Format, int32_t ImageSize, TexturePointer Data) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mXoffset(Xoffset),
            mYoffset(Yoffset),
            mWidth(Width),
            mHeight(Height),
            mFormat(Format),
            mImageSize(ImageSize),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4c, 0xe3, 0x8f, 0x52, 0x17, 0x8b, 0x87, 0xa1, 0x2f, 0xd4, 0x8c, 0xb6, 0xc9, 0xbe, 0x9e, 0xe3, 0x0a, 0xb5, 0xc6, 0x77,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Int32(this->mXoffset);
            e->Int32(this->mYoffset);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Uint32(this->mFormat);
            e->Int32(this->mImageSize);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        int32_t mXoffset;
        int32_t mYoffset;
        int32_t mWidth;
        int32_t mHeight;
        CompressedTexelFormat mFormat;
        int32_t mImageSize;
        TexturePointer mData;
    };

    class GlCopyTexImage2D: public Encodable {
    public:
        GlCopyTexImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, TexelFormat Format, int32_t X, int32_t Y, int32_t Width, int32_t Height, int32_t Border) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mFormat(Format),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height),
            mBorder(Border) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x47, 0x75, 0x3a, 0x4b, 0x07, 0x67, 0x51, 0x2b, 0x76, 0xd3, 0xab, 0x41, 0x5d, 0xa3, 0x7a, 0xa6, 0x90, 0x28, 0x7f, 0xc3,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Uint32(this->mFormat);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Int32(this->mBorder);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        TexelFormat mFormat;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
        int32_t mBorder;
    };

    class GlCopyTexSubImage2D: public Encodable {
    public:
        GlCopyTexSubImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, int32_t Xoffset, int32_t Yoffset, int32_t X, int32_t Y, int32_t Width, int32_t Height) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mXoffset(Xoffset),
            mYoffset(Yoffset),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x59, 0x01, 0xd8, 0x9f, 0xb0, 0x22, 0x09, 0xff, 0x3a, 0x95, 0x20, 0x68, 0xf8, 0xbf, 0x2c, 0x38, 0x55, 0xac, 0x69, 0x51,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Int32(this->mXoffset);
            e->Int32(this->mYoffset);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        int32_t mXoffset;
        int32_t mYoffset;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlCreateProgram: public Encodable {
    public:
        GlCreateProgram(atom::Observations observations, ProgramId Result) :
            mobservations(observations),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x54, 0xa2, 0x4c, 0x27, 0x9f, 0x12, 0x2c, 0xfb, 0x4f, 0x47, 0x54, 0xd8, 0xfa, 0x4b, 0x69, 0xf6, 0x3e, 0x65, 0x36, 0xc2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        ProgramId mResult;
    };

    class GlCreateShader: public Encodable {
    public:
        GlCreateShader(atom::Observations observations, ShaderType Type, ShaderId Result) :
            mobservations(observations),
            mType(Type),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xcc, 0x3f, 0x4b, 0x85, 0x80, 0xf2, 0x9f, 0x1d, 0x95, 0x89, 0x7f, 0xcd, 0x2e, 0xd6, 0xc7, 0x9f, 0x0a, 0x4b, 0xbf, 0x01,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mType);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        ShaderType mType;
        ShaderId mResult;
    };

    class GlCullFace: public Encodable {
    public:
        GlCullFace(atom::Observations observations, FaceMode Mode) :
            mobservations(observations),
            mMode(Mode) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc3, 0x30, 0x1b, 0x5a, 0x8a, 0x39, 0xc5, 0x2f, 0x95, 0xba, 0x14, 0x8f, 0xdb, 0xf5, 0x16, 0x1f, 0xcb, 0xb9, 0x0a, 0x87,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mMode);
        }

        atom::Observations mobservations;
        FaceMode mMode;
    };

    class GlDeleteBuffers: public Encodable {
    public:
        GlDeleteBuffers(atom::Observations observations, int32_t Count, BufferId__P Buffers) :
            mobservations(observations),
            mCount(Count),
            mBuffers(Buffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8f, 0xe2, 0xcc, 0x25, 0x5b, 0xe5, 0xab, 0xa7, 0x6b, 0x93, 0x97, 0x50, 0xd3, 0x52, 0xd4, 0x71, 0x2d, 0x14, 0xb1, 0xc8,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mBuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        BufferId__P mBuffers;
    };

    class GlDeleteFramebuffers: public Encodable {
    public:
        GlDeleteFramebuffers(atom::Observations observations, int32_t Count, FramebufferId__P Framebuffers) :
            mobservations(observations),
            mCount(Count),
            mFramebuffers(Framebuffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0c, 0x58, 0x2e, 0x54, 0x3d, 0x02, 0x09, 0xe4, 0xbc, 0x40, 0x03, 0x55, 0x92, 0x74, 0x8c, 0xab, 0x0b, 0x29, 0x12, 0x09,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mFramebuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        FramebufferId__P mFramebuffers;
    };

    class GlDeleteProgram: public Encodable {
    public:
        GlDeleteProgram(atom::Observations observations, ProgramId Program) :
            mobservations(observations),
            mProgram(Program) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x3d, 0x9f, 0xd2, 0xe3, 0xa2, 0x70, 0x3d, 0x38, 0x17, 0x8a, 0x71, 0xca, 0xbe, 0xb4, 0x8c, 0x97, 0x00, 0x75, 0x9f, 0x2f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
    };

    class QueryId__P: public Encodable {
    public:
        QueryId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbc, 0x1f, 0x91, 0x31, 0xab, 0x23, 0x97, 0xbd, 0x24, 0x4b, 0x69, 0x3f, 0xb9, 0x40, 0xf4, 0xb4, 0xb3, 0x93, 0x43, 0x33,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlDeleteQueries: public Encodable {
    public:
        GlDeleteQueries(atom::Observations observations, int32_t Count, QueryId__P Queries) :
            mobservations(observations),
            mCount(Count),
            mQueries(Queries) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xef, 0x66, 0xdb, 0x46, 0x91, 0x9a, 0x79, 0x40, 0x07, 0x4b, 0x18, 0x38, 0x4c, 0x3f, 0x5f, 0x36, 0x65, 0x6b, 0x86, 0x6f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mQueries);
        }

        atom::Observations mobservations;
        int32_t mCount;
        QueryId__P mQueries;
    };

    class GlDeleteQueriesEXT: public Encodable {
    public:
        GlDeleteQueriesEXT(atom::Observations observations, int32_t Count, QueryId__P Queries) :
            mobservations(observations),
            mCount(Count),
            mQueries(Queries) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc1, 0xba, 0x04, 0x28, 0x00, 0x4f, 0x7f, 0x73, 0xae, 0x18, 0x11, 0x19, 0x70, 0xd0, 0xe4, 0xc9, 0x2e, 0x01, 0x80, 0xfa,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mQueries);
        }

        atom::Observations mobservations;
        int32_t mCount;
        QueryId__P mQueries;
    };

    class RenderbufferId__P: public Encodable {
    public:
        RenderbufferId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x18, 0xae, 0x51, 0x0d, 0xb7, 0xf3, 0xf8, 0xe7, 0x47, 0x3f, 0x5d, 0x29, 0xf8, 0x43, 0x60, 0xe2, 0x5a, 0x2d, 0xa6, 0x9b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlDeleteRenderbuffers: public Encodable {
    public:
        GlDeleteRenderbuffers(atom::Observations observations, int32_t Count, RenderbufferId__P Renderbuffers) :
            mobservations(observations),
            mCount(Count),
            mRenderbuffers(Renderbuffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc7, 0x91, 0x63, 0x48, 0xf4, 0xe3, 0xea, 0x86, 0x4b, 0x3c, 0x40, 0x44, 0x6c, 0x5d, 0x8c, 0x87, 0xb9, 0x7d, 0x26, 0x4b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mRenderbuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        RenderbufferId__P mRenderbuffers;
    };

    class GlDeleteShader: public Encodable {
    public:
        GlDeleteShader(atom::Observations observations, ShaderId Shader) :
            mobservations(observations),
            mShader(Shader) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x11, 0xd1, 0xa7, 0x92, 0xf4, 0x7b, 0x74, 0x2a, 0xac, 0x29, 0x4f, 0x42, 0x17, 0x9c, 0x3e, 0xb9, 0x03, 0x8d, 0xbd, 0xe7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
        }

        atom::Observations mobservations;
        ShaderId mShader;
    };

    class TextureId__P: public Encodable {
    public:
        TextureId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x99, 0x6c, 0x61, 0x83, 0x7a, 0xc0, 0x86, 0x16, 0x1a, 0x93, 0x45, 0x97, 0x32, 0x66, 0x80, 0x91, 0xd1, 0x87, 0xd1, 0x8e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlDeleteTextures: public Encodable {
    public:
        GlDeleteTextures(atom::Observations observations, int32_t Count, TextureId__P Textures) :
            mobservations(observations),
            mCount(Count),
            mTextures(Textures) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8e, 0x87, 0xbe, 0x83, 0xfc, 0x68, 0xab, 0x65, 0x39, 0x6d, 0x29, 0xe8, 0x91, 0x0a, 0xb4, 0x3b, 0x72, 0x6b, 0x87, 0xdc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mTextures);
        }

        atom::Observations mobservations;
        int32_t mCount;
        TextureId__P mTextures;
    };

    class VertexArrayId__P: public Encodable {
    public:
        VertexArrayId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xfb, 0x13, 0x6e, 0xf5, 0x8d, 0x52, 0xf5, 0xb2, 0xb5, 0x02, 0x1f, 0x10, 0x15, 0x84, 0x51, 0xb2, 0xc6, 0x8b, 0xc5, 0x5f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlDeleteVertexArraysOES: public Encodable {
    public:
        GlDeleteVertexArraysOES(atom::Observations observations, int32_t Count, VertexArrayId__P Arrays) :
            mobservations(observations),
            mCount(Count),
            mArrays(Arrays) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb6, 0xb4, 0x59, 0xf8, 0x46, 0x00, 0x47, 0x2c, 0x12, 0xa7, 0x1a, 0xfe, 0xee, 0xd4, 0xa6, 0x1a, 0xfc, 0x47, 0xef, 0x0c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mArrays);
        }

        atom::Observations mobservations;
        int32_t mCount;
        VertexArrayId__P mArrays;
    };

    class GlDepthFunc: public Encodable {
    public:
        GlDepthFunc(atom::Observations observations, TestFunction Function) :
            mobservations(observations),
            mFunction(Function) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa7, 0x7e, 0x09, 0x94, 0x5c, 0x20, 0x03, 0xac, 0x59, 0x2f, 0xe6, 0xfd, 0x3e, 0xcc, 0x20, 0x33, 0xa8, 0x09, 0xce, 0x0b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFunction);
        }

        atom::Observations mobservations;
        TestFunction mFunction;
    };

    class GlDepthMask: public Encodable {
    public:
        GlDepthMask(atom::Observations observations, bool Enabled) :
            mobservations(observations),
            mEnabled(Enabled) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc5, 0x6d, 0x4e, 0x1a, 0x87, 0x06, 0xec, 0xa4, 0xe8, 0xb4, 0x2e, 0x82, 0xff, 0x78, 0x0a, 0x83, 0x79, 0x82, 0xce, 0xf1,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Bool(this->mEnabled);
        }

        atom::Observations mobservations;
        bool mEnabled;
    };

    class GlDepthRangef: public Encodable {
    public:
        GlDepthRangef(atom::Observations observations, float Near, float Far) :
            mobservations(observations),
            mNear(Near),
            mFar(Far) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x78, 0x1b, 0x34, 0xe8, 0x78, 0x4e, 0x71, 0xa9, 0xe2, 0x5f, 0x8c, 0xb7, 0x13, 0x10, 0x6f, 0x22, 0xbe, 0x5c, 0x85, 0x96,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mNear);
            e->Float32(this->mFar);
        }

        atom::Observations mobservations;
        float mNear;
        float mFar;
    };

    class GlDetachShader: public Encodable {
    public:
        GlDetachShader(atom::Observations observations, ProgramId Program, ShaderId Shader) :
            mobservations(observations),
            mProgram(Program),
            mShader(Shader) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd1, 0xf8, 0x03, 0x27, 0x0d, 0xc3, 0xbb, 0x7b, 0x58, 0xa8, 0x8a, 0x4d, 0x7b, 0x24, 0x57, 0xa3, 0x00, 0xcf, 0xc4, 0xce,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mShader);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        ShaderId mShader;
    };

    class GlDisable: public Encodable {
    public:
        GlDisable(atom::Observations observations, Capability Capability) :
            mobservations(observations),
            mCapability(Capability) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x79, 0x79, 0x54, 0xb0, 0x72, 0xfd, 0x82, 0xa8, 0x02, 0x84, 0x02, 0x24, 0xd8, 0x72, 0x8c, 0xf8, 0x1d, 0x1c, 0x4b, 0xc4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mCapability);
        }

        atom::Observations mobservations;
        Capability mCapability;
    };

    class GlDisableClientState: public Encodable {
    public:
        GlDisableClientState(atom::Observations observations, ArrayType Type) :
            mobservations(observations),
            mType(Type) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xba, 0x1b, 0xf5, 0xf6, 0x05, 0x90, 0x12, 0x0a, 0xdd, 0x26, 0x72, 0x28, 0xcf, 0xe0, 0xd8, 0x82, 0xbf, 0x60, 0xd6, 0x21,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mType);
        }

        atom::Observations mobservations;
        ArrayType mType;
    };

    class GlDisableVertexAttribArray: public Encodable {
    public:
        GlDisableVertexAttribArray(atom::Observations observations, AttributeLocation Location) :
            mobservations(observations),
            mLocation(Location) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0e, 0x71, 0x56, 0x6a, 0x0a, 0x8d, 0xc7, 0x6b, 0x76, 0x8f, 0x05, 0xca, 0xeb, 0x95, 0x01, 0x46, 0x44, 0xf6, 0xf3, 0x52,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
    };

    class GlDiscardFramebufferEXT: public Encodable {
    public:
        GlDiscardFramebufferEXT(atom::Observations observations, FramebufferTarget Target, int32_t NumAttachments, DiscardFramebufferAttachment__P Attachments) :
            mobservations(observations),
            mTarget(Target),
            mNumAttachments(NumAttachments),
            mAttachments(Attachments) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x70, 0xae, 0x75, 0x3e, 0x8d, 0x47, 0xfa, 0xcd, 0x76, 0x68, 0xa1, 0x25, 0x90, 0x55, 0xb0, 0xd5, 0x30, 0x09, 0x62, 0x27,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mNumAttachments);
            e->Value(&this->mAttachments);
        }

        atom::Observations mobservations;
        FramebufferTarget mTarget;
        int32_t mNumAttachments;
        DiscardFramebufferAttachment__P mAttachments;
    };

    class GlDrawArrays: public Encodable {
    public:
        GlDrawArrays(atom::Observations observations, DrawMode DrawMode, int32_t FirstIndex, int32_t IndexCount) :
            mobservations(observations),
            mDrawMode(DrawMode),
            mFirstIndex(FirstIndex),
            mIndexCount(IndexCount) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7f, 0xea, 0xee, 0x65, 0x7d, 0xf9, 0x1f, 0x13, 0xae, 0x78, 0x1b, 0x1c, 0xbb, 0x29, 0x62, 0xe6, 0x6a, 0xd4, 0x67, 0x8f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mDrawMode);
            e->Int32(this->mFirstIndex);
            e->Int32(this->mIndexCount);
        }

        atom::Observations mobservations;
        DrawMode mDrawMode;
        int32_t mFirstIndex;
        int32_t mIndexCount;
    };

    class IndicesPointer: public Encodable {
    public:
        IndicesPointer(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x76, 0x75, 0x96, 0xf7, 0x8e, 0x48, 0x4e, 0x8b, 0x35, 0x9b, 0x75, 0x1f, 0xb2, 0x5a, 0x50, 0xb7, 0x2e, 0x2f, 0xa9, 0xe2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlDrawElements: public Encodable {
    public:
        GlDrawElements(atom::Observations observations, DrawMode DrawMode, int32_t ElementCount, IndicesType IndicesType, IndicesPointer Indices) :
            mobservations(observations),
            mDrawMode(DrawMode),
            mElementCount(ElementCount),
            mIndicesType(IndicesType),
            mIndices(Indices) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x18, 0xba, 0xb0, 0xb5, 0x2d, 0xca, 0xbb, 0x23, 0xb0, 0x0a, 0xc4, 0x9f, 0xb7, 0xd5, 0xc2, 0xa7, 0xab, 0x41, 0x6b, 0x21,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mDrawMode);
            e->Int32(this->mElementCount);
            e->Uint32(this->mIndicesType);
            e->Value(&this->mIndices);
        }

        atom::Observations mobservations;
        DrawMode mDrawMode;
        int32_t mElementCount;
        IndicesType mIndicesType;
        IndicesPointer mIndices;
    };

    class GlEGLImageTargetRenderbufferStorageOES: public Encodable {
    public:
        GlEGLImageTargetRenderbufferStorageOES(atom::Observations observations, ImageTargetRenderbufferStorage Target, TexturePointer Image) :
            mobservations(observations),
            mTarget(Target),
            mImage(Image) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x53, 0x5e, 0x99, 0x02, 0x81, 0xd9, 0x2d, 0x36, 0xa1, 0xc6, 0x25, 0xd8, 0x3d, 0x5e, 0xa1, 0xb2, 0xfb, 0xda, 0xb4, 0x8d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Value(&this->mImage);
        }

        atom::Observations mobservations;
        ImageTargetRenderbufferStorage mTarget;
        TexturePointer mImage;
    };

    class ImageOES: public Encodable {
    public:
        ImageOES(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x77, 0x91, 0xd9, 0x22, 0x22, 0x46, 0xfa, 0x9b, 0xc5, 0xf0, 0x4f, 0x9b, 0xa6, 0x73, 0xe8, 0xdf, 0x22, 0x6b, 0x06, 0x36,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlEGLImageTargetTexture2DOES: public Encodable {
    public:
        GlEGLImageTargetTexture2DOES(atom::Observations observations, ImageTargetTexture Target, ImageOES Image) :
            mobservations(observations),
            mTarget(Target),
            mImage(Image) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x56, 0x39, 0x9e, 0x74, 0x52, 0x6e, 0xa3, 0x41, 0xc9, 0xab, 0x03, 0x18, 0x30, 0x25, 0x3a, 0x08, 0x6d, 0xae, 0xe7, 0x35,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Value(&this->mImage);
        }

        atom::Observations mobservations;
        ImageTargetTexture mTarget;
        ImageOES mImage;
    };

    class GlEnable: public Encodable {
    public:
        GlEnable(atom::Observations observations, Capability Capability) :
            mobservations(observations),
            mCapability(Capability) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x48, 0xaa, 0x9b, 0x21, 0xfc, 0xc7, 0xe6, 0x29, 0xf7, 0xcf, 0xda, 0x40, 0x88, 0x59, 0x9c, 0x23, 0xb4, 0xb0, 0xfe, 0x74,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mCapability);
        }

        atom::Observations mobservations;
        Capability mCapability;
    };

    class GlEnableClientState: public Encodable {
    public:
        GlEnableClientState(atom::Observations observations, ArrayType Type) :
            mobservations(observations),
            mType(Type) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x82, 0x27, 0xe0, 0xfe, 0xce, 0xe9, 0x44, 0xf2, 0x48, 0x00, 0xc4, 0x51, 0x95, 0x03, 0xe3, 0xe3, 0x97, 0x3e, 0x73, 0x92,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mType);
        }

        atom::Observations mobservations;
        ArrayType mType;
    };

    class GlEnableVertexAttribArray: public Encodable {
    public:
        GlEnableVertexAttribArray(atom::Observations observations, AttributeLocation Location) :
            mobservations(observations),
            mLocation(Location) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe7, 0x92, 0xb4, 0x99, 0xeb, 0x7e, 0xdc, 0x7a, 0xbb, 0x5b, 0x49, 0x71, 0x82, 0xd3, 0x09, 0x49, 0xb4, 0x0f, 0xfc, 0x66,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
    };

    class GlEndQuery: public Encodable {
    public:
        GlEndQuery(atom::Observations observations, QueryTarget Target) :
            mobservations(observations),
            mTarget(Target) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb0, 0xc0, 0x56, 0x8b, 0xa4, 0xc3, 0x2b, 0xde, 0xb0, 0xaa, 0x61, 0xa9, 0x06, 0x63, 0x1b, 0xc6, 0xe2, 0x5b, 0xa0, 0x42,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
    };

    class GlEndQueryEXT: public Encodable {
    public:
        GlEndQueryEXT(atom::Observations observations, QueryTarget Target) :
            mobservations(observations),
            mTarget(Target) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x12, 0x04, 0x23, 0x20, 0x96, 0x9c, 0x40, 0xb8, 0x80, 0xfe, 0x76, 0x70, 0x48, 0xdf, 0x81, 0x60, 0xb1, 0x23, 0xab, 0x12,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
    };

    class GlEndTilingQCOM: public Encodable {
    public:
        GlEndTilingQCOM(atom::Observations observations, TilePreserveMaskQCOM PreserveMask) :
            mobservations(observations),
            mPreserveMask(PreserveMask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x51, 0x3b, 0x7d, 0x13, 0xa0, 0xbc, 0xcf, 0x24, 0x84, 0x9a, 0xc3, 0x78, 0x7e, 0x2c, 0xe4, 0x23, 0x6e, 0x23, 0xdd, 0x9a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mPreserveMask);
        }

        atom::Observations mobservations;
        TilePreserveMaskQCOM mPreserveMask;
    };

    class GlFinish: public Encodable {
    public:
        GlFinish(atom::Observations observations) :
            mobservations(observations) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x62, 0xe9, 0xca, 0xf4, 0x39, 0xd8, 0x39, 0x1e, 0x49, 0x43, 0x1f, 0x40, 0xbb, 0x3d, 0x1b, 0x11, 0xc9, 0x5c, 0x9a, 0xf9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
        }

        atom::Observations mobservations;
    };

    class GlFlush: public Encodable {
    public:
        GlFlush(atom::Observations observations) :
            mobservations(observations) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x63, 0x83, 0x26, 0x9a, 0x10, 0x6b, 0x68, 0x9f, 0x90, 0x65, 0x54, 0xba, 0x66, 0x25, 0xc8, 0x09, 0x24, 0xe3, 0x21, 0x00,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
        }

        atom::Observations mobservations;
    };

    class GlFramebufferRenderbuffer: public Encodable {
    public:
        GlFramebufferRenderbuffer(atom::Observations observations, FramebufferTarget FramebufferTarget, FramebufferAttachment FramebufferAttachment, RenderbufferTarget RenderbufferTarget, RenderbufferId Renderbuffer) :
            mobservations(observations),
            mFramebufferTarget(FramebufferTarget),
            mFramebufferAttachment(FramebufferAttachment),
            mRenderbufferTarget(RenderbufferTarget),
            mRenderbuffer(Renderbuffer) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x08, 0x60, 0xdc, 0xd3, 0x3d, 0xe4, 0xdf, 0xea, 0xb9, 0x9c, 0xa5, 0xd2, 0x51, 0x4b, 0x35, 0x5a, 0xf0, 0xc7, 0xd6, 0xe2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFramebufferTarget);
            e->Uint32(this->mFramebufferAttachment);
            e->Uint32(this->mRenderbufferTarget);
            e->Uint32(this->mRenderbuffer);
        }

        atom::Observations mobservations;
        FramebufferTarget mFramebufferTarget;
        FramebufferAttachment mFramebufferAttachment;
        RenderbufferTarget mRenderbufferTarget;
        RenderbufferId mRenderbuffer;
    };

    class GlFramebufferTexture2D: public Encodable {
    public:
        GlFramebufferTexture2D(atom::Observations observations, FramebufferTarget FramebufferTarget, FramebufferAttachment FramebufferAttachment, TextureImageTarget TextureTarget, TextureId Texture, int32_t Level) :
            mobservations(observations),
            mFramebufferTarget(FramebufferTarget),
            mFramebufferAttachment(FramebufferAttachment),
            mTextureTarget(TextureTarget),
            mTexture(Texture),
            mLevel(Level) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x10, 0x30, 0x07, 0x4c, 0xd1, 0xfc, 0x8a, 0xb5, 0xa6, 0x3d, 0x8f, 0x3d, 0xc4, 0x89, 0x04, 0x9d, 0x45, 0x46, 0x4f, 0x08,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFramebufferTarget);
            e->Uint32(this->mFramebufferAttachment);
            e->Uint32(this->mTextureTarget);
            e->Uint32(this->mTexture);
            e->Int32(this->mLevel);
        }

        atom::Observations mobservations;
        FramebufferTarget mFramebufferTarget;
        FramebufferAttachment mFramebufferAttachment;
        TextureImageTarget mTextureTarget;
        TextureId mTexture;
        int32_t mLevel;
    };

    class GlFrontFace: public Encodable {
    public:
        GlFrontFace(atom::Observations observations, FaceOrientation Orientation) :
            mobservations(observations),
            mOrientation(Orientation) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x1e, 0x28, 0xc7, 0x47, 0x97, 0xc9, 0x1c, 0x7f, 0x57, 0xde, 0x5e, 0x6f, 0xce, 0x21, 0x17, 0xf4, 0xb0, 0xd8, 0xa9, 0x44,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mOrientation);
        }

        atom::Observations mobservations;
        FaceOrientation mOrientation;
    };

    class GlGenBuffers: public Encodable {
    public:
        GlGenBuffers(atom::Observations observations, int32_t Count, BufferId__P Buffers) :
            mobservations(observations),
            mCount(Count),
            mBuffers(Buffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x32, 0x53, 0x4b, 0x2a, 0xe7, 0xc6, 0x48, 0x67, 0xd2, 0x7b, 0x7f, 0x3b, 0x84, 0xa6, 0x7c, 0x78, 0x84, 0x3d, 0xf0, 0xdf,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mBuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        BufferId__P mBuffers;
    };

    class GlGenFramebuffers: public Encodable {
    public:
        GlGenFramebuffers(atom::Observations observations, int32_t Count, FramebufferId__P Framebuffers) :
            mobservations(observations),
            mCount(Count),
            mFramebuffers(Framebuffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x1f, 0xc4, 0xb4, 0x78, 0xb4, 0x9a, 0xa1, 0x24, 0x35, 0x98, 0x6f, 0x28, 0x1b, 0xbb, 0xea, 0x8f, 0xec, 0x0b, 0xe7, 0xb6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mFramebuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        FramebufferId__P mFramebuffers;
    };

    class GlGenQueries: public Encodable {
    public:
        GlGenQueries(atom::Observations observations, int32_t Count, QueryId__P Queries) :
            mobservations(observations),
            mCount(Count),
            mQueries(Queries) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x39, 0x4c, 0xdc, 0xb4, 0x99, 0x69, 0x21, 0x1d, 0x29, 0x7b, 0x63, 0xb9, 0xf3, 0x15, 0xf0, 0x91, 0x19, 0x96, 0x55, 0xfb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mQueries);
        }

        atom::Observations mobservations;
        int32_t mCount;
        QueryId__P mQueries;
    };

    class GlGenQueriesEXT: public Encodable {
    public:
        GlGenQueriesEXT(atom::Observations observations, int32_t Count, QueryId__P Queries) :
            mobservations(observations),
            mCount(Count),
            mQueries(Queries) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa9, 0x25, 0x0c, 0x6b, 0x1d, 0x84, 0x28, 0x3b, 0x88, 0xc1, 0xff, 0xc1, 0x76, 0x53, 0x13, 0x2f, 0x27, 0x5e, 0x30, 0x53,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mQueries);
        }

        atom::Observations mobservations;
        int32_t mCount;
        QueryId__P mQueries;
    };

    class GlGenRenderbuffers: public Encodable {
    public:
        GlGenRenderbuffers(atom::Observations observations, int32_t Count, RenderbufferId__P Renderbuffers) :
            mobservations(observations),
            mCount(Count),
            mRenderbuffers(Renderbuffers) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x07, 0x42, 0x56, 0x00, 0xfe, 0x35, 0xc4, 0xa9, 0x57, 0xec, 0x42, 0x13, 0x7f, 0xd4, 0x19, 0xb8, 0xa8, 0xa8, 0x6c, 0x71,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mRenderbuffers);
        }

        atom::Observations mobservations;
        int32_t mCount;
        RenderbufferId__P mRenderbuffers;
    };

    class GlGenTextures: public Encodable {
    public:
        GlGenTextures(atom::Observations observations, int32_t Count, TextureId__P Textures) :
            mobservations(observations),
            mCount(Count),
            mTextures(Textures) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x64, 0x29, 0x1a, 0xec, 0x06, 0x04, 0x37, 0x17, 0xd4, 0x7d, 0x2a, 0x05, 0x6a, 0xdc, 0x2d, 0x0f, 0x1e, 0xce, 0x1e, 0x5a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mTextures);
        }

        atom::Observations mobservations;
        int32_t mCount;
        TextureId__P mTextures;
    };

    class GlGenVertexArraysOES: public Encodable {
    public:
        GlGenVertexArraysOES(atom::Observations observations, int32_t Count, VertexArrayId__P Arrays) :
            mobservations(observations),
            mCount(Count),
            mArrays(Arrays) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe0, 0x5b, 0x77, 0xc1, 0x67, 0x6d, 0xa5, 0xa2, 0xc7, 0x21, 0x8c, 0x2b, 0x0c, 0xd5, 0xab, 0x25, 0x91, 0xb2, 0x4d, 0x9c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mArrays);
        }

        atom::Observations mobservations;
        int32_t mCount;
        VertexArrayId__P mArrays;
    };

    class GlGenerateMipmap: public Encodable {
    public:
        GlGenerateMipmap(atom::Observations observations, TextureImageTarget Target) :
            mobservations(observations),
            mTarget(Target) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x42, 0xea, 0x5b, 0xaa, 0xcc, 0x26, 0x78, 0xf5, 0xf0, 0x10, 0x98, 0x9f, 0xa8, 0xb6, 0x7b, 0xae, 0xf8, 0xbd, 0x42, 0x3e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
    };

    class S32__P: public Encodable {
    public:
        S32__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x15, 0xd8, 0xda, 0x55, 0xc7, 0x51, 0xdc, 0x13, 0x0e, 0xe6, 0xf3, 0x33, 0x66, 0x41, 0xd6, 0xf1, 0x5f, 0x02, 0x93, 0x41,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class ShaderAttribType__P: public Encodable {
    public:
        ShaderAttribType__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xae, 0xed, 0x56, 0xf7, 0xb4, 0xb8, 0x0b, 0x47, 0x04, 0xa1, 0xc2, 0x24, 0x58, 0x0d, 0x4b, 0xd2, 0xb8, 0x43, 0xac, 0x6b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetActiveAttrib: public Encodable {
    public:
        GlGetActiveAttrib(atom::Observations observations, ProgramId Program, AttributeLocation Location, int32_t BufferSize, S32__P BufferBytesWritten, S32__P VectorCount, ShaderAttribType__P Type, Char__P Name) :
            mobservations(observations),
            mProgram(Program),
            mLocation(Location),
            mBufferSize(BufferSize),
            mBufferBytesWritten(BufferBytesWritten),
            mVectorCount(VectorCount),
            mType(Type),
            mName(Name) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa6, 0x71, 0x22, 0x04, 0xa2, 0x0e, 0x8a, 0x5b, 0x9e, 0x05, 0x76, 0x4a, 0x54, 0x82, 0x91, 0xce, 0xfb, 0x76, 0x4b, 0x97,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mLocation);
            e->Int32(this->mBufferSize);
            e->Value(&this->mBufferBytesWritten);
            e->Value(&this->mVectorCount);
            e->Value(&this->mType);
            e->Value(&this->mName);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        AttributeLocation mLocation;
        int32_t mBufferSize;
        S32__P mBufferBytesWritten;
        S32__P mVectorCount;
        ShaderAttribType__P mType;
        Char__P mName;
    };

    class ShaderUniformType__P: public Encodable {
    public:
        ShaderUniformType__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xec, 0x33, 0x14, 0x93, 0x2e, 0xbc, 0x9b, 0x5b, 0x66, 0x62, 0x30, 0x7a, 0x5d, 0x8f, 0x13, 0x4e, 0x2b, 0x39, 0xc9, 0x32,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetActiveUniform: public Encodable {
    public:
        GlGetActiveUniform(atom::Observations observations, ProgramId Program, int32_t Location, int32_t BufferSize, S32__P BufferBytesWritten, S32__P VectorCount, ShaderUniformType__P Type, Char__P Name) :
            mobservations(observations),
            mProgram(Program),
            mLocation(Location),
            mBufferSize(BufferSize),
            mBufferBytesWritten(BufferBytesWritten),
            mVectorCount(VectorCount),
            mType(Type),
            mName(Name) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6e, 0xac, 0x3c, 0x92, 0xee, 0x19, 0x7e, 0x39, 0x44, 0x04, 0x5d, 0xec, 0xb0, 0xa2, 0xdc, 0x94, 0x6e, 0x5b, 0x05, 0x3c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mLocation);
            e->Int32(this->mBufferSize);
            e->Value(&this->mBufferBytesWritten);
            e->Value(&this->mVectorCount);
            e->Value(&this->mType);
            e->Value(&this->mName);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        int32_t mLocation;
        int32_t mBufferSize;
        S32__P mBufferBytesWritten;
        S32__P mVectorCount;
        ShaderUniformType__P mType;
        Char__P mName;
    };

    class ShaderId__P: public Encodable {
    public:
        ShaderId__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x08, 0x41, 0x7d, 0x5d, 0x94, 0x16, 0xc5, 0x83, 0xb1, 0x5b, 0x6b, 0x53, 0x78, 0xac, 0x10, 0xbd, 0x1e, 0x59, 0x09, 0x1d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetAttachedShaders: public Encodable {
    public:
        GlGetAttachedShaders(atom::Observations observations, ProgramId Program, int32_t BufferLength, S32__P ShadersLengthWritten, ShaderId__P Shaders) :
            mobservations(observations),
            mProgram(Program),
            mBufferLength(BufferLength),
            mShadersLengthWritten(ShadersLengthWritten),
            mShaders(Shaders) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc3, 0xf9, 0x1d, 0xd0, 0xcc, 0x89, 0x4c, 0x62, 0xad, 0x92, 0x44, 0x25, 0x6d, 0x63, 0x8b, 0x92, 0x1a, 0x01, 0xeb, 0xb4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mBufferLength);
            e->Value(&this->mShadersLengthWritten);
            e->Value(&this->mShaders);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        int32_t mBufferLength;
        S32__P mShadersLengthWritten;
        ShaderId__P mShaders;
    };

    class GlGetAttribLocation: public Encodable {
    public:
        GlGetAttribLocation(atom::Observations observations, ProgramId Program, char* Name, AttributeLocation Result) :
            mobservations(observations),
            mProgram(Program),
            mName(Name),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x31, 0x3d, 0x4f, 0xb6, 0x80, 0x95, 0xce, 0x6a, 0x65, 0x25, 0x0a, 0xb5, 0xff, 0x15, 0x44, 0x1d, 0x3e, 0x91, 0xc7, 0xef,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->String(this->mName);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        char* mName;
        AttributeLocation mResult;
    };

    class GlGetBooleanv: public Encodable {
    public:
        GlGetBooleanv(atom::Observations observations, StateVariable Param, Bool__P Values) :
            mobservations(observations),
            mParam(Param),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbf, 0x1d, 0xb7, 0x81, 0xa0, 0x1f, 0x6b, 0x03, 0x21, 0xe3, 0x51, 0x7c, 0x73, 0x4f, 0xf9, 0x9a, 0x62, 0x0a, 0xfd, 0xa4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mParam);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        StateVariable mParam;
        Bool__P mValues;
    };

    class GlGetBufferParameteriv: public Encodable {
    public:
        GlGetBufferParameteriv(atom::Observations observations, BufferTarget Target, BufferParameter Parameter, S32__P Value) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc3, 0xad, 0xb9, 0xd4, 0x86, 0x78, 0x8e, 0x05, 0x73, 0x0d, 0x21, 0x3e, 0x98, 0xb8, 0x6c, 0x68, 0x13, 0x06, 0xb4, 0x56,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
        BufferParameter mParameter;
        S32__P mValue;
    };

    class GlGetError: public Encodable {
    public:
        GlGetError(atom::Observations observations, Error Result) :
            mobservations(observations),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x32, 0xd4, 0xe6, 0xb7, 0x2f, 0x3a, 0x06, 0xc9, 0xe3, 0x7c, 0x56, 0x38, 0x38, 0x95, 0xa4, 0x28, 0x38, 0x57, 0x2c, 0x9e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        Error mResult;
    };

    class GlGetFloatv: public Encodable {
    public:
        GlGetFloatv(atom::Observations observations, StateVariable Param, F32__P Values) :
            mobservations(observations),
            mParam(Param),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x3b, 0xdb, 0xfd, 0xab, 0xa4, 0xad, 0x98, 0xf5, 0x0d, 0x91, 0xdb, 0xe3, 0x45, 0xe3, 0x71, 0xf1, 0x6e, 0xd1, 0x59, 0x11,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mParam);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        StateVariable mParam;
        F32__P mValues;
    };

    class GlGetFramebufferAttachmentParameteriv: public Encodable {
    public:
        GlGetFramebufferAttachmentParameteriv(atom::Observations observations, FramebufferTarget FramebufferTarget, FramebufferAttachment Attachment, FramebufferAttachmentParameter Parameter, S32__P Value) :
            mobservations(observations),
            mFramebufferTarget(FramebufferTarget),
            mAttachment(Attachment),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xea, 0x0f, 0x37, 0x28, 0xa8, 0x59, 0x9e, 0x90, 0x50, 0x4a, 0xa4, 0x6d, 0xa2, 0xe3, 0x43, 0xf2, 0xd2, 0x6d, 0x09, 0x40,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFramebufferTarget);
            e->Uint32(this->mAttachment);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        FramebufferTarget mFramebufferTarget;
        FramebufferAttachment mAttachment;
        FramebufferAttachmentParameter mParameter;
        S32__P mValue;
    };

    class GlGetGraphicsResetStatusEXT: public Encodable {
    public:
        GlGetGraphicsResetStatusEXT(atom::Observations observations, ResetStatus Result) :
            mobservations(observations),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x05, 0xbe, 0x22, 0x49, 0x59, 0x3a, 0x7c, 0x01, 0xa0, 0x5c, 0x5c, 0xf3, 0x08, 0xa2, 0xc6, 0xfa, 0x87, 0x3e, 0xdd, 0x53,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mResult);
        }

        atom::Observations mobservations;
        ResetStatus mResult;
    };

    class GlGetIntegerv: public Encodable {
    public:
        GlGetIntegerv(atom::Observations observations, StateVariable Param, S32__P Values) :
            mobservations(observations),
            mParam(Param),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x93, 0xaa, 0x39, 0x40, 0xc7, 0xf4, 0x20, 0x49, 0x7b, 0x61, 0xfc, 0x8f, 0x9d, 0x2d, 0xe9, 0x9c, 0x8c, 0xb3, 0xc7, 0x62,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mParam);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        StateVariable mParam;
        S32__P mValues;
    };

    class U32__P: public Encodable {
    public:
        U32__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbc, 0x9f, 0x1f, 0x59, 0xba, 0xa6, 0x8d, 0xe3, 0x2f, 0x46, 0xe5, 0xf1, 0xde, 0x51, 0x77, 0x45, 0xab, 0x1f, 0xdc, 0x67,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetProgramBinaryOES: public Encodable {
    public:
        GlGetProgramBinaryOES(atom::Observations observations, ProgramId Program, int32_t BufferSize, S32__P BytesWritten, U32__P BinaryFormat, Void__P Binary) :
            mobservations(observations),
            mProgram(Program),
            mBufferSize(BufferSize),
            mBytesWritten(BytesWritten),
            mBinaryFormat(BinaryFormat),
            mBinary(Binary) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x41, 0xe1, 0x61, 0x7a, 0xa2, 0x17, 0x6f, 0x2f, 0xd4, 0xaf, 0x47, 0x68, 0xce, 0x51, 0x64, 0x3a, 0x97, 0xbb, 0xf3, 0xec,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mBufferSize);
            e->Value(&this->mBytesWritten);
            e->Value(&this->mBinaryFormat);
            e->Value(&this->mBinary);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        int32_t mBufferSize;
        S32__P mBytesWritten;
        U32__P mBinaryFormat;
        Void__P mBinary;
    };

    class GlGetProgramInfoLog: public Encodable {
    public:
        GlGetProgramInfoLog(atom::Observations observations, ProgramId Program, int32_t BufferLength, S32__P StringLengthWritten, Char__P Info) :
            mobservations(observations),
            mProgram(Program),
            mBufferLength(BufferLength),
            mStringLengthWritten(StringLengthWritten),
            mInfo(Info) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7f, 0xd8, 0xe7, 0x8b, 0xf6, 0xa4, 0x9e, 0xe4, 0xcd, 0xbf, 0x72, 0x0d, 0xc9, 0xc0, 0xdc, 0xb0, 0x5e, 0x3c, 0x52, 0x21,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mBufferLength);
            e->Value(&this->mStringLengthWritten);
            e->Value(&this->mInfo);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        int32_t mBufferLength;
        S32__P mStringLengthWritten;
        Char__P mInfo;
    };

    class GlGetProgramiv: public Encodable {
    public:
        GlGetProgramiv(atom::Observations observations, ProgramId Program, ProgramParameter Parameter, S32__P Value) :
            mobservations(observations),
            mProgram(Program),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0c, 0x30, 0x8a, 0xb8, 0x12, 0x64, 0xb2, 0x25, 0xfe, 0x4c, 0x3e, 0xaf, 0x2c, 0x0d, 0x05, 0x67, 0x8f, 0x95, 0xb2, 0x41,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        ProgramParameter mParameter;
        S32__P mValue;
    };

    class S64__P: public Encodable {
    public:
        S64__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x94, 0xcc, 0x14, 0xe7, 0xe5, 0xaa, 0x45, 0x47, 0x68, 0x47, 0x60, 0x90, 0x4d, 0x40, 0x9e, 0x4e, 0xa3, 0x65, 0x3a, 0x9b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetQueryObjecti64vEXT: public Encodable {
    public:
        GlGetQueryObjecti64vEXT(atom::Observations observations, QueryId Query, QueryObjectParameter Parameter, S64__P Value) :
            mobservations(observations),
            mQuery(Query),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4d, 0xad, 0xff, 0x92, 0xcd, 0xd0, 0xac, 0xe7, 0x0e, 0x9f, 0xa7, 0x7b, 0x91, 0x31, 0xfb, 0x37, 0xea, 0x2c, 0xbd, 0x9c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryObjectParameter mParameter;
        S64__P mValue;
    };

    class GlGetQueryObjectivEXT: public Encodable {
    public:
        GlGetQueryObjectivEXT(atom::Observations observations, QueryId Query, QueryObjectParameter Parameter, S32__P Value) :
            mobservations(observations),
            mQuery(Query),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x83, 0xd8, 0xfe, 0x13, 0x5b, 0xce, 0x42, 0x6f, 0x82, 0xbc, 0x0b, 0xfe, 0x33, 0xae, 0xd6, 0x73, 0x87, 0xe4, 0x95, 0xad,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryObjectParameter mParameter;
        S32__P mValue;
    };

    class U64__P: public Encodable {
    public:
        U64__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x5b, 0xb1, 0xae, 0xc9, 0xd5, 0x8f, 0x30, 0x22, 0xf4, 0x8f, 0x96, 0xf2, 0x6f, 0xb2, 0x65, 0xa7, 0xfd, 0xfb, 0xae, 0x50,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class GlGetQueryObjectui64vEXT: public Encodable {
    public:
        GlGetQueryObjectui64vEXT(atom::Observations observations, QueryId Query, QueryObjectParameter Parameter, U64__P Value) :
            mobservations(observations),
            mQuery(Query),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x5d, 0x7e, 0xa2, 0xff, 0x4b, 0x0c, 0x64, 0x67, 0xbf, 0x8e, 0xe0, 0x4c, 0x78, 0xd5, 0x6c, 0xb3, 0xf9, 0xc1, 0x47, 0xe5,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryObjectParameter mParameter;
        U64__P mValue;
    };

    class GlGetQueryObjectuiv: public Encodable {
    public:
        GlGetQueryObjectuiv(atom::Observations observations, QueryId Query, QueryObjectParameter Parameter, U32__P Value) :
            mobservations(observations),
            mQuery(Query),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xac, 0x6d, 0xbf, 0x24, 0x6d, 0xf4, 0xd4, 0x03, 0x1b, 0x6f, 0xfe, 0xc4, 0xa0, 0xa7, 0xf7, 0x21, 0xe9, 0x73, 0x96, 0x06,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryObjectParameter mParameter;
        U32__P mValue;
    };

    class GlGetQueryObjectuivEXT: public Encodable {
    public:
        GlGetQueryObjectuivEXT(atom::Observations observations, QueryId Query, QueryObjectParameter Parameter, U32__P Value) :
            mobservations(observations),
            mQuery(Query),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa5, 0xa4, 0x75, 0x56, 0xa4, 0x9f, 0xc4, 0x89, 0xa3, 0xd6, 0x58, 0x74, 0xfc, 0xd1, 0x52, 0xd7, 0xd0, 0x3e, 0x83, 0x66,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryObjectParameter mParameter;
        U32__P mValue;
    };

    class GlGetQueryiv: public Encodable {
    public:
        GlGetQueryiv(atom::Observations observations, QueryTarget Target, QueryParameter Parameter, S32__P Value) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0e, 0x7c, 0xf0, 0x23, 0x65, 0x05, 0x0c, 0x47, 0x0f, 0xb0, 0xa1, 0xb5, 0x1b, 0x6a, 0x28, 0x1e, 0x11, 0x0b, 0x6b, 0xbc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
        QueryParameter mParameter;
        S32__P mValue;
    };

    class GlGetQueryivEXT: public Encodable {
    public:
        GlGetQueryivEXT(atom::Observations observations, QueryTarget Target, QueryParameter Parameter, S32__P Value) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc5, 0x52, 0xdf, 0xab, 0xb0, 0x07, 0x60, 0x2b, 0x5e, 0x73, 0xc6, 0x30, 0x5b, 0xd4, 0xda, 0x9b, 0xf6, 0xb9, 0x5b, 0x8c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        QueryTarget mTarget;
        QueryParameter mParameter;
        S32__P mValue;
    };

    class GlGetRenderbufferParameteriv: public Encodable {
    public:
        GlGetRenderbufferParameteriv(atom::Observations observations, RenderbufferTarget Target, RenderbufferParameter Parameter, S32__P Values) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x87, 0xc3, 0x18, 0x1d, 0xdb, 0x8c, 0x12, 0xc5, 0x99, 0x36, 0x7d, 0x42, 0xcf, 0x94, 0xfe, 0xa9, 0x7b, 0x98, 0xfe, 0xad,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        RenderbufferTarget mTarget;
        RenderbufferParameter mParameter;
        S32__P mValues;
    };

    class GlGetShaderInfoLog: public Encodable {
    public:
        GlGetShaderInfoLog(atom::Observations observations, ShaderId Shader, int32_t BufferLength, S32__P StringLengthWritten, Char__P Info) :
            mobservations(observations),
            mShader(Shader),
            mBufferLength(BufferLength),
            mStringLengthWritten(StringLengthWritten),
            mInfo(Info) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x92, 0xca, 0x29, 0xdb, 0xad, 0x52, 0xb1, 0x8f, 0x63, 0xc1, 0xf8, 0x50, 0x9b, 0xd5, 0x22, 0x71, 0x9f, 0x9c, 0xc3, 0x39,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
            e->Int32(this->mBufferLength);
            e->Value(&this->mStringLengthWritten);
            e->Value(&this->mInfo);
        }

        atom::Observations mobservations;
        ShaderId mShader;
        int32_t mBufferLength;
        S32__P mStringLengthWritten;
        Char__P mInfo;
    };

    class GlGetShaderPrecisionFormat: public Encodable {
    public:
        GlGetShaderPrecisionFormat(atom::Observations observations, ShaderType ShaderType, PrecisionType PrecisionType, S32__P Range, S32__P Precision) :
            mobservations(observations),
            mShaderType(ShaderType),
            mPrecisionType(PrecisionType),
            mRange(Range),
            mPrecision(Precision) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x5c, 0x87, 0x98, 0x4b, 0x36, 0xe8, 0xc8, 0xff, 0x5f, 0x0d, 0x3c, 0xf7, 0xb0, 0xf6, 0x70, 0x01, 0x07, 0x6c, 0xc2, 0x26,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShaderType);
            e->Uint32(this->mPrecisionType);
            e->Value(&this->mRange);
            e->Value(&this->mPrecision);
        }

        atom::Observations mobservations;
        ShaderType mShaderType;
        PrecisionType mPrecisionType;
        S32__P mRange;
        S32__P mPrecision;
    };

    class GlGetShaderSource: public Encodable {
    public:
        GlGetShaderSource(atom::Observations observations, ShaderId Shader, int32_t BufferLength, S32__P StringLengthWritten, Char__P Source) :
            mobservations(observations),
            mShader(Shader),
            mBufferLength(BufferLength),
            mStringLengthWritten(StringLengthWritten),
            mSource(Source) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x40, 0x17, 0xc7, 0x81, 0x4a, 0xc0, 0x92, 0x81, 0x0b, 0xc7, 0x7e, 0x46, 0x29, 0x90, 0x9a, 0x5f, 0xe8, 0xfc, 0x2c, 0xf4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
            e->Int32(this->mBufferLength);
            e->Value(&this->mStringLengthWritten);
            e->Value(&this->mSource);
        }

        atom::Observations mobservations;
        ShaderId mShader;
        int32_t mBufferLength;
        S32__P mStringLengthWritten;
        Char__P mSource;
    };

    class GlGetShaderiv: public Encodable {
    public:
        GlGetShaderiv(atom::Observations observations, ShaderId Shader, ShaderParameter Parameter, S32__P Value) :
            mobservations(observations),
            mShader(Shader),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x39, 0x6e, 0x5d, 0xe0, 0x98, 0x44, 0x05, 0xb2, 0x40, 0xc0, 0xbf, 0x6f, 0xec, 0x6b, 0x96, 0x01, 0x70, 0x0c, 0x3b, 0xe9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
            e->Uint32(this->mParameter);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        ShaderId mShader;
        ShaderParameter mParameter;
        S32__P mValue;
    };

    class GlGetString: public Encodable {
    public:
        GlGetString(atom::Observations observations, StringConstant Param, Char__P Result) :
            mobservations(observations),
            mParam(Param),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x2e, 0xd5, 0x44, 0x37, 0x45, 0x75, 0x0f, 0x8e, 0xd8, 0xf4, 0x41, 0x59, 0x1e, 0xfc, 0x28, 0x21, 0xa8, 0x8d, 0x44, 0x3a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mParam);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        StringConstant mParam;
        Char__P mResult;
    };

    class GlGetTexParameterfv: public Encodable {
    public:
        GlGetTexParameterfv(atom::Observations observations, TextureTarget Target, TextureParameter Parameter, F32__P Values) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x37, 0xaf, 0xce, 0x41, 0x14, 0x36, 0xf7, 0x6d, 0xa1, 0xf0, 0x11, 0xe6, 0x33, 0xc2, 0x40, 0x67, 0x66, 0x36, 0x05, 0x57,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        TextureParameter mParameter;
        F32__P mValues;
    };

    class GlGetTexParameteriv: public Encodable {
    public:
        GlGetTexParameteriv(atom::Observations observations, TextureTarget Target, TextureParameter Parameter, S32__P Values) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc3, 0x09, 0xc1, 0xba, 0x0d, 0x1b, 0xdb, 0xb2, 0x65, 0x4a, 0xbd, 0x90, 0x70, 0x65, 0x79, 0x08, 0x93, 0x8f, 0x33, 0x28,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        TextureParameter mParameter;
        S32__P mValues;
    };

    class GlGetUniformLocation: public Encodable {
    public:
        GlGetUniformLocation(atom::Observations observations, ProgramId Program, char* Name, UniformLocation Result) :
            mobservations(observations),
            mProgram(Program),
            mName(Name),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd9, 0x4d, 0x1e, 0x3c, 0xe5, 0x99, 0xab, 0xf3, 0x3c, 0x4e, 0x27, 0xad, 0xd6, 0xd0, 0x7c, 0x6d, 0xb9, 0x4b, 0x2d, 0xc4,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->String(this->mName);
            e->Int32(this->mResult);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        char* mName;
        UniformLocation mResult;
    };

    class GlGetUniformfv: public Encodable {
    public:
        GlGetUniformfv(atom::Observations observations, ProgramId Program, UniformLocation Location, F32__P Values) :
            mobservations(observations),
            mProgram(Program),
            mLocation(Location),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x95, 0xba, 0xf3, 0xa4, 0xd9, 0x80, 0x7e, 0x97, 0x4b, 0x80, 0xaf, 0x3d, 0x8a, 0xec, 0x09, 0x2a, 0x3e, 0xf7, 0xc5, 0xd6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mLocation);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        UniformLocation mLocation;
        F32__P mValues;
    };

    class GlGetUniformiv: public Encodable {
    public:
        GlGetUniformiv(atom::Observations observations, ProgramId Program, UniformLocation Location, S32__P Values) :
            mobservations(observations),
            mProgram(Program),
            mLocation(Location),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc8, 0x25, 0x82, 0x99, 0x0a, 0x7f, 0x6c, 0x55, 0x72, 0xd0, 0x79, 0xf9, 0xf7, 0xf3, 0x84, 0xb8, 0xdf, 0x96, 0x8f, 0xef,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Int32(this->mLocation);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        UniformLocation mLocation;
        S32__P mValues;
    };

    class GlHint: public Encodable {
    public:
        GlHint(atom::Observations observations, HintTarget Target, HintMode Mode) :
            mobservations(observations),
            mTarget(Target),
            mMode(Mode) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x48, 0xaf, 0x97, 0x70, 0xba, 0x4b, 0xbd, 0x3a, 0x72, 0xc8, 0xd6, 0x25, 0x05, 0x00, 0x7e, 0x86, 0x38, 0x90, 0xd7, 0xff,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mMode);
        }

        atom::Observations mobservations;
        HintTarget mTarget;
        HintMode mMode;
    };

    class GlInsertEventMarkerEXT: public Encodable {
    public:
        GlInsertEventMarkerEXT(atom::Observations observations, int32_t Length, char* Marker) :
            mobservations(observations),
            mLength(Length),
            mMarker(Marker) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe0, 0x62, 0x82, 0xd3, 0x0a, 0x0c, 0xae, 0xde, 0xf3, 0xac, 0xe6, 0xa9, 0x5f, 0xb5, 0xc7, 0x8b, 0x2c, 0xe1, 0x99, 0xea,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLength);
            e->String(this->mMarker);
        }

        atom::Observations mobservations;
        int32_t mLength;
        char* mMarker;
    };

    class GlInvalidateFramebuffer: public Encodable {
    public:
        GlInvalidateFramebuffer(atom::Observations observations, FramebufferTarget Target, int32_t Count, FramebufferAttachment__P Attachments) :
            mobservations(observations),
            mTarget(Target),
            mCount(Count),
            mAttachments(Attachments) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb4, 0x9d, 0xbf, 0x94, 0x4c, 0x3e, 0x3a, 0xf1, 0xfa, 0xbb, 0xed, 0x74, 0xa3, 0x70, 0x2c, 0xfa, 0x16, 0xaa, 0xa7, 0x20,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mCount);
            e->Value(&this->mAttachments);
        }

        atom::Observations mobservations;
        FramebufferTarget mTarget;
        int32_t mCount;
        FramebufferAttachment__P mAttachments;
    };

    class GlIsBuffer: public Encodable {
    public:
        GlIsBuffer(atom::Observations observations, BufferId Buffer, bool Result) :
            mobservations(observations),
            mBuffer(Buffer),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x25, 0xf9, 0x53, 0xf4, 0x60, 0x55, 0xc5, 0xfe, 0x8a, 0x0f, 0xd4, 0x1a, 0x88, 0xe7, 0xf4, 0x4c, 0xcc, 0x81, 0x3b, 0xb7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mBuffer);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        BufferId mBuffer;
        bool mResult;
    };

    class GlIsEnabled: public Encodable {
    public:
        GlIsEnabled(atom::Observations observations, Capability Capability, bool Result) :
            mobservations(observations),
            mCapability(Capability),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x49, 0x3f, 0xc2, 0x32, 0x2c, 0x37, 0x0c, 0x4c, 0xe9, 0x45, 0x95, 0x51, 0x1c, 0x46, 0x31, 0x20, 0x8d, 0xc2, 0xb6, 0x15,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mCapability);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        Capability mCapability;
        bool mResult;
    };

    class GlIsFramebuffer: public Encodable {
    public:
        GlIsFramebuffer(atom::Observations observations, FramebufferId Framebuffer, bool Result) :
            mobservations(observations),
            mFramebuffer(Framebuffer),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0b, 0xdd, 0x4e, 0xe8, 0x9f, 0x9d, 0xcc, 0xd2, 0xea, 0x1a, 0xa6, 0xc5, 0xef, 0x65, 0x2e, 0x02, 0x80, 0xe0, 0xc4, 0x63,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFramebuffer);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        FramebufferId mFramebuffer;
        bool mResult;
    };

    class GlIsProgram: public Encodable {
    public:
        GlIsProgram(atom::Observations observations, ProgramId Program, bool Result) :
            mobservations(observations),
            mProgram(Program),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x62, 0xbd, 0xde, 0xd6, 0x51, 0x60, 0x50, 0x3e, 0x3d, 0x54, 0x0a, 0xec, 0xb2, 0xcd, 0xf5, 0x54, 0xfb, 0x79, 0x3c, 0xdd,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        bool mResult;
    };

    class GlIsQuery: public Encodable {
    public:
        GlIsQuery(atom::Observations observations, QueryId Query, bool Result) :
            mobservations(observations),
            mQuery(Query),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x3b, 0x6f, 0x09, 0x4b, 0x89, 0xdc, 0x6b, 0x2f, 0x74, 0xd6, 0x51, 0x3b, 0x3f, 0xfe, 0x6d, 0x60, 0x72, 0x60, 0x61, 0xe2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        bool mResult;
    };

    class GlIsQueryEXT: public Encodable {
    public:
        GlIsQueryEXT(atom::Observations observations, QueryId Query, bool Result) :
            mobservations(observations),
            mQuery(Query),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb1, 0x6a, 0x0d, 0xdf, 0xb6, 0xea, 0x3d, 0x84, 0xd0, 0x8c, 0x22, 0xf5, 0xf9, 0x82, 0x88, 0xa5, 0x3e, 0xdd, 0x56, 0xea,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        bool mResult;
    };

    class GlIsRenderbuffer: public Encodable {
    public:
        GlIsRenderbuffer(atom::Observations observations, RenderbufferId Renderbuffer, bool Result) :
            mobservations(observations),
            mRenderbuffer(Renderbuffer),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xee, 0xfa, 0xeb, 0x17, 0x01, 0xe1, 0xe4, 0xc6, 0x90, 0x90, 0x9c, 0xfa, 0x28, 0x24, 0xad, 0x33, 0xc5, 0xef, 0x2f, 0xe6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mRenderbuffer);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        RenderbufferId mRenderbuffer;
        bool mResult;
    };

    class GlIsShader: public Encodable {
    public:
        GlIsShader(atom::Observations observations, ShaderId Shader, bool Result) :
            mobservations(observations),
            mShader(Shader),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb5, 0x7a, 0x83, 0x39, 0x62, 0xa0, 0x1c, 0x3d, 0x08, 0x84, 0x29, 0xda, 0x1a, 0x6a, 0xe2, 0xd6, 0x24, 0x88, 0x4e, 0xe2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        ShaderId mShader;
        bool mResult;
    };

    class GlIsTexture: public Encodable {
    public:
        GlIsTexture(atom::Observations observations, TextureId Texture, bool Result) :
            mobservations(observations),
            mTexture(Texture),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xae, 0x84, 0x50, 0xca, 0xe6, 0x83, 0x45, 0x6c, 0x68, 0x8d, 0x96, 0xf2, 0xb2, 0x0f, 0x9c, 0x01, 0x78, 0x1c, 0x12, 0xdd,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTexture);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        TextureId mTexture;
        bool mResult;
    };

    class GlIsVertexArrayOES: public Encodable {
    public:
        GlIsVertexArrayOES(atom::Observations observations, VertexArrayId Array, bool Result) :
            mobservations(observations),
            mArray(Array),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xab, 0xa3, 0xb5, 0xac, 0x9c, 0x32, 0x14, 0xdb, 0x82, 0x00, 0xa7, 0xbd, 0xe0, 0xb2, 0x40, 0x64, 0xac, 0x30, 0xb8, 0xc7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mArray);
            e->Bool(this->mResult);
        }

        atom::Observations mobservations;
        VertexArrayId mArray;
        bool mResult;
    };

    class GlLineWidth: public Encodable {
    public:
        GlLineWidth(atom::Observations observations, float Width) :
            mobservations(observations),
            mWidth(Width) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x52, 0x6f, 0x5c, 0x5b, 0xcb, 0xf6, 0xfb, 0xfb, 0x29, 0x3d, 0x64, 0x86, 0x07, 0x05, 0x67, 0x26, 0xba, 0x3c, 0xb8, 0xfb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mWidth);
        }

        atom::Observations mobservations;
        float mWidth;
    };

    class GlLinkProgram: public Encodable {
    public:
        GlLinkProgram(atom::Observations observations, ProgramId Program) :
            mobservations(observations),
            mProgram(Program) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x17, 0xf0, 0x30, 0xba, 0x15, 0x5a, 0xf7, 0x20, 0x04, 0x04, 0xea, 0xd7, 0xc3, 0xba, 0x6a, 0x4c, 0x9e, 0x0d, 0x96, 0x41,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
    };

    class GlMapBufferRange: public Encodable {
    public:
        GlMapBufferRange(atom::Observations observations, BufferTarget Target, int32_t Offset, int32_t Length, MapBufferRangeAccess Access, Void__P Result) :
            mobservations(observations),
            mTarget(Target),
            mOffset(Offset),
            mLength(Length),
            mAccess(Access),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc0, 0x75, 0x4f, 0x53, 0xa9, 0x4a, 0x24, 0x26, 0x84, 0x2f, 0xfb, 0xf0, 0x64, 0xd3, 0xae, 0xb9, 0x5b, 0xe4, 0xc7, 0xd5,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mOffset);
            e->Int32(this->mLength);
            e->Uint32(this->mAccess);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
        int32_t mOffset;
        int32_t mLength;
        MapBufferRangeAccess mAccess;
        Void__P mResult;
    };

    class GlPixelStorei: public Encodable {
    public:
        GlPixelStorei(atom::Observations observations, PixelStoreParameter Parameter, int32_t Value) :
            mobservations(observations),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdd, 0x40, 0xad, 0x0f, 0xff, 0xb4, 0xf6, 0x1b, 0xef, 0xcf, 0xc3, 0x98, 0x37, 0xed, 0x0f, 0x55, 0x4b, 0x8b, 0x1d, 0x0d,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mParameter);
            e->Int32(this->mValue);
        }

        atom::Observations mobservations;
        PixelStoreParameter mParameter;
        int32_t mValue;
    };

    class GlPolygonOffset: public Encodable {
    public:
        GlPolygonOffset(atom::Observations observations, float ScaleFactor, float Units) :
            mobservations(observations),
            mScaleFactor(ScaleFactor),
            mUnits(Units) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb8, 0xb4, 0x99, 0x5e, 0x5c, 0x92, 0xdf, 0xc5, 0xce, 0xbc, 0x85, 0xd0, 0xad, 0x3e, 0xba, 0x10, 0x0b, 0x50, 0x20, 0x23,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mScaleFactor);
            e->Float32(this->mUnits);
        }

        atom::Observations mobservations;
        float mScaleFactor;
        float mUnits;
    };

    class GlPopGroupMarkerEXT: public Encodable {
    public:
        GlPopGroupMarkerEXT(atom::Observations observations) :
            mobservations(observations) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x63, 0xb8, 0xb9, 0x5e, 0x5d, 0xf9, 0x13, 0xbb, 0xc7, 0xce, 0x02, 0x0f, 0xc7, 0x14, 0x03, 0x22, 0xe5, 0x70, 0x9f, 0x87,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
        }

        atom::Observations mobservations;
    };

    class GlProgramBinaryOES: public Encodable {
    public:
        GlProgramBinaryOES(atom::Observations observations, ProgramId Program, uint32_t BinaryFormat, Void__P Binary, int32_t BinarySize) :
            mobservations(observations),
            mProgram(Program),
            mBinaryFormat(BinaryFormat),
            mBinary(Binary),
            mBinarySize(BinarySize) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc6, 0x5f, 0x91, 0x9e, 0x1e, 0xfe, 0x8c, 0xfb, 0xdd, 0x3c, 0x9b, 0x02, 0xc6, 0x13, 0xab, 0x58, 0x36, 0xa0, 0xe3, 0x30,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
            e->Uint32(this->mBinaryFormat);
            e->Value(&this->mBinary);
            e->Int32(this->mBinarySize);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
        uint32_t mBinaryFormat;
        Void__P mBinary;
        int32_t mBinarySize;
    };

    class GlPushGroupMarkerEXT: public Encodable {
    public:
        GlPushGroupMarkerEXT(atom::Observations observations, int32_t Length, char* Marker) :
            mobservations(observations),
            mLength(Length),
            mMarker(Marker) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x02, 0x2e, 0x06, 0x0f, 0xcb, 0x78, 0xe3, 0x76, 0x55, 0x1d, 0x6b, 0x9f, 0x57, 0xd2, 0x40, 0x46, 0x1a, 0x0a, 0x70, 0x02,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLength);
            e->String(this->mMarker);
        }

        atom::Observations mobservations;
        int32_t mLength;
        char* mMarker;
    };

    class GlQueryCounterEXT: public Encodable {
    public:
        GlQueryCounterEXT(atom::Observations observations, QueryId Query, QueryTarget Target) :
            mobservations(observations),
            mQuery(Query),
            mTarget(Target) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x24, 0xfc, 0x89, 0xbe, 0x08, 0x35, 0xd1, 0xd7, 0x0f, 0xc7, 0xe4, 0x39, 0x79, 0xb1, 0x22, 0x49, 0x57, 0x58, 0x6e, 0x2b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mQuery);
            e->Uint32(this->mTarget);
        }

        atom::Observations mobservations;
        QueryId mQuery;
        QueryTarget mTarget;
    };

    class GlReadPixels: public Encodable {
    public:
        GlReadPixels(atom::Observations observations, int32_t X, int32_t Y, int32_t Width, int32_t Height, BaseTexelFormat Format, TexelType Type, Void__P Data) :
            mobservations(observations),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height),
            mFormat(Format),
            mType(Type),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbe, 0x23, 0x91, 0x78, 0x3a, 0xe3, 0xb5, 0x9c, 0xe3, 0x88, 0x3a, 0x59, 0xe5, 0x90, 0x43, 0xb3, 0x79, 0x6b, 0xc3, 0x86,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Uint32(this->mFormat);
            e->Uint32(this->mType);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
        BaseTexelFormat mFormat;
        TexelType mType;
        Void__P mData;
    };

    class GlReleaseShaderCompiler: public Encodable {
    public:
        GlReleaseShaderCompiler(atom::Observations observations) :
            mobservations(observations) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x75, 0x57, 0x32, 0x6e, 0x7b, 0x73, 0x9d, 0x61, 0x34, 0xf4, 0xfe, 0x45, 0xb6, 0xb2, 0x1d, 0x6e, 0xd0, 0xab, 0xbb, 0x78,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
        }

        atom::Observations mobservations;
    };

    class GlRenderbufferStorage: public Encodable {
    public:
        GlRenderbufferStorage(atom::Observations observations, RenderbufferTarget Target, RenderbufferFormat Format, int32_t Width, int32_t Height) :
            mobservations(observations),
            mTarget(Target),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb6, 0x7f, 0xe4, 0x65, 0x99, 0x3d, 0xe3, 0x4d, 0x4a, 0x0b, 0x1e, 0x5e, 0x14, 0x7c, 0xb4, 0x0e, 0x0b, 0xa7, 0x49, 0x22,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        RenderbufferTarget mTarget;
        RenderbufferFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlRenderbufferStorageMultisample: public Encodable {
    public:
        GlRenderbufferStorageMultisample(atom::Observations observations, RenderbufferTarget Target, int32_t Samples, RenderbufferFormat Format, int32_t Width, int32_t Height) :
            mobservations(observations),
            mTarget(Target),
            mSamples(Samples),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x77, 0x47, 0x04, 0xde, 0x5b, 0x64, 0x6b, 0x24, 0x7e, 0x3e, 0x58, 0x82, 0xdf, 0x38, 0x3e, 0xb8, 0xf2, 0x27, 0x15, 0x79,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mSamples);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        RenderbufferTarget mTarget;
        int32_t mSamples;
        RenderbufferFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlSampleCoverage: public Encodable {
    public:
        GlSampleCoverage(atom::Observations observations, float Value, bool Invert) :
            mobservations(observations),
            mValue(Value),
            mInvert(Invert) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdb, 0x2a, 0x80, 0xc6, 0x8a, 0x74, 0x81, 0x89, 0x6f, 0x52, 0x38, 0xf2, 0x8a, 0x46, 0x7b, 0xf1, 0x67, 0xe3, 0x07, 0x42,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Float32(this->mValue);
            e->Bool(this->mInvert);
        }

        atom::Observations mobservations;
        float mValue;
        bool mInvert;
    };

    class GlScissor: public Encodable {
    public:
        GlScissor(atom::Observations observations, int32_t X, int32_t Y, int32_t Width, int32_t Height) :
            mobservations(observations),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa5, 0x41, 0xe6, 0x77, 0xf6, 0x30, 0x6c, 0xdc, 0x47, 0x80, 0x42, 0x8d, 0xb6, 0x13, 0x10, 0x30, 0x25, 0xfc, 0xb6, 0xca,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlShaderBinary: public Encodable {
    public:
        GlShaderBinary(atom::Observations observations, int32_t Count, ShaderId__P Shaders, uint32_t BinaryFormat, Void__P Binary, int32_t BinarySize) :
            mobservations(observations),
            mCount(Count),
            mShaders(Shaders),
            mBinaryFormat(BinaryFormat),
            mBinary(Binary),
            mBinarySize(BinarySize) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x86, 0xb4, 0x9f, 0x81, 0x21, 0x9f, 0x2f, 0xdf, 0xf5, 0x5c, 0x14, 0x20, 0xac, 0x1b, 0x9d, 0xf1, 0xcb, 0x28, 0x62, 0x43,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mCount);
            e->Value(&this->mShaders);
            e->Uint32(this->mBinaryFormat);
            e->Value(&this->mBinary);
            e->Int32(this->mBinarySize);
        }

        atom::Observations mobservations;
        int32_t mCount;
        ShaderId__P mShaders;
        uint32_t mBinaryFormat;
        Void__P mBinary;
        int32_t mBinarySize;
    };

    class GlShaderSource: public Encodable {
    public:
        GlShaderSource(atom::Observations observations, ShaderId Shader, int32_t Count, Char__P__P Source, S32__P Length) :
            mobservations(observations),
            mShader(Shader),
            mCount(Count),
            mSource(Source),
            mLength(Length) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x07, 0x7d, 0xaf, 0xb9, 0xc9, 0xac, 0x7e, 0xab, 0xc5, 0x97, 0xf6, 0x8e, 0xcc, 0xda, 0x9d, 0x10, 0x1e, 0x4e, 0x81, 0x4b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mShader);
            e->Int32(this->mCount);
            e->Value(&this->mSource);
            e->Value(&this->mLength);
        }

        atom::Observations mobservations;
        ShaderId mShader;
        int32_t mCount;
        Char__P__P mSource;
        S32__P mLength;
    };

    class GlStartTilingQCOM: public Encodable {
    public:
        GlStartTilingQCOM(atom::Observations observations, int32_t X, int32_t Y, int32_t Width, int32_t Height, TilePreserveMaskQCOM PreserveMask) :
            mobservations(observations),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height),
            mPreserveMask(PreserveMask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x87, 0x76, 0x34, 0xf8, 0x30, 0x7e, 0xb3, 0x9e, 0x0f, 0xed, 0x9e, 0xa4, 0xe4, 0x73, 0x88, 0xbc, 0xa4, 0xed, 0x69, 0x7e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Uint32(this->mPreserveMask);
        }

        atom::Observations mobservations;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
        TilePreserveMaskQCOM mPreserveMask;
    };

    class GlStencilFuncSeparate: public Encodable {
    public:
        GlStencilFuncSeparate(atom::Observations observations, FaceMode Face, TestFunction Function, int32_t ReferenceValue, int32_t Mask) :
            mobservations(observations),
            mFace(Face),
            mFunction(Function),
            mReferenceValue(ReferenceValue),
            mMask(Mask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x83, 0x37, 0xed, 0xe5, 0xee, 0x51, 0x7b, 0x34, 0x8c, 0xbc, 0x87, 0x0e, 0xa5, 0x6b, 0xfd, 0xfd, 0x06, 0x35, 0x65, 0xfa,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFace);
            e->Uint32(this->mFunction);
            e->Int32(this->mReferenceValue);
            e->Int32(this->mMask);
        }

        atom::Observations mobservations;
        FaceMode mFace;
        TestFunction mFunction;
        int32_t mReferenceValue;
        int32_t mMask;
    };

    class GlStencilMask: public Encodable {
    public:
        GlStencilMask(atom::Observations observations, uint32_t Mask) :
            mobservations(observations),
            mMask(Mask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x73, 0x1d, 0xc0, 0x01, 0xcf, 0xbe, 0x91, 0x96, 0x36, 0xf2, 0x73, 0xa4, 0xb4, 0x9d, 0xd7, 0xf3, 0x5e, 0xd8, 0x74, 0x37,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mMask);
        }

        atom::Observations mobservations;
        uint32_t mMask;
    };

    class GlStencilMaskSeparate: public Encodable {
    public:
        GlStencilMaskSeparate(atom::Observations observations, FaceMode Face, uint32_t Mask) :
            mobservations(observations),
            mFace(Face),
            mMask(Mask) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb7, 0xe8, 0x35, 0x90, 0xf1, 0x79, 0xd9, 0x29, 0xbe, 0xab, 0xf1, 0x2d, 0x31, 0x2e, 0xb8, 0xa4, 0x67, 0x91, 0xa8, 0x0c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFace);
            e->Uint32(this->mMask);
        }

        atom::Observations mobservations;
        FaceMode mFace;
        uint32_t mMask;
    };

    class GlStencilOpSeparate: public Encodable {
    public:
        GlStencilOpSeparate(atom::Observations observations, FaceMode Face, StencilAction StencilFail, StencilAction StencilPassDepthFail, StencilAction StencilPassDepthPass) :
            mobservations(observations),
            mFace(Face),
            mStencilFail(StencilFail),
            mStencilPassDepthFail(StencilPassDepthFail),
            mStencilPassDepthPass(StencilPassDepthPass) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x9d, 0xe2, 0xc4, 0xb4, 0x72, 0x55, 0x3d, 0x06, 0xcd, 0xe7, 0x6d, 0x3c, 0xbc, 0xa6, 0x5b, 0xc1, 0xff, 0x09, 0xec, 0x00,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mFace);
            e->Uint32(this->mStencilFail);
            e->Uint32(this->mStencilPassDepthFail);
            e->Uint32(this->mStencilPassDepthPass);
        }

        atom::Observations mobservations;
        FaceMode mFace;
        StencilAction mStencilFail;
        StencilAction mStencilPassDepthFail;
        StencilAction mStencilPassDepthPass;
    };

    class GlTexImage2D: public Encodable {
    public:
        GlTexImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, TexelFormat InternalFormat, int32_t Width, int32_t Height, int32_t Border, TexelFormat Format, TexelType Type, TexturePointer Data) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mInternalFormat(InternalFormat),
            mWidth(Width),
            mHeight(Height),
            mBorder(Border),
            mFormat(Format),
            mType(Type),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x75, 0x47, 0xbd, 0xaa, 0x7a, 0xe5, 0xc5, 0x97, 0x9f, 0xe3, 0x56, 0xd0, 0xdc, 0x77, 0xa2, 0x3a, 0xb1, 0xfa, 0x3d, 0x18,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Uint32(this->mInternalFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Int32(this->mBorder);
            e->Uint32(this->mFormat);
            e->Uint32(this->mType);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        TexelFormat mInternalFormat;
        int32_t mWidth;
        int32_t mHeight;
        int32_t mBorder;
        TexelFormat mFormat;
        TexelType mType;
        TexturePointer mData;
    };

    class GlTexParameterf: public Encodable {
    public:
        GlTexParameterf(atom::Observations observations, TextureTarget Target, TextureParameter Parameter, float Value) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x71, 0x53, 0x54, 0x52, 0xd4, 0xc1, 0x72, 0x77, 0x6e, 0xaa, 0xb4, 0x93, 0xea, 0xb2, 0x95, 0xf2, 0x01, 0xbe, 0xae, 0x06,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Float32(this->mValue);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        TextureParameter mParameter;
        float mValue;
    };

    class GlTexParameteri: public Encodable {
    public:
        GlTexParameteri(atom::Observations observations, TextureTarget Target, TextureParameter Parameter, int32_t Value) :
            mobservations(observations),
            mTarget(Target),
            mParameter(Parameter),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd9, 0xec, 0x83, 0xf4, 0x8a, 0xf8, 0x43, 0xc3, 0xde, 0x41, 0xee, 0xfb, 0x9a, 0x3d, 0xaf, 0xfc, 0xb1, 0xd4, 0xe5, 0xbe,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Uint32(this->mParameter);
            e->Int32(this->mValue);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        TextureParameter mParameter;
        int32_t mValue;
    };

    class GlTexStorage1DEXT: public Encodable {
    public:
        GlTexStorage1DEXT(atom::Observations observations, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width) :
            mobservations(observations),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x82, 0xe5, 0xba, 0x13, 0x88, 0xf4, 0xc5, 0xdf, 0x67, 0xb6, 0x1f, 0x1c, 0xab, 0x00, 0x8c, 0x18, 0x03, 0x2d, 0x9c, 0x94,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
    };

    class GlTexStorage2DEXT: public Encodable {
    public:
        GlTexStorage2DEXT(atom::Observations observations, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width, int32_t Height) :
            mobservations(observations),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x22, 0x01, 0xae, 0xf0, 0xdf, 0xef, 0xe7, 0xc1, 0xb8, 0xf9, 0x1a, 0xf1, 0x20, 0xff, 0xbf, 0x8f, 0x28, 0x40, 0x8d, 0xc6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlTexStorage3DEXT: public Encodable {
    public:
        GlTexStorage3DEXT(atom::Observations observations, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width, int32_t Height, int32_t Depth) :
            mobservations(observations),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height),
            mDepth(Depth) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8f, 0xe9, 0x78, 0x84, 0x96, 0x0a, 0x60, 0xdf, 0xf8, 0x7a, 0xc4, 0xe8, 0xf7, 0x93, 0x27, 0xfd, 0x65, 0xed, 0xde, 0xaa,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Int32(this->mDepth);
        }

        atom::Observations mobservations;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
        int32_t mDepth;
    };

    class GlTexSubImage2D: public Encodable {
    public:
        GlTexSubImage2D(atom::Observations observations, TextureImageTarget Target, int32_t Level, int32_t Xoffset, int32_t Yoffset, int32_t Width, int32_t Height, TexelFormat Format, TexelType Type, TexturePointer Data) :
            mobservations(observations),
            mTarget(Target),
            mLevel(Level),
            mXoffset(Xoffset),
            mYoffset(Yoffset),
            mWidth(Width),
            mHeight(Height),
            mFormat(Format),
            mType(Type),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8e, 0xb2, 0x9e, 0x94, 0xf9, 0xe8, 0xd4, 0xa9, 0x27, 0xf1, 0xe4, 0xa9, 0xa1, 0x25, 0x5a, 0x2b, 0xf8, 0x8a, 0x61, 0x2b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevel);
            e->Int32(this->mXoffset);
            e->Int32(this->mYoffset);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Uint32(this->mFormat);
            e->Uint32(this->mType);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        TextureImageTarget mTarget;
        int32_t mLevel;
        int32_t mXoffset;
        int32_t mYoffset;
        int32_t mWidth;
        int32_t mHeight;
        TexelFormat mFormat;
        TexelType mType;
        TexturePointer mData;
    };

    class GlTextureStorage1DEXT: public Encodable {
    public:
        GlTextureStorage1DEXT(atom::Observations observations, TextureId Texture, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width) :
            mobservations(observations),
            mTexture(Texture),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0a, 0x69, 0xa0, 0xa4, 0xc1, 0xa6, 0x81, 0xd8, 0x94, 0xe3, 0x54, 0xe1, 0xa1, 0xa7, 0x53, 0xc0, 0x6a, 0x55, 0x7e, 0xfb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTexture);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
        }

        atom::Observations mobservations;
        TextureId mTexture;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
    };

    class GlTextureStorage2DEXT: public Encodable {
    public:
        GlTextureStorage2DEXT(atom::Observations observations, TextureId Texture, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width, int32_t Height) :
            mobservations(observations),
            mTexture(Texture),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xaa, 0x63, 0x10, 0x72, 0xaf, 0x48, 0x52, 0xce, 0x02, 0x08, 0x02, 0xac, 0xf5, 0xf9, 0xb8, 0x03, 0x87, 0x02, 0xcc, 0x3a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTexture);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        TextureId mTexture;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlTextureStorage3DEXT: public Encodable {
    public:
        GlTextureStorage3DEXT(atom::Observations observations, TextureId Texture, TextureTarget Target, int32_t Levels, TexelFormat Format, int32_t Width, int32_t Height, int32_t Depth) :
            mobservations(observations),
            mTexture(Texture),
            mTarget(Target),
            mLevels(Levels),
            mFormat(Format),
            mWidth(Width),
            mHeight(Height),
            mDepth(Depth) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc3, 0x4b, 0xb7, 0x25, 0xcd, 0x73, 0x0d, 0x77, 0x57, 0x84, 0xb6, 0xc0, 0x9c, 0x0f, 0x3e, 0xaf, 0x93, 0xd7, 0xc0, 0xe6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTexture);
            e->Uint32(this->mTarget);
            e->Int32(this->mLevels);
            e->Uint32(this->mFormat);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
            e->Int32(this->mDepth);
        }

        atom::Observations mobservations;
        TextureId mTexture;
        TextureTarget mTarget;
        int32_t mLevels;
        TexelFormat mFormat;
        int32_t mWidth;
        int32_t mHeight;
        int32_t mDepth;
    };

    class GlUniform1f: public Encodable {
    public:
        GlUniform1f(atom::Observations observations, UniformLocation Location, float Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdc, 0x09, 0x5b, 0x59, 0xd2, 0xff, 0x8d, 0xd9, 0xab, 0xf7, 0x80, 0xbb, 0xc4, 0x33, 0xf6, 0x28, 0xf3, 0x93, 0x52, 0x4e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Float32(this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        float mValue;
    };

    class GlUniform1fv: public Encodable {
    public:
        GlUniform1fv(atom::Observations observations, UniformLocation Location, int32_t Count, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6c, 0x24, 0x91, 0x06, 0x3a, 0x75, 0x28, 0xf4, 0xef, 0x98, 0xed, 0xf2, 0x17, 0x37, 0x85, 0xa4, 0xcc, 0x91, 0x2a, 0xc7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        F32__P mValue;
    };

    class GlUniform1i: public Encodable {
    public:
        GlUniform1i(atom::Observations observations, UniformLocation Location, int32_t Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdc, 0xc5, 0xf9, 0x9f, 0xe8, 0xdf, 0x34, 0x63, 0x92, 0x71, 0x0c, 0xc1, 0xb5, 0xa9, 0xed, 0xa0, 0xfb, 0x74, 0x32, 0xd9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mValue;
    };

    class GlUniform1iv: public Encodable {
    public:
        GlUniform1iv(atom::Observations observations, UniformLocation Location, int32_t Count, S32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa4, 0x66, 0xca, 0x9b, 0x82, 0xb9, 0x81, 0x2f, 0xe3, 0x70, 0xa5, 0xf4, 0x7b, 0x3b, 0xc4, 0x40, 0x12, 0xd2, 0x75, 0xba,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        S32__P mValue;
    };

    class GlUniform2f: public Encodable {
    public:
        GlUniform2f(atom::Observations observations, UniformLocation Location, float Value0, float Value1) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xfe, 0xb0, 0x7e, 0x45, 0x14, 0x3c, 0xc4, 0xd6, 0x30, 0x6e, 0xae, 0x61, 0x65, 0x50, 0x23, 0x75, 0xa8, 0x21, 0x3e, 0x79,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        float mValue0;
        float mValue1;
    };

    class GlUniform2fv: public Encodable {
    public:
        GlUniform2fv(atom::Observations observations, UniformLocation Location, int32_t Count, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe5, 0x71, 0x7a, 0x00, 0x7e, 0xcc, 0x57, 0x43, 0xc2, 0x55, 0x11, 0x21, 0x30, 0xeb, 0x7b, 0x53, 0xeb, 0x16, 0x19, 0xd6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        F32__P mValue;
    };

    class GlUniform2i: public Encodable {
    public:
        GlUniform2i(atom::Observations observations, UniformLocation Location, int32_t Value0, int32_t Value1) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4c, 0x11, 0x73, 0xaa, 0xef, 0x59, 0xde, 0x41, 0x09, 0x12, 0xd7, 0x30, 0x31, 0x24, 0x6f, 0x29, 0x57, 0x6f, 0x90, 0x65,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mValue0);
            e->Int32(this->mValue1);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mValue0;
        int32_t mValue1;
    };

    class GlUniform2iv: public Encodable {
    public:
        GlUniform2iv(atom::Observations observations, UniformLocation Location, int32_t Count, S32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x73, 0xaa, 0xfe, 0x04, 0x12, 0x5c, 0xa9, 0x23, 0x5a, 0x84, 0x12, 0x0c, 0x33, 0xdd, 0x7c, 0xe8, 0x34, 0x0e, 0xbe, 0xb8,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        S32__P mValue;
    };

    class GlUniform3f: public Encodable {
    public:
        GlUniform3f(atom::Observations observations, UniformLocation Location, float Value0, float Value1, float Value2) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x15, 0xd9, 0x47, 0x62, 0x1f, 0xf4, 0x8a, 0x57, 0x8d, 0x50, 0x0d, 0xc7, 0x32, 0xda, 0x19, 0x25, 0xe9, 0x27, 0xca, 0x7b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
            e->Float32(this->mValue2);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        float mValue0;
        float mValue1;
        float mValue2;
    };

    class GlUniform3fv: public Encodable {
    public:
        GlUniform3fv(atom::Observations observations, UniformLocation Location, int32_t Count, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf5, 0x0d, 0x86, 0x4d, 0xe7, 0x26, 0x8b, 0xb8, 0xc3, 0xcc, 0x16, 0x99, 0xbd, 0x43, 0x2c, 0x3d, 0x1a, 0x3b, 0xfa, 0x4a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        F32__P mValue;
    };

    class GlUniform3i: public Encodable {
    public:
        GlUniform3i(atom::Observations observations, UniformLocation Location, int32_t Value0, int32_t Value1, int32_t Value2) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd2, 0x99, 0x76, 0x0a, 0x2c, 0xb1, 0x75, 0xac, 0x1b, 0xd1, 0x5d, 0xa4, 0x56, 0x1b, 0x90, 0xce, 0x23, 0xf1, 0x4f, 0x65,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mValue0);
            e->Int32(this->mValue1);
            e->Int32(this->mValue2);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mValue0;
        int32_t mValue1;
        int32_t mValue2;
    };

    class GlUniform3iv: public Encodable {
    public:
        GlUniform3iv(atom::Observations observations, UniformLocation Location, int32_t Count, S32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x09, 0x38, 0xc6, 0xb0, 0x6a, 0x6a, 0xd1, 0xa2, 0x4f, 0xf5, 0x5c, 0x81, 0xab, 0xf1, 0xc6, 0x75, 0xe9, 0x70, 0x23, 0xa9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        S32__P mValue;
    };

    class GlUniform4f: public Encodable {
    public:
        GlUniform4f(atom::Observations observations, UniformLocation Location, float Value0, float Value1, float Value2, float Value3) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2),
            mValue3(Value3) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x07, 0x94, 0x2a, 0xa5, 0x8e, 0xd5, 0x4b, 0x3f, 0x2b, 0xe3, 0x52, 0xb1, 0x7c, 0x18, 0x9e, 0x23, 0xb1, 0xdb, 0x6f, 0x84,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
            e->Float32(this->mValue2);
            e->Float32(this->mValue3);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        float mValue0;
        float mValue1;
        float mValue2;
        float mValue3;
    };

    class GlUniform4fv: public Encodable {
    public:
        GlUniform4fv(atom::Observations observations, UniformLocation Location, int32_t Count, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x99, 0x5e, 0x7c, 0xb3, 0xe9, 0xc3, 0x3b, 0x80, 0x13, 0x0a, 0xb9, 0x71, 0x56, 0x25, 0x5c, 0x5f, 0xac, 0x3a, 0xbf, 0x26,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        F32__P mValue;
    };

    class GlUniform4i: public Encodable {
    public:
        GlUniform4i(atom::Observations observations, UniformLocation Location, int32_t Value0, int32_t Value1, int32_t Value2, int32_t Value3) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2),
            mValue3(Value3) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe2, 0x70, 0x4f, 0xe8, 0xf2, 0xdd, 0xbc, 0xba, 0x90, 0xde, 0x98, 0x18, 0x14, 0x07, 0x29, 0x53, 0xad, 0x3e, 0x18, 0x74,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mValue0);
            e->Int32(this->mValue1);
            e->Int32(this->mValue2);
            e->Int32(this->mValue3);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mValue0;
        int32_t mValue1;
        int32_t mValue2;
        int32_t mValue3;
    };

    class GlUniform4iv: public Encodable {
    public:
        GlUniform4iv(atom::Observations observations, UniformLocation Location, int32_t Count, S32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7a, 0x46, 0x92, 0x39, 0x56, 0x96, 0x2c, 0x53, 0x0f, 0x88, 0xa5, 0x8f, 0x95, 0xbf, 0xc5, 0x5b, 0xb4, 0xfe, 0xee, 0x2f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        S32__P mValue;
    };

    class GlUniformMatrix2fv: public Encodable {
    public:
        GlUniformMatrix2fv(atom::Observations observations, UniformLocation Location, int32_t Count, bool Transpose, F32__P Values) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mTranspose(Transpose),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x92, 0x32, 0x5c, 0x87, 0x66, 0x8a, 0x8e, 0x3e, 0xc5, 0x07, 0x28, 0xbf, 0x42, 0x3c, 0x6a, 0x29, 0x30, 0x8f, 0x6d, 0x1f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Bool(this->mTranspose);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        bool mTranspose;
        F32__P mValues;
    };

    class GlUniformMatrix3fv: public Encodable {
    public:
        GlUniformMatrix3fv(atom::Observations observations, UniformLocation Location, int32_t Count, bool Transpose, F32__P Values) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mTranspose(Transpose),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xfb, 0x5f, 0x49, 0x7f, 0xef, 0x17, 0xfd, 0x81, 0xea, 0x06, 0x70, 0x21, 0x6d, 0xcc, 0x87, 0x33, 0x58, 0xf7, 0x95, 0x94,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Bool(this->mTranspose);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        bool mTranspose;
        F32__P mValues;
    };

    class GlUniformMatrix4fv: public Encodable {
    public:
        GlUniformMatrix4fv(atom::Observations observations, UniformLocation Location, int32_t Count, bool Transpose, F32__P Values) :
            mobservations(observations),
            mLocation(Location),
            mCount(Count),
            mTranspose(Transpose),
            mValues(Values) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x52, 0x0f, 0x12, 0x1c, 0xe8, 0x4b, 0x78, 0xfd, 0xd9, 0x60, 0x03, 0x9b, 0xb8, 0x66, 0x8e, 0x83, 0x74, 0x7f, 0x9d, 0xae,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mLocation);
            e->Int32(this->mCount);
            e->Bool(this->mTranspose);
            e->Value(&this->mValues);
        }

        atom::Observations mobservations;
        UniformLocation mLocation;
        int32_t mCount;
        bool mTranspose;
        F32__P mValues;
    };

    class GlUnmapBuffer: public Encodable {
    public:
        GlUnmapBuffer(atom::Observations observations, BufferTarget Target) :
            mobservations(observations),
            mTarget(Target) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb8, 0x33, 0x76, 0xd5, 0x25, 0x8b, 0xf1, 0x9a, 0x95, 0x99, 0x11, 0x51, 0x68, 0x3f, 0x38, 0xaa, 0x42, 0x88, 0x74, 0xd9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mTarget);
        }

        atom::Observations mobservations;
        BufferTarget mTarget;
    };

    class GlUseProgram: public Encodable {
    public:
        GlUseProgram(atom::Observations observations, ProgramId Program) :
            mobservations(observations),
            mProgram(Program) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x4b, 0x8d, 0xa5, 0x92, 0x0f, 0xae, 0x78, 0xf9, 0xa4, 0xae, 0x29, 0x3c, 0xa1, 0x5b, 0x2c, 0xe4, 0xe2, 0xf6, 0x0b, 0x9b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
    };

    class GlValidateProgram: public Encodable {
    public:
        GlValidateProgram(atom::Observations observations, ProgramId Program) :
            mobservations(observations),
            mProgram(Program) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x51, 0xe9, 0x87, 0x35, 0x9c, 0x27, 0xef, 0x70, 0xbf, 0xce, 0x08, 0x9c, 0xe0, 0xa7, 0x47, 0xac, 0xab, 0xe5, 0xed, 0xd5,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mProgram);
        }

        atom::Observations mobservations;
        ProgramId mProgram;
    };

    class GlVertexAttrib1f: public Encodable {
    public:
        GlVertexAttrib1f(atom::Observations observations, AttributeLocation Location, float Value0) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7e, 0xf1, 0xf8, 0x90, 0x37, 0x0b, 0x9b, 0xd8, 0x33, 0xb5, 0x36, 0x74, 0x76, 0x55, 0xd1, 0xef, 0x24, 0xe8, 0x95, 0xa7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Float32(this->mValue0);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        float mValue0;
    };

    class GlVertexAttrib1fv: public Encodable {
    public:
        GlVertexAttrib1fv(atom::Observations observations, AttributeLocation Location, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x84, 0xd2, 0x43, 0x86, 0x82, 0x14, 0x9f, 0xe9, 0x5a, 0xa6, 0xa8, 0x55, 0x84, 0xb4, 0xde, 0x41, 0xcc, 0xbc, 0x4a, 0xa2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        F32__P mValue;
    };

    class GlVertexAttrib2f: public Encodable {
    public:
        GlVertexAttrib2f(atom::Observations observations, AttributeLocation Location, float Value0, float Value1) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x75, 0xa4, 0x82, 0xbe, 0xe7, 0x8c, 0xce, 0xe5, 0xe7, 0x0c, 0xc8, 0x23, 0xf3, 0xbf, 0xd5, 0xf9, 0x67, 0x99, 0x3c, 0x77,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        float mValue0;
        float mValue1;
    };

    class GlVertexAttrib2fv: public Encodable {
    public:
        GlVertexAttrib2fv(atom::Observations observations, AttributeLocation Location, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xcf, 0xa0, 0xde, 0x2f, 0x88, 0xf3, 0xad, 0xa8, 0x05, 0xd9, 0x1a, 0x0d, 0xc6, 0x72, 0xc8, 0xb0, 0xfe, 0x36, 0xb2, 0x69,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        F32__P mValue;
    };

    class GlVertexAttrib3f: public Encodable {
    public:
        GlVertexAttrib3f(atom::Observations observations, AttributeLocation Location, float Value0, float Value1, float Value2) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x32, 0x55, 0xd8, 0x5b, 0x39, 0xba, 0x65, 0xb7, 0x45, 0x9d, 0xa9, 0x8a, 0x4c, 0x0c, 0x4f, 0x51, 0xa6, 0xd8, 0x0c, 0xbc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
            e->Float32(this->mValue2);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        float mValue0;
        float mValue1;
        float mValue2;
    };

    class GlVertexAttrib3fv: public Encodable {
    public:
        GlVertexAttrib3fv(atom::Observations observations, AttributeLocation Location, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x75, 0x81, 0x16, 0xb1, 0xbb, 0x41, 0x12, 0x99, 0x23, 0x1b, 0x74, 0x5c, 0x74, 0xf7, 0x9d, 0xc7, 0x59, 0x7e, 0x58, 0x1a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        F32__P mValue;
    };

    class GlVertexAttrib4f: public Encodable {
    public:
        GlVertexAttrib4f(atom::Observations observations, AttributeLocation Location, float Value0, float Value1, float Value2, float Value3) :
            mobservations(observations),
            mLocation(Location),
            mValue0(Value0),
            mValue1(Value1),
            mValue2(Value2),
            mValue3(Value3) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x26, 0x2d, 0x3c, 0xc8, 0x49, 0x62, 0xf6, 0x27, 0x48, 0xe9, 0x61, 0x1d, 0xcd, 0x09, 0xbd, 0x81, 0x3a, 0xdf, 0x39, 0x76,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Float32(this->mValue0);
            e->Float32(this->mValue1);
            e->Float32(this->mValue2);
            e->Float32(this->mValue3);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        float mValue0;
        float mValue1;
        float mValue2;
        float mValue3;
    };

    class GlVertexAttrib4fv: public Encodable {
    public:
        GlVertexAttrib4fv(atom::Observations observations, AttributeLocation Location, F32__P Value) :
            mobservations(observations),
            mLocation(Location),
            mValue(Value) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xef, 0xb2, 0x40, 0xe1, 0xb9, 0xd1, 0x42, 0x98, 0x84, 0x6f, 0xa0, 0xeb, 0x0f, 0x22, 0x31, 0x6c, 0x79, 0xb5, 0x22, 0xc9,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Value(&this->mValue);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        F32__P mValue;
    };

    class GlVertexAttribPointer: public Encodable {
    public:
        GlVertexAttribPointer(atom::Observations observations, AttributeLocation Location, int32_t Size, VertexAttribType Type, bool Normalized, int32_t Stride, VertexPointer Data) :
            mobservations(observations),
            mLocation(Location),
            mSize(Size),
            mType(Type),
            mNormalized(Normalized),
            mStride(Stride),
            mData(Data) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x9d, 0xd0, 0xda, 0x47, 0xd9, 0x9e, 0x24, 0x1d, 0x75, 0x48, 0x0f, 0x8d, 0x27, 0x76, 0x63, 0x2d, 0x79, 0x41, 0xb8, 0xca,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mLocation);
            e->Int32(this->mSize);
            e->Uint32(this->mType);
            e->Bool(this->mNormalized);
            e->Int32(this->mStride);
            e->Value(&this->mData);
        }

        atom::Observations mobservations;
        AttributeLocation mLocation;
        int32_t mSize;
        VertexAttribType mType;
        bool mNormalized;
        int32_t mStride;
        VertexPointer mData;
    };

    class GlViewport: public Encodable {
    public:
        GlViewport(atom::Observations observations, int32_t X, int32_t Y, int32_t Width, int32_t Height) :
            mobservations(observations),
            mX(X),
            mY(Y),
            mWidth(Width),
            mHeight(Height) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x96, 0x41, 0xef, 0xd3, 0x17, 0x6b, 0x50, 0x3c, 0xeb, 0x46, 0x86, 0x49, 0x1c, 0x1b, 0xec, 0x65, 0xe1, 0xe0, 0xa7, 0xcb,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Int32(this->mX);
            e->Int32(this->mY);
            e->Int32(this->mWidth);
            e->Int32(this->mHeight);
        }

        atom::Observations mobservations;
        int32_t mX;
        int32_t mY;
        int32_t mWidth;
        int32_t mHeight;
    };

    class GlXCreateContext: public Encodable {
    public:
        GlXCreateContext(atom::Observations observations, Void__P Dpy, Void__P Vis, GLXContext ShareList, bool Direct, GLXContext Result) :
            mobservations(observations),
            mDpy(Dpy),
            mVis(Vis),
            mShareList(ShareList),
            mDirect(Direct),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x69, 0xd6, 0x87, 0x67, 0x9c, 0x50, 0x4f, 0xe6, 0x49, 0x6b, 0x1a, 0x51, 0x2f, 0xd7, 0x22, 0x72, 0x8e, 0x01, 0xda, 0x6e,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDpy);
            e->Value(&this->mVis);
            e->Value(&this->mShareList);
            e->Bool(this->mDirect);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        Void__P mDpy;
        Void__P mVis;
        GLXContext mShareList;
        bool mDirect;
        GLXContext mResult;
    };

    class GlXCreateNewContext: public Encodable {
    public:
        GlXCreateNewContext(atom::Observations observations, Void__P Display, Void__P Fbconfig, uint32_t Type, GLXContext Shared, bool Direct, GLXContext Result) :
            mobservations(observations),
            mDisplay(Display),
            mFbconfig(Fbconfig),
            mType(Type),
            mShared(Shared),
            mDirect(Direct),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x84, 0x7e, 0x5e, 0x97, 0x8c, 0x27, 0x99, 0x7b, 0x5e, 0xd5, 0x5f, 0xc8, 0xd5, 0xc1, 0x5e, 0x0c, 0x90, 0x64, 0xf7, 0x43,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mFbconfig);
            e->Uint32(this->mType);
            e->Value(&this->mShared);
            e->Bool(this->mDirect);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        Void__P mDisplay;
        Void__P mFbconfig;
        uint32_t mType;
        GLXContext mShared;
        bool mDirect;
        GLXContext mResult;
    };

    class GlXMakeContextCurrent: public Encodable {
    public:
        GlXMakeContextCurrent(atom::Observations observations, Void__P Display, GLXDrawable Draw, GLXDrawable Read, GLXContext Ctx) :
            mobservations(observations),
            mDisplay(Display),
            mDraw(Draw),
            mRead(Read),
            mCtx(Ctx) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x78, 0x1c, 0x13, 0x6d, 0x45, 0x65, 0x07, 0xf2, 0x7d, 0xa0, 0x15, 0xa1, 0x59, 0x22, 0x6d, 0xbe, 0xbd, 0x15, 0xb8, 0x90,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mDraw);
            e->Value(&this->mRead);
            e->Value(&this->mCtx);
        }

        atom::Observations mobservations;
        Void__P mDisplay;
        GLXDrawable mDraw;
        GLXDrawable mRead;
        GLXContext mCtx;
    };

    class GlXSwapBuffers: public Encodable {
    public:
        GlXSwapBuffers(atom::Observations observations, Void__P Display, GLXDrawable Drawable) :
            mobservations(observations),
            mDisplay(Display),
            mDrawable(Drawable) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6f, 0x6a, 0xec, 0x59, 0x43, 0x85, 0x4a, 0xf5, 0x61, 0xc7, 0xb1, 0x28, 0x6c, 0x34, 0xa5, 0xb8, 0xbd, 0x25, 0x12, 0xc2,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mDisplay);
            e->Value(&this->mDrawable);
        }

        atom::Observations mobservations;
        Void__P mDisplay;
        GLXDrawable mDrawable;
    };

    class HGLRC: public Encodable {
    public:
        HGLRC(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x95, 0xfc, 0xcf, 0x7f, 0x79, 0x35, 0x44, 0x38, 0xd4, 0x4f, 0x6d, 0xad, 0xae, 0xcd, 0xf0, 0xa5, 0x4d, 0x49, 0x48, 0xc7,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class Globals: public Encodable {
    public:
        Globals(ContextID NextContextID, ThreadID CurrentThread, std::unordered_map<ThreadID,Context*>* Contexts, std::unordered_map<EGLContext,Context*>* EGLContexts, std::unordered_map<GLXContext,Context*>* GLXContexts, std::unordered_map<HGLRC,Context*>* WGLContexts, std::unordered_map<CGLContextObj,Context*>* CGLContexts) :
            mNextContextID(NextContextID),
            mCurrentThread(CurrentThread),
            mContexts(Contexts),
            mEGLContexts(EGLContexts),
            mGLXContexts(GLXContexts),
            mWGLContexts(WGLContexts),
            mCGLContexts(CGLContexts) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x6b, 0xd7, 0xb2, 0xf9, 0x46, 0xfa, 0xb5, 0xa7, 0x8e, 0x26, 0xe5, 0x72, 0xe7, 0x8f, 0x33, 0x91, 0xb4, 0xb9, 0x49, 0x0c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint32(this->mNextContextID);
            e->Uint32(this->mCurrentThread);
            
            
            
            
            
        }

        ContextID mNextContextID;
        ThreadID mCurrentThread;
        std::unordered_map<ThreadID,Context*>* mContexts;
        std::unordered_map<EGLContext,Context*>* mEGLContexts;
        std::unordered_map<GLXContext,Context*>* mGLXContexts;
        std::unordered_map<HGLRC,Context*>* mWGLContexts;
        std::unordered_map<CGLContextObj,Context*>* mCGLContexts;
    };

    class HDC: public Encodable {
    public:
        HDC(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x77, 0x14, 0x36, 0x4d, 0x67, 0xdb, 0x2d, 0xd0, 0xcc, 0x8e, 0x01, 0x72, 0xfa, 0x85, 0x42, 0x9c, 0x04, 0x31, 0x53, 0xcc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class Int__S: public Encodable {
    public:
        Int__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xef, 0x04, 0x53, 0x99, 0xc8, 0x30, 0x5d, 0x73, 0xa3, 0x8e, 0xa4, 0x73, 0xdc, 0x4d, 0x29, 0x31, 0x52, 0x04, 0x83, 0x2a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Int__P: public Encodable {
    public:
        Int__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x90, 0xa6, 0xad, 0x4c, 0xf7, 0x0c, 0x42, 0xb6, 0xb7, 0x7f, 0xa8, 0xf0, 0xf6, 0xf9, 0xa4, 0x22, 0xd0, 0x36, 0x92, 0x46,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class QueryId__S: public Encodable {
    public:
        QueryId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xbf, 0x4b, 0xf7, 0x28, 0xcd, 0x2c, 0xea, 0x7a, 0xa3, 0x91, 0xa4, 0x2e, 0xa1, 0x6d, 0x0e, 0x39, 0x8c, 0x8b, 0x87, 0x70,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class RenderbufferId__S: public Encodable {
    public:
        RenderbufferId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x80, 0xaa, 0x20, 0xce, 0x31, 0x49, 0xb2, 0x53, 0x4b, 0x75, 0x77, 0xa5, 0x80, 0x4b, 0x7a, 0x89, 0x19, 0xf1, 0xe0, 0xdf,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class ReplayBindRenderer: public Encodable {
    public:
        ReplayBindRenderer(atom::Observations observations, uint32_t Id) :
            mobservations(observations),
            mId(Id) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xdb, 0xb2, 0x76, 0x5b, 0xa5, 0x3d, 0xb0, 0xef, 0x04, 0x2a, 0x03, 0xf1, 0x57, 0x07, 0x5a, 0x92, 0x20, 0xa9, 0x0a, 0x8a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mId);
        }

        atom::Observations mobservations;
        uint32_t mId;
    };

    class ReplayCreateRenderer: public Encodable {
    public:
        ReplayCreateRenderer(atom::Observations observations, uint32_t Id) :
            mobservations(observations),
            mId(Id) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xd5, 0x5d, 0xca, 0x28, 0xdc, 0x88, 0xac, 0x79, 0x3a, 0x31, 0xd4, 0xe3, 0x68, 0x68, 0xb9, 0x7a, 0xac, 0x48, 0x7e, 0x52,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint32(this->mId);
        }

        atom::Observations mobservations;
        uint32_t mId;
    };

    class S32__S: public Encodable {
    public:
        S32__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xc5, 0xc7, 0x25, 0x85, 0xea, 0xb4, 0x11, 0x92, 0x58, 0x43, 0x47, 0xab, 0x19, 0xaa, 0x6e, 0xf4, 0x9b, 0x9c, 0x28, 0x5f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class S64__S: public Encodable {
    public:
        S64__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x05, 0x83, 0x2e, 0xcd, 0x87, 0x87, 0xe8, 0x61, 0x58, 0xf3, 0x93, 0x39, 0xcd, 0xfb, 0x4f, 0xc3, 0xa9, 0xcb, 0xb0, 0x25,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class ShaderAttribType__S: public Encodable {
    public:
        ShaderAttribType__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x49, 0x5c, 0x8a, 0x45, 0x57, 0x49, 0x11, 0x26, 0xe8, 0x13, 0xa3, 0x03, 0xa9, 0xea, 0xc6, 0x93, 0x5a, 0x50, 0x57, 0xf0,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class ShaderId__S: public Encodable {
    public:
        ShaderId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xb8, 0xc6, 0x02, 0x67, 0xe5, 0x56, 0x31, 0x1d, 0x4e, 0x91, 0x3e, 0x62, 0x71, 0x66, 0x96, 0x5c, 0x3a, 0xd9, 0x45, 0x17,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class ShaderUniformType__S: public Encodable {
    public:
        ShaderUniformType__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x28, 0xa8, 0x7d, 0x72, 0x60, 0xb9, 0xc2, 0xbb, 0x57, 0xcb, 0x18, 0x75, 0x20, 0xdf, 0x05, 0x4e, 0x06, 0x46, 0x75, 0x69,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class StartTimer: public Encodable {
    public:
        StartTimer(atom::Observations observations, uint8_t Index) :
            mobservations(observations),
            mIndex(Index) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x23, 0x7b, 0x88, 0x65, 0x96, 0xf3, 0x0d, 0x5d, 0x50, 0x56, 0xad, 0x18, 0xc8, 0x0a, 0xe8, 0x57, 0xa0, 0x21, 0x1c, 0x9b,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint8(this->mIndex);
        }

        atom::Observations mobservations;
        uint8_t mIndex;
    };

    class StopTimer: public Encodable {
    public:
        StopTimer(atom::Observations observations, uint8_t Index, uint64_t Result) :
            mobservations(observations),
            mIndex(Index),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xe8, 0x9f, 0x7c, 0xb1, 0xa4, 0xf8, 0x37, 0x81, 0x6b, 0x01, 0x71, 0x0e, 0xbc, 0xf2, 0x92, 0xd2, 0x39, 0x2e, 0xca, 0x5f,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Uint8(this->mIndex);
            e->Uint64(this->mResult);
        }

        atom::Observations mobservations;
        uint8_t mIndex;
        uint64_t mResult;
    };

    class TextureId__S: public Encodable {
    public:
        TextureId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x7c, 0x74, 0x2d, 0x21, 0x88, 0x88, 0xbd, 0x80, 0x99, 0xd2, 0x8a, 0x4c, 0x47, 0x2a, 0x0c, 0xed, 0xa5, 0x43, 0x6f, 0x60,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class U32__S: public Encodable {
    public:
        U32__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x47, 0x8d, 0xb4, 0x2f, 0x7e, 0xde, 0x24, 0x93, 0x35, 0xb1, 0xfd, 0xda, 0x67, 0x36, 0xc5, 0x33, 0xcb, 0x3a, 0xbd, 0x6c,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class U64__S: public Encodable {
    public:
        U64__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x03, 0x30, 0x8e, 0xf7, 0x85, 0xac, 0x98, 0x5d, 0x6d, 0xcc, 0xee, 0x49, 0x76, 0x98, 0xdb, 0xbf, 0x9d, 0xd7, 0xed, 0x45,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class U8__P: public Encodable {
    public:
        U8__P(memory::Pointer Address, memory::PoolID Pool) :
            mAddress(Address),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xf6, 0x6e, 0x22, 0xf8, 0x33, 0x69, 0x05, 0xe9, 0x8b, 0xdf, 0xfa, 0x53, 0x75, 0xae, 0x80, 0xcc, 0x2c, 0x27, 0x98, 0x17,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mAddress);
            e->Uint32(this->mPool);
        }

        memory::Pointer mAddress;
        memory::PoolID mPool;
    };

    class VertexArrayId__S: public Encodable {
    public:
        VertexArrayId__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x0c, 0x8b, 0x70, 0x73, 0x00, 0xb5, 0x36, 0x14, 0x66, 0x06, 0x94, 0xa5, 0x4e, 0xaa, 0x01, 0xaf, 0x98, 0x36, 0xd3, 0x12,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class Void__S: public Encodable {
    public:
        Void__S(memory::Pointer Root, memory::Pointer Base, uint64_t Count, memory::PoolID Pool) :
            mRoot(Root),
            mBase(Base),
            mCount(Count),
            mPool(Pool) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x95, 0x61, 0x52, 0x69, 0x11, 0x55, 0xc2, 0xab, 0x85, 0x8f, 0xce, 0x86, 0x29, 0xd6, 0xbc, 0x17, 0xc5, 0x7a, 0xfe, 0xc6,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Uint64(this->mRoot);
            e->Uint64(this->mBase);
            e->Uint64(this->mCount);
            e->Uint32(this->mPool);
        }

        memory::Pointer mRoot;
        memory::Pointer mBase;
        uint64_t mCount;
        memory::PoolID mPool;
    };

    class WglCreateContext: public Encodable {
    public:
        WglCreateContext(atom::Observations observations, HDC Hdc, HGLRC Result) :
            mobservations(observations),
            mHdc(Hdc),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x8e, 0xe0, 0x9b, 0x8b, 0x3d, 0x3c, 0xc7, 0x22, 0x61, 0xb4, 0xee, 0xa9, 0x75, 0x75, 0xd6, 0x53, 0x0d, 0x31, 0x15, 0xcc,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mHdc);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        HDC mHdc;
        HGLRC mResult;
    };

    class WglCreateContextAttribsARB: public Encodable {
    public:
        WglCreateContextAttribsARB(atom::Observations observations, HDC Hdc, HGLRC HShareContext, Int__P AttribList, HGLRC Result) :
            mobservations(observations),
            mHdc(Hdc),
            mHShareContext(HShareContext),
            mAttribList(AttribList),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x28, 0x15, 0x85, 0xa3, 0xab, 0x16, 0x84, 0xed, 0xe0, 0xe6, 0xec, 0x92, 0xe8, 0x14, 0x8e, 0xbe, 0x5f, 0x32, 0x72, 0x42,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mHdc);
            e->Value(&this->mHShareContext);
            e->Value(&this->mAttribList);
            e->Value(&this->mResult);
        }

        atom::Observations mobservations;
        HDC mHdc;
        HGLRC mHShareContext;
        Int__P mAttribList;
        HGLRC mResult;
    };

    class WglMakeCurrent: public Encodable {
    public:
        WglMakeCurrent(atom::Observations observations, HDC Hdc, HGLRC Hglrc, BOOL Result) :
            mobservations(observations),
            mHdc(Hdc),
            mHglrc(Hglrc),
            mResult(Result) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0x86, 0xd3, 0x02, 0xb5, 0xf6, 0x1b, 0x7f, 0x3e, 0xb1, 0x23, 0x36, 0x2b, 0x9d, 0xa2, 0x13, 0xa6, 0xf6, 0xbc, 0xb3, 0x8a,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mHdc);
            e->Value(&this->mHglrc);
            e->Int64(this->mResult);
        }

        atom::Observations mobservations;
        HDC mHdc;
        HGLRC mHglrc;
        BOOL mResult;
    };

    class WglSwapBuffers: public Encodable {
    public:
        WglSwapBuffers(atom::Observations observations, HDC Hdc) :
            mobservations(observations),
            mHdc(Hdc) {}
        virtual const gapic::Id& Id() const {
            static gapic::Id ID{ { 0xa1, 0x23, 0xcd, 0xfc, 0xb1, 0x9b, 0xcf, 0x24, 0x77, 0xab, 0x3b, 0xb0, 0x75, 0x58, 0x9b, 0x35, 0x54, 0x11, 0x3f, 0xc8,  } };
            return ID;
        }
        virtual void Encode(Encoder* e) const {
            e->Value(&this->mobservations);
            e->Value(&this->mHdc);
        }

        atom::Observations mobservations;
        HDC mHdc;
    };



} // namespace gles
} // namespace coder
} // namespace gapic
